PYTHIA Stand-Alone Examples
===========================
main60: standard declarations and commonblocks, for easy copying 
main61: the very most trivial test of PYTHIA 
main62: run all existing subprocesses one at a time 
main63: Z0 production at LEP 1  
main65: supersymmetry production at a hadron collider (see below for
	SLHA example)  
main67: technicolor production at the Tevatron 
main79: charged multiplicity in top events at the LHC 
main68: heavy Higgs mass spectrum comparing two running-width schemes 
main71: production of a single top by s-channel W exchange (with tricks) 
main64: study of W mass shift by colour rearrangement at LEP 2 
main66: leptoquark production at HERA 
main69: jet or minimum bias production by gamma*-p or gamma*-gamma*
	interactions

PYTHIA Interfaced to External Programs and Add-ons
==================================================
main81: LHEF: read-in of parton-level events in the Les Houches Event
	File (LHEF) format for further processing by Pythia. Needs the
	example file ttbar.lhe. For more information on this standard, see
	hep-ph/0609017. For information on combining it with SLHA/BSM
	spectra, see hep-ph/0712.3311. 
main70: implementation of user-defined external processes according to
	the Les Houches standard  
main72: comparison of cross sections for q g -> q gamma as external or
	internal process 
main73: program for e+e- with routines to turn gluinos into stable
	gluino-hadrons, optionally via stop-hadrons
main74: and  a modified version with unstable gluino-hadrons in hadron
	colliders 
main77: and  ditto, using "PDG-endorsed" codes for R-hadrons 
main78: and  production of stable stop-hadrons, also using
	"PDG-endorsed" codes
main76: SLHA: example how to use input via the SuSy Les Houches Accord
	(SLHA) to generate supersymmetric processes, in this case stop1 pair
	production events at LHC; the run requires an external file with a
	SuSy spectrum calculated by an external RGE code, like softsusy.spc
	generated by SoftSusy
main80: example how to use the interface to FeynHiggs

C...Program to turn gluinos into gluino-hadrons, assuming
C...the gluino is the stable LSP. Furthermore, optionally, 
C...stop is assumed long-lived, so that intermediate 
C...stop-hadrons are formed.

C******************************************************************

C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Process names.
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
C...Local arrays.
      DIMENSION EPQSUM(6)

C...Number of events, CM energy.
      NEV=10000
      ECM=200D0

C...Pick stop and gluino masses.
      PMST=80D0
      PMGL=50D0

C...Decide whether to form stop hadrons (1) or not (0).
      MSTOPH=1

C...Pick process.
      MSEL=0
      MSUB(261)=1

C...Set necessary SUSY parameters (brute force).
      IMSS(1)=1
C...Gluino mass - of "constituent" mass kind.
      IMSS(3)=1
      RMSS(3)=PMGL
C...Force gluino mass = lightest neutralino (almost).
      RMSS(1)=PMGL
      RMSS(2)=PMGL
      RMSS(4)=1D4
C...Stop_1 mass.
      IMSS(5)=1
      RMSS(12)=PMST

C...Convenient shorthand.
      KFST=KSUSY1+6
      KCST=PYCOMP(KFST)
      KFGL=KSUSY1+21

C...Only allow decay channel for stop -> neutralino_1 + c. All else off.
      DO 100 IDC=MDCY(KCST,2),MDCY(KCST,2)+MDCY(KCST,3)-1
        IF(KFDP(IDC,1).EQ.KFGL+1.AND.KFDP(IDC,2).EQ.4) THEN
        ELSE
          MDME(IDC,1)=MIN(0,MDME(IDC,1))
        ENDIF
  100 CONTINUE

C...Initialize.
      CALL PYINIT('CMS','e+','e-',ECM)

C...Now overwrite neutralino in decay channel above with gluino.
C...Thereby we artificially create stop -> gluino + c channel.
      DO 110 IDC=MDCY(KCST,2),MDCY(KCST,2)+MDCY(KCST,3)-1
        IF(KFDP(IDC,1).EQ.KFGL+1.AND.KFDP(IDC,2).EQ.4) THEN
          KFDP(IDC,1)=KFGL 
        ELSE
        ENDIF
  110 CONTINUE

C...Put gluino stable.
      MDCY(PYCOMP(KFGL),1)=0
  
C...Show particle data.
c      CALL PYSTAT(2)
C      CALL PYLIST(12)

C...Switch off hadronization in normal PYEVNT call.
      MSTP(111)=0 

C...Histograms.
      CALL PYBOOK(1,'E-P-Q conservation check',100,0D0,0.0001D0)
      CALL PYBOOK(2,'energy in ISR photons',100,0D0,ECM-2D0*PMST)
      CALL PYBOOK(3,'charged hadron multiplicity (excl. R hadrons)',
     &50,-0.5D0,49.5D0)
      CALL PYBOOK(11,'stop squark momentum spectrum',100,0D0,100D0)
      CALL PYBOOK(12,'stop hadron momentum spectrum',100,0D0,100D0)
      CALL PYBOOK(13,'stop hadron mass spectrum, central',
     &100,PMST,PMST+2D0)
      CALL PYBOOK(14,'stop hadron mass spectrum, off central',
     &100,0D0,100D0)
      CALL PYBOOK(21,'gluino parton momentum spectrum',100,0D0,100D0)
      CALL PYBOOK(22,'gluino hadron momentum spectrum',100,0D0,100D0)
      CALL PYBOOK(23,'Gluino-hadron mass spectrum, central',
     &100,PMGL,PMGL+2D0)
      CALL PYBOOK(24,'Gluino-hadron mass spectrum, off central',
     &100,0D0,100D0)
 
C...Event generation loop.
      DO 200 IEV=1,NEV
      if(mod(iev,100).eq.0) write(*,*) 'begin event no', iev

C...Put stop stable.
        IF(MSTOPH.EQ.1) MDCY(KCST,1)=0

C...Generate event, but without worrying about small string systems.
        MSTJ(14)=-1
        CALL PYEVNT
        MSTJ(14)=1
        DO 140 J=1,6
          EPQSUM(J)=PYP(0,J)
 140    CONTINUE

C...Restore stop decay capability.
        IF(MSTOPH.EQ.1) MDCY(KCST,1)=1

C...Now perform treatment of stop hadronization and decay.
        IF(MSTOPH.EQ.1) CALL PYSTFR

C...Now perform treatment of gluino hadronization.
        CALL PYGLFR

C...List first few events.
        IF(IEV.LE.2) CALL PYLIST(2)

C...Statistics: generic.
        NMERR=0
        EPQ=ABS(PYP(0,4)-EPQSUM(4))+ABS(PYP(0,1)-EPQSUM(1))+
     &  ABS(PYP(0,2)-EPQSUM(2))+ABS(PYP(0,3)-EPQSUM(3))+
     &  ABS(PYP(0,6)-EPQSUM(6))
        IF(EPQ.GT.1D-4) CALL PYFILL(1,EPQ,1D0)
        IF(EPQ.GT.1D-4) NMERR=NMERR+1
        EGAMM=0D0
        NCH=0
        DO 160 I=1,N
          DM2=P(I,4)**2-P(I,1)**2-P(I,2)**2-P(I,3)**2-P(I,5)**2
          IF(DM2.GT.1D-8) THEN
             WRITE(*,*) 'problem',I,DM2
            IF(DM2.GT.1D-4) NMERR=NMERR+1
          ENDIF
          IF(K(I,1).EQ.1) THEN
            IF(K(I,2).EQ.22.AND.K(I,3).LE.4) EGAMM=EGAMM+P(I,4)
            IF(PYCHGE(K(I,2)).NE.0) NCH=NCH+1
          ENDIF      
          PABS=SQRT(P(I,1)**2+P(I,2)**2+P(I,3)**2)  
C...Statistics: stop.         
          IF((K(I,1).EQ.11.OR.K(I,1).EQ.12).AND.IABS(K(I,2)).EQ.KFST) 
     &    THEN
            CALL PYFILL(11,PABS,1D0)
          ENDIF
          IF(K(I,1).EQ.13.AND.IABS(K(I,2)).EQ.KFST) THEN
            CALL PYFILL(12,PABS,1D0)
            IF(K(I,2).GT.0) THEN
              IOTHER=MOD(K(I,4)/MSTU(5),MSTU(5))
            ELSE
              IOTHER=MOD(K(I,5)/MSTU(5),MSTU(5))
            ENDIF
            PMSTHD=P(I,5)+P(IOTHER,5)
            IF(PMSTHD.LT.PMST.OR.PMSTHD.GT.PMST+2D0) THEN
              CALL PYFILL(14,PMSTHD,1D0)
            ELSE
              CALL PYFILL(13,PMSTHD,1D0)
            ENDIF
          ENDIF
C...Statistics: gluino.
          IF(K(I,1).EQ.12.AND.K(I,2).EQ.KFGL) THEN
            CALL PYFILL(21,PABS,1D0)
          ENDIF
          IF((K(I,1).EQ.6.OR.K(I,1).EQ.7).AND.K(I,2).EQ.KFGL) THEN
            CALL PYFILL(22,PABS,1D0)
            IF(P(I,5).LT.PMGL.OR.P(I,5).GT.PMGL+2D0) THEN
              CALL PYFILL(24,P(I,5),1D0)
            ELSE
              CALL PYFILL(23,P(I,5),1D0)
            ENDIF
          ENDIF
 160    CONTINUE
        CALL PYFILL(2,EGAMM,1D0)
        CALL PYFILL(3,DBLE(NCH),1D0)
        IF(NMERR.GT.0) CALL PYLIST(2)

C...End of event generation loop.
 200  CONTINUE

C...Cross section - not relevant in this case. Histograms.
      CALL PYSTAT(1)      
      CALL PYHIST

      END
 
C*********************************************************************
 
C...PYSTFR
C...Fragments the string near to a stop, to form a stop-hadron, 
C...by producing a new q-qbar pair.
 
      SUBROUTINE PYSTFR
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/
C...Local array.
      DIMENSION PSUM(5),PSAV(5),IJOIN(2),IPOSST(10) 
 
C...Free parameter: max kinetic energy in gluino-hadron.
      PMKIN=0.5D0
 
C...Free parameter: part of stop mass that does not participate
C...in weak decay.
      PMINAC=0.5D0

C...Switch off popcorn baryon production. (Not imperative, but more
C...failed events when popcorn is allowed.)
      MSTJ12=MSTJ(12)
      MSTJ(12)=1

C...Convenient shorthand.
      KFST=KSUSY1+6
      KCST=PYCOMP(KFST)
      KFGL=KSUSY1+21

C...Loopback point for serious problems, with new try.
      LOOP=0
      CALL PYEDIT(21)
      CHGSAV=PYP(0,6)
   90 LOOP=LOOP+1
      IF(LOOP.GT.1) CALL PYEDIT(22)

C...Take copy of string system(s).
      NOLD=N
      NSTOP=0
      DO 120 I=1,NOLD
        ICOPY=0
        IF(K(I,1).EQ.2) ICOPY=1
        IF(K(I,1).EQ.1.AND.I.GE.2) THEN
          IF(K(I-1,1).EQ.12) ICOPY=1
        ENDIF
        IF(ICOPY.EQ.1) THEN  
          N=N+1
          DO 100 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  100     CONTINUE
          K(I,1)=K(I,1)+10
          K(I,4)=N
          K(I,5)=N
          K(N,3)=I
          IF(IABS(K(I,2)).EQ.KFST) THEN
            NSTOP=NSTOP+1
            IPOSST(NSTOP)=N
          ENDIF   
        ENDIF
  120 CONTINUE
      NTMP=N

C...Loop over (up to) two stops per event.
C...Identify position of stop (randomize order of treatment).
      IRNST=INT(1.5D0+PYR(0))
      DO 300 ISTOP=1,NSTOP
        IST=IPOSST(1)
        IF(NSTOP.EQ.2.AND.ISTOP.NE.IRNST) IST=IPOSST(2)

C...Identify range of partons on string the stop belongs to. 
        IMIN=IST+1
  140   IMIN=IMIN-1
        IF(K(IMIN-1,1).EQ.2) GOTO 140
        IMAX=IST-1
  150   IMAX=IMAX+1
        IF(K(IMAX,1).EQ.2) GOTO 150
        IOTHER=IMAX
        IF(IST.EQ.IMAX) IOTHER=IMIN  
 
C...Find mass of this stop-string. 
        DO 170 J=1,5
          PSUM(J)=0D0
          DO 160 I=IMIN,IMAX
            PSUM(J)=PSUM(J)+P(I,J)
  160     CONTINUE
  170   CONTINUE
        PSUM(5)=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &  PSUM(3)**2))
 
C...If low-mass, then consider stop-hadron already formed.
        IF(PSUM(5).LE.P(IST,5)+P(IOTHER,5)+PMKIN) THEN
          DO 180 I=IMIN,IMAX
            K(I,1)=2
            IF(I.EQ.IMAX) K(I,1)=1
            IF(I.NE.IST) THEN
              DO 175 J=1,5
                P(IST,J)=P(IST,J)+P(I,J)
                P(I,J)=0D0
  175         CONTINUE
            ENDIF
  180     CONTINUE
          P(IST,5)=SQRT(MAX(0D0,P(IST,4)**2-P(IST,1)**2-P(IST,2)**2-
     &    P(IST,3)**2))
          GOTO 300
        ENDIF    

C...Else break string by production of new qqbar pair.
C...(Also diquarks allowed, but not popcorn.)
        INFLAV=ISIGN(4,K(IST,2))
        CALL PYDCYK(INFLAV,0,KFSAV,KFDUM)
        KFSAV=ISIGN(MOD(IABS(KFSAV),10000),KFSAV)
        MSTJ(93)=1 
        PMSAV=PYMASS(KFSAV)         

C...Mass of stop-hadron.
        PMSSAV=P(IST,5)
        PMSHAD=P(IST,5)+PMSAV

C...Pick momentum sharing according to fragmentation function as if bottom.
        PMBSAV=PARF(105)
        PARF(105)=PMSSAV
        CALL PYZDIS(5,0,PMSHAD**2,ZST)
        PARF(105)=PMBSAV 
        ZST=MAX(0.9D0,MIN(0.9999D0,ZST)) 
        DO 190 J=1,5
          PSAV(J)=(1D0-ZST)*P(IST,J)
          P(IST,J)=ZST*P(IST,J)
  190  CONTINUE

C...Recoiling parton from which to shuffle momentum. System momentum.
          IF(IST.EQ.IMIN) IREC=IST+1
          IF(IST.EQ.IMAX) IREC=IST-1
  200     DO 210 J=1,4
            PSUM(J)=P(IST,J)+P(IREC,J)
  210     CONTINUE           

C...Boost to rest frame of system, and align stop along +z axis.
          CALL PYROBO(IST,IST,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          PHI=PYANGL(P(IST,1),P(IST,2))
          CALL PYROBO(IST,IST,0D0,-PHI,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,0D0,-PHI,0D0,0D0,0D0)
          THETA=PYANGL(P(IST,3),P(IST,1)) 
          CALL PYROBO(IST,IST,-THETA,0D0,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,-THETA,0D0,0D0,0D0,0D0)

C...Calculate new kinematics in this frame, for desired stop hadron mass.
          ETOT=P(IST,4)+P(IREC,4)
          PMREC=P(IREC,5)
          IF(K(IREC,2).NE.21.AND.IABS(K(IREC,2)).NE.KFST) THEN
            MSTJ(93)=1 
            PMREC=PYMASS(K(IREC,2))         
          ENDIF 
          IF(ETOT.GT.PMSHAD+PMREC) THEN
            IFAIL=0
            PZNEW=0.5D0*SQRT(MAX(0D0,(ETOT**2-PMSHAD**2-PMREC**2)**2-
     &      4D0*PMSHAD**2*PMREC**2))/ETOT
            P(IST,3)=PZNEW
            P(IST,4)=SQRT(PZNEW**2+PMSHAD**2)
            P(IST,5)=PMSHAD
            P(IREC,3)=-PZNEW
            P(IREC,4)=SQRT(PZNEW**2+PMREC**2)
            P(IREC,5)=PMREC

C...If not enough momentum, take what can be taken.
          ELSE
            IFAIL=1
            P(IST,3)=0D0
            P(IST,4)=ETOT-PMREC
            P(IST,5)=P(IST,4)
            P(IREC,3)=0D0
            P(IREC,4)=PMREC
            P(IREC,5)=PMREC
          ENDIF

C...Bost back to lab frame.
          CALL PYROBO(IST,IST,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))

C...Loop back when not enough momentum could be shuffled.
C...(As long as there is something left.)
          IF(IFAIL.EQ.1) THEN
            IF(IST.EQ.IMIN.AND.IREC.LT.IMAX) THEN
              IREC=IREC+1
              GOTO 200
            ELSEIF(IST.EQ.IMAX.AND.IREC.GT.IMIN) THEN
              IREC=IREC-1
              GOTO 200
            ENDIF
          ENDIF

C...New slots at end of record for squark + new antiquark.
        DO 230 J=1,5
          K(N+1,J)=0
          P(N+1,J)=P(IST,J)
          V(N+1,J)=V(IST,J)
          K(N+2,J)=0
          P(N+2,J)=0D0
          V(N+2,J)=V(IST,J)
  230   CONTINUE
 
C...Status and code of these slots.
        K(N+1,1)=2
        K(N+2,1)=1
        K(N+1,2)=K(IST,2)
        K(N+2,2)=KFSAV
        K(N+1,3)=K(IST,3)
        K(N+2,3)=K(IST,3)
        N=N+2
        
C...Code and momentum of new string endpoint.
        K(IST,2)=-KFSAV
        DO 240 J=1,5
          P(IST,J)=PSAV(J)
  240   CONTINUE
 
C...End of loop over two stops.
  300 CONTINUE

C...Cleanup: remove zero-energy gluons.
      NNOW=N
      N=NOLD
      DO 330 I=NOLD+1,NNOW
        IF(K(I,2).EQ.21.AND.P(I,4).LT.1D-10) THEN
        ELSEIF(I.EQ.N+1) THEN
          N=N+1
        ELSE
          N=N+1
          DO 320 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  320     CONTINUE
        ENDIF
  330 CONTINUE
      NNOW=N

C...Check that no low-mass system of diquark-antidiquark kind,
C...or very low-mass of any kind.
      KFBEG=0
      DO 332 J=1,5
        PSUM(J)=0D0
  332 CONTINUE
      DO 338 I=NOLD+1,NNOW
        DO 334 J=1,4
          PSUM(J)=PSUM(J)+P(I,J)
  334   CONTINUE
        IF(KFBEG.EQ.0) THEN
          KFBEG=IABS(K(I,2))
          MSTJ(93)=1 
          PSUM(5)=PSUM(5)+PYMASS(K(I,2))         
        ELSEIF(K(I,1).EQ.1) THEN
          KFEND=IABS(K(I,2))
          MSTJ(93)=1 
          PSUM(5)=PSUM(5)+PYMASS(K(I,2))         
          DELTA=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &    PSUM(3)**2))-PSUM(5)
          IF(KFBEG.GT.10.AND.KFBEG.LT.10000.AND.KFEND.GT.10.AND.
     &    KFEND.LT.10000.AND.DELTA.LT.PARJ(32)) GOTO 90
          IF(DELTA.LT.0D0) GOTO 90
          KFBEG=0
          DO 336 J=1,5
            PSUM(J)=0D0
  336     CONTINUE
        ENDIF
  338 CONTINUE

C...Finished with stop hadronization. Restore baryon production model.
      MSTJ(12)=MSTJ12

C...Now hadronize small string piece. Some cheating to allow sensible
C...momentum shuffling.
      IF(N-NOLD.GT.4) THEN
        MDCY(8,1)=0
        DO 340 I=NOLD+1,N
          IF(IABS(K(I,2)).EQ.KFST) THEN
            K(I,1)=1
            K(I,2)=ISIGN(8,K(I,2))
          ELSEIF(IABS(K(I-1,2)).EQ.8) THEN
            K(I,1)=11
          ENDIF
  340   CONTINUE
        MSTJ16=MSTJ(16)
        MSTJ(16)=0
        CALL PYEXEC
        MSTJ(16)=MSTJ16
        DO 350 I=NOLD+1,NNOW
          IF(IABS(K(I,2)).EQ.8) THEN
            K(I,1)=2
            K(I,2)=ISIGN(KFST,K(I,2))
          ELSEIF(IABS(K(I-1,2)).EQ.KFST.AND.K(I-1,1).EQ.2) THEN
            K(I,1)=1
          ENDIF
  350   CONTINUE
      ENDIF

C...Split momentum inside stop-hadron.
      DO 370 I=NOLD+1,NNOW
        IF(IABS(K(I,2)).EQ.KFST) THEN
          ISPEC=I+1
          IF(K(I,1).EQ.1) ISPEC=I-1
          MSTJ(93)=1 
          PMSPEC=PYMASS(K(ISPEC,2))         
          FAC=(PMSPEC+PMINAC)/P(I,5)
          DO 360 J=1,5
            P(ISPEC,J)=FAC*P(I,J)
            P(I,J)=(1D0-FAC)*P(I,J)
  360     CONTINUE
    
C...Hook up colours and decay stop to gluino.
          IJOIN(1)=I
          IJOIN(2)=ISPEC
          CALL PYJOIN(2,IJOIN)
          CALL PYRESD(I)
        ENDIF      
  370 CONTINUE

C...Rearrange partons along string.
      MSTJ(14)=-1
      CALL PYPREP(0)
      MSTJ(14)=1
          
      RETURN
      END
 
C*********************************************************************
 
C...PYGLFR
C...Fragments the string near to a gluino, to form a gluino-hadron, 
C...either by producing a new g-g pair or two new q-qbar ones.
 
      SUBROUTINE PYGLFR
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/
C...Local array.
      DIMENSION PSUM(5),KFSAV(2),PMSAV(2),PSAV(2,5) 

C...Free parameter: relative probability for gluino-gluon-ball.
C...(But occasional low-mass string will never become it anyway.)
      PROBGG=0.1D0
 
C...Free parameter: gluon constituent mass.
      PMGLU=0.7D0
 
C...Free parameter: max kinetic energy in gluino-hadron.
      PMKIN=0.5D0

C...Switch off popcorn baryon production. (Not imperative, but more
C...failed events when popcorn is allowed.)
      MSTJ12=MSTJ(12)
      MSTJ(12)=1

C...Convenient shorthand.
      KFGL=KSUSY1+21

C...Loopback point for serious problems, with new try.
      LOOP=0
      CALL PYEDIT(21)
      CHGSAV=PYP(0,6)
   90 LOOP=LOOP+1
      IF(LOOP.GT.1) CALL PYEDIT(22)

C...Take copy of string system(s), leaving extra free slot after gluino.
C...(Eventually to be overwritten by one q and one qbar string break.)
      NOLD=N
      NGLUI=0
      DO 120 I=1,NOLD
        ICOPY=0
        IF(K(I,1).EQ.2) ICOPY=1
        IF(K(I,1).EQ.1.AND.I.GE.2) THEN
          IF(K(I-1,1).EQ.12) ICOPY=1
        ENDIF
        IF(ICOPY.EQ.1) THEN  
          N=N+1
          DO 100 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  100     CONTINUE
          K(I,1)=K(I,1)+10
          K(I,4)=N
          K(I,5)=N
          K(N,3)=I
          IF(K(I,2).EQ.KFGL) THEN
            NGLUI=NGLUI+1  
            N=N+1
            DO 110 J=1,5
              K(N,J)=K(N-1,J)
              P(N,J)=0D0
              V(N,J)=V(I,J)
  110       CONTINUE
            K(I,5)=N
            K(N,2)=21
          ENDIF
        ENDIF
  120 CONTINUE

C...Loop over (up to) two gluinos per event.
      DO 300 IGLUI=1,NGLUI

C...Identify position of gluino (randomize order of treatment).
        IGL=0
        NGL=0
        DO 130 I=1,N
          IF(K(I,1).EQ.2.AND.K(I,2).EQ.KFGL) THEN
            NGL=NGL+1
            IF(IGLUI.EQ.NGLUI) THEN
              IGL=I
            ELSEIF(NGL.EQ.1) THEN
              IF(PYR(0).LT.0.5D0) IGL=I
            ELSEIF(IGL.EQ.0) THEN
              IGL=I
            ENDIF
          ENDIF
  130   CONTINUE

C...Identify range of partons on string the gluino belongs to. 
        IMIN=IGL
  140   IMIN=IMIN-1
        IF(K(IMIN-1,1).EQ.2) GOTO 140
        IMAX=IGL
  150   IMAX=IMAX+1
        IF(K(IMAX,1).EQ.2) GOTO 150
 
C...Find mass of this gluino-string. 
        DO 170 J=1,5
          PSUM(J)=0D0
          DO 160 I=IMIN,IMAX
            PSUM(J)=PSUM(J)+P(I,J)
  160     CONTINUE
  170   CONTINUE
        PSUM(5)=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &  PSUM(3)**2))
 
C...If low-mass, then consider gluino-hadron already formed.
        IF(PSUM(5).LE.P(IGL,5)+P(IMIN,5)+P(IMAX,5)+PMKIN) THEN
          DO 180 I=IMIN,IMAX
            K(I,1)=15+IGLUI
  180     CONTINUE
          GOTO 300
        ENDIF    

C...Else break string by production of new gg or two new qqbar pairs.
C...(Also diquarks allowed, but not popcorn, and not two adjacent.)
        IF(PYR(0).LT.PROBGG) THEN
          KFSAV(1)=21
          KFSAV(2)=21
          PMSAV(1)=0.5D0*PMGLU  
          PMSAV(2)=0.5D0*PMGLU  
        ELSE
  185     CALL PYDCYK(K(IMIN,2),0,KFSAV(1),KFDUM)
          CALL PYDCYK(K(IMAX,2),0,KFSAV(2),KFDUM)
          IF(IABS(KFSAV(1)).GT.10.AND.IABS(KFSAV(2)).GT.10) GOTO 185
          IF(IABS(KFSAV(1)).GT.10.AND.IABS(K(IGL-1,2)).GT.10) GOTO 185
          IF(IABS(KFSAV(2)).GT.10.AND.IABS(K(IGL+2,2)).GT.10) GOTO 185
          KFSAV(1)=ISIGN(MOD(IABS(KFSAV(1)),10000),KFSAV(1))
          KFSAV(2)=ISIGN(MOD(IABS(KFSAV(2)),10000),KFSAV(2))
          MSTJ(93)=1 
          PMSAV(1)=PYMASS(KFSAV(1))         
          MSTJ(93)=1 
          PMSAV(2)=PYMASS(KFSAV(2))
        ENDIF         

C...Mass of gluino-hadron.
        PMGSAV=P(IGL,5)
        PMGB=P(IGL,5)+PMSAV(1)+PMSAV(2)

C...Pick at random order in which both sides of gluino string break.
        ISIDE=INT(1.5D0+PYR(0))
        DO 220 ISDE=1,2
          IF(ISDE.EQ.1) IS=ISIDE
          IF(ISDE.EQ.2) IS=3-ISIDE

C...Pick momentum sharing according to fragmentation function as if bottom.
          PMBSAV=PARF(105)
          PARF(105)=PMGSAV
          CALL PYZDIS(5,0,PMGB**2,ZGL)
          PARF(105)=PMBSAV 
          ZGL=MAX(0.9D0,MIN(0.9999D0,ZGL)) 
          DO 190 J=1,5
            PSAV(IS,J)=(1D0-ZGL)*P(IGL,J)
            P(IGL,J)=ZGL*P(IGL,J)
  190    CONTINUE

C...Target gluino-hadron mass for this stage of momentum reshuffling.
          PMOLD=P(IGL,5)
          IF(ISDE.EQ.1) PMNEW=PMGSAV+PMSAV(IS)
          IF(ISDE.EQ.2) PMNEW=PMGB 

C...Recoiling parton from which to shuffle momentum. System momentum.
          IF(IS.EQ.1) IREC=IGL-1
          IF(IS.EQ.2) IREC=IGL+2
  200     DO 210 J=1,4
            PSUM(J)=P(IGL,J)+P(IREC,J)
  210     CONTINUE           

C...Boost to rest frame of system, and align gluino along +z axis.
          CALL PYROBO(IGL,IGL,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          PHI=PYANGL(P(IGL,1),P(IGL,2))
          CALL PYROBO(IGL,IGL,0D0,-PHI,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,0D0,-PHI,0D0,0D0,0D0)
          THETA=PYANGL(P(IGL,3),P(IGL,1)) 
          CALL PYROBO(IGL,IGL,-THETA,0D0,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,-THETA,0D0,0D0,0D0,0D0)

C...Calculate new kinematics in this frame, for desired gluino mass.
          ETOT=P(IGL,4)+P(IREC,4)
          IF(ETOT.GT.PMNEW+P(IREC,5)) THEN
            IFAIL=0
            PZNEW=0.5D0*SQRT(MAX(0D0,(ETOT**2-PMNEW**2-P(IREC,5)**2)**2-
     &      4D0*PMNEW**2*P(IREC,5)**2))/ETOT
            P(IGL,3)=PZNEW
            P(IGL,4)=SQRT(PZNEW**2+PMNEW**2)
            P(IGL,5)=PMNEW
            P(IREC,3)=-PZNEW
            P(IREC,4)=SQRT(PZNEW**2+P(IREC,5)**2)

C...If not enough momentum, take what can be taken.
          ELSE
            IFAIL=1
            PMOLD=ETOT-P(IREC,5)
            P(IGL,3)=0D0
            P(IGL,4)=PMOLD
            P(IGL,5)=PMOLD
            P(IREC,3)=0D0
            P(IREC,4)=P(IREC,5)
          ENDIF

C...Bost back to lab frame.
          CALL PYROBO(IGL,IGL,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))

C...Loop back when not enough momentum could be shuffled.
C...(As long as there is something left on either side.)
          IF(IFAIL.EQ.1) THEN
  215       IF(IS.EQ.1.AND.IREC.GT.IMIN) THEN
              IREC=IREC-1
              GOTO 200
            ELSEIF(IS.EQ.2.AND.IREC.LT.IMAX) THEN
              IREC=IREC+1
              GOTO 200
            ELSEIF(ISDE.EQ.2.AND.IS.EQ.3-ISIDE) THEN
              IS=ISIDE
              IREC=IRECSV
              GOTO 215
            ENDIF
          ENDIF

C...End loop over fragmentation of two sides around gluino.
         IRECSV=IREC
  220   CONTINUE

C...New slots at end of record for gluino + new quarks/gluons.
        DO 230 J=1,5
          K(N+1,J)=0
          P(N+1,J)=P(IGL,J)
          V(N+1,J)=V(IGL,J)
          K(N+2,J)=0
          P(N+2,J)=0D0
          V(N+2,J)=V(IGL,J)
          K(N+3,J)=0
          P(N+3,J)=0D0
          V(N+3,J)=V(IGL,J)
  230   CONTINUE
 
C...Status and code of these slots.
        K(N+1,1)=15+IGLUI
        K(N+2,1)=15+IGLUI
        K(N+3,1)=15+IGLUI
        K(N+1,2)=K(IGL,2)
        IF(KFSAV(1).EQ.21) THEN
          K(N+2,2)=KFSAV(1)
          K(N+3,2)=KFSAV(2)
        ELSE
          K(N+2,2)=-KFSAV(1)
          K(N+3,2)=-KFSAV(2)
        ENDIF
        K(N+1,3)=K(IGL,3)
        K(N+2,3)=K(IGL,3)
        K(N+3,3)=K(IGL,3)
        N=N+3
        
C...Code and momentum of two new string endpoints.
        K(IGL,2)=KFSAV(1)
        K(IGL+1,2)=KFSAV(2)
        IF(KFSAV(1).NE.21) K(IGL,1)=1
        DO 240 J=1,5
          P(IGL,J)=PSAV(1,J)
          P(IGL+1,J)=PSAV(2,J)
  240   CONTINUE
 
C...End of loop over two gluinos.
  300 CONTINUE

C...Cleanup: remove zero-energy gluons.
      NNOW=N
      N=NOLD
      DO 330 I=NOLD+1,NNOW
        IF(K(I,2).EQ.21.AND.P(I,4).LT.1D-10) THEN
        ELSEIF(I.EQ.N+1) THEN
          N=N+1
        ELSE
          N=N+1
          DO 320 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  320     CONTINUE
        ENDIF
  330 CONTINUE

C...Finish off with standard hadronization.
      CALL PYEXEC

C...Restore code of gluino-hadrons to non-fragmented numbers.
C...(Status code K(I,1) = 6 and 7 can now be used to identify 
C...constituents of the two gluino-hadrons.)
      DO 340 I=1,N
        IF(K(I,1).EQ.16.OR.K(I,1).EQ.17) K(I,1)=K(I,1)-10
  340 CONTINUE

C...Extracheck charge.
      CHGNEW=PYP(0,6)
      IF(ABS(CHGNEW-CHGSAV).GT.0.1D0) MSTU(24)=1

C...In case of trouble, make up to five attempts.
      IF(MSTU(24).NE.0.AND.LOOP.LT.5) THEN
        WRITE(*,*) '     ...give it new try...'
        MSTU(23)=MSTU(23)-1
        GOTO 90
      ELSEIF(MSTU(24).NE.0) THEN
        WRITE(*,*) '     ...but still fail after repeated attempts!'
      ELSEIF(MSTU(24).EQ.0.AND.LOOP.GT.1) THEN
        WRITE(*,*) '     ...and now it worked!'
      ENDIF

C...Finished. Restore baryon production model.
      MSTJ(12)=MSTJ12
      
      RETURN
      END

C...Sample program for jet or minumum bias events 
C...in ep or e+e- by gamma*p or gamma*gamma* interactions,
C...internally convoluted with gamma* flux in e.

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      
C...Select machine: 1 = HERA, 2 = LEP2.
      ISEL=1

C...Number of events.
      NEV=1000

C...Three (main) options of event classes:
C...= 1 : jet events only (set pTmin in CKIN(3)).
C...= 2 : jet plus low-pT events (pTmin irrelevant).
C...= 3 : jet plus low-pT plus elastic and diffractive events.  
      MOPT=3
      IF(MOPT.EQ.1) THEN
        CKIN(3)=4D0
      ELSEIF(MOPT.EQ.2) THEN   
        CKIN(3)=0D0
      ELSE
        CKIN(3)=0D0
        MSEL=2    
      ENDIF    

C...Set minimal and maximal W of gamma*gamma* system.
      CKIN(77)=50D0
      CKIN(78)=200D0

C...Set minimum photon virtuality.
c      CKIN(65)=0D0
c      CKIN(67)=0D0    
C...Set maximum photon virtuality.
      CKIN(66)=4D0
      CKIN(68)=4D0  

C...Modify contribution of resolved longitudinal photons.
c      MSTP(17)=4
c      PARP(165)=1D0 

C...Simplify simulation.
c      MSTP(61)=0 
c      MSTP(71)=0 
c      MSTP(81)=0 
c      MSTP(91)=0 
c      MSTP(111)=0 

C...Initialize for HERA.
      IF(ISEL.EQ.1) THEN
        DO 100 J=1,3
          P(1,J)=0D0
          P(2,J)=0D0
 100    CONTINUE
        P(1,3)=-27.5D0
        P(2,3)=820D0
C...Use minimal W to set minimum photon energy fractions.
        ECM=SQRT(4D0*ABS(P(1,3)*P(2,3))) 
        CKIN(61)=(CKIN(77)/ECM)**2  
        CKIN(73)=CKIN(61)
C...Check that not too low pTmin.
        IF(MOPT.EQ.1) THEN
          PTMINS=PARP(81)*(ECM/PARP(89))**PARP(90) 
          CKIN(3)=MAX(CKIN(3),1.01D0*PTMINS)
        ENDIF
        CALL PYINIT('3MOM','GAMMA/E-','P',0D0)

C...Initialize for LEP2.
      ELSE
        ECM=200D0
C...Use minimal W to set minimum photon energy fractions. 
        CKIN(61)=(CKIN(77)/ECM)**2  
        CKIN(63)=CKIN(61)
        CKIN(73)=CKIN(61)
        CKIN(75)=CKIN(61)
C...Check that not too low pTmin.
        IF(MOPT.EQ.1) THEN
          PTMINS=PARP(81)*(ECM/PARP(89))**PARP(90) 
          CKIN(3)=MAX(CKIN(3),1.01D0*PTMINS)
        ENDIF
        CALL PYINIT('CMS','GAMMA/E+','GAMMA/E-',ECM)
      ENDIF 

C...Book histograms.
      CALL PYBOOK(1,'x = energy fraction of photons in lepton',
     &100,0D0,1D0)
      CALL PYBOOK(2,'W distribution',100,0D0,200D0)
      CALL PYBOOK(3,'log10(Q2)',100,-15D0,10D0)
      CALL PYBOOK(4,'x = energy fraction of partons in photon',
     &100,0D0,1D0)
      CALL PYBOOK(5,'pT of hard scattering',100,0D0,20D0)
      CALL PYBOOK(6,'number of hard interactions in event',
     &20,-0.5D0,19.5D0)

C...Event loop. List first few events.
      DO 200 IEV=1,NEV
        CALL PYEVNT
        IF(IEV.LE.2) CALL PYLIST(1)

C...Analyze event.
        ISUB=MSTI(1)
        X1G=PARI(103)
        X2G=PARI(104)
        W=PARI(11)
        Q21=PARI(105)
        Q22=PARI(106)
C...Shift a direct photon away from x_p = 1 for better histogramming.
        X1P=MIN(0.999D0,PARI(33))
        X2P=MIN(0.999D0,PARI(34))
C...pT=0 for low-pT, but nonvanishing for elastic/diffractive events.
        PT=PARI(17)
        NMUL=MSTI(31)

C...Fill histograms. End event loop.
        CALL PYFILL(1,X1G,1D0)
        IF(ISEL.EQ.2) CALL PYFILL(1,X2G,1D0)
        CALL PYFILL(2,W,1D0)
        CALL PYFILL(3,LOG10(Q21),1D0)
        IF(ISEL.EQ.2) CALL PYFILL(3,LOG10(Q22),1D0)
        CALL PYFILL(4,X1P,1D0)
        IF(ISEL.EQ.2) CALL PYFILL(4,X2P,1D0)
        CALL PYFILL(5,PT,1D0)
        CALL PYFILL(6,DBLE(NMUL),1D0)
  200 CONTINUE

C...Final statistics and histograms.
      CALL PYSTAT(1)
      CALL PYHIST 

      END

C...This program makes use of the built-in test program of the
C...PYTHIA packages. It is convenient test that you know how to 
C...compile and link.

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C-----------------------------------------------------------------

      CALL PYTEST(0)
      END

C...Sample main program for a heavy Higgs mass spectrum.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C-----------------------------------------------------------------

C...First section: initialization.
 
C...Number of events and cm energy. 
      NEV=1000
      ECM=14000D0

C...Processes.
      MSEL=0
      MSUB(102)=1
      MSUB(123)=1
      MSUB(124)=1

C...Higgs mass.
      PMAS(25,1)=600D0

C...Switch off unnecessary aspects: initial and  final state
C...showers, multiple interactions, hadronization.
C...(Optional for faster simulation of the parton-level 
C...processes only.)
      MSTP(61)=0
      MSTP(71)=0
      MSTP(81)=0
      MSTP(111)=0 

C...Initialize.
      CALL PYINIT('CMS','p','p',ECM)

C...List table of resonance decay channels.
C      CALL PYSTAT(2)
 
C...Book histograms.
      CALL PYBOOK(1,'Higgs mass distribution, old',
     &100,0D0,1000D0)
      CALL PYBOOK(2,'Higgs mass distribution, new',
     &100,0D0,1000D0)

C-----------------------------------------------------------------

C...Second section: event loop.

C...Outer loop over Higgs width treatment.
      DO 250 ICA=1,2
      MSTP(49)=ICA-1 

C...Generate events and look at first few.
      DO 200 IEV=1,NEV
        CALL PYEVNT
        IF(IEV.LE.1) CALL PYLIST(1) 

C...Find and fill Higgs mass.
        DO 150 I=7,9
          IF(K(I,2).EQ.25) CALL PYFILL(ICA,P(I,5),1D0) 
  150   CONTINUE

C...End of loops over events and cases.
  200 CONTINUE
  250 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      CALL PYHIST

      END

C...A somewhat more realistic example: a study of reconnection
C...effects on the W mass at LEP 2.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C...Local arrays and data.
      DIMENSION NEVT(30),IQQ(4),PMWR(4,4),IJJ(4),DISTSV(4,4),
     &NACC(10,5),PDIFF(5),NACC2(10,5),WACC(10,5),WACC2(10,5)
      DATA NEVT/30*0/,NACC/50*0/,WACC/50*0D0/,NACC2/50*0/,
     &WACC2/50*0D0/

C-----------------------------------------------------------------

C...First section: initialization.

C...CM energy. Number of events. Number of cases. pi0 stable.
      ECM=170D0
      NEV=10000
      NRE=7
      MDCY(PYCOMP(111),1)=0

C...Choice of W+W- process.
      MSEL=0
      MSUB(25)=1  

C...Allow only hadronic W decays.
      DO 100 IDC=MDCY(24,2),MDCY(24,2)+MDCY(24,3)-1
        IF(IABS(KFDP(IDC,1)).GE.6) MDME(IDC,1)=
     &  MIN(0,MDME(IDC,1))
 100  CONTINUE

C...No ISR photon radiation.
      MSTP(11)=0       

C...Initialize.
      CALL PYINIT('CMS','e+','e-',ECM)

C...Set up cluster finding for 4 clusters.
      MSTU(41)=1
      MSTU(47)=4
      PARU(44)=8D0

C...Book histograms for all cases.
      DO 110 IRE=1,NRE
      CALL PYBOOK(IRE,'Prob(number of jets)',20,-0.5D0,19.5D0)
      CALL PYBOOK(IRE+10,'Prob(reconnect) as fn n_jets',20,-0.5D0,
     &19.5D0)
      CALL PYBOOK(IRE+20,'<m_W>(true)',100,70D0,90D0)
      CALL PYBOOK(IRE+30,'<m_W>(LUCLUS-true)',100,-10D0,10D0)
      CALL PYBOOK(IRE+40,'<m_W>(LUCLUS min dist1-true)',100,-10D0,10D0)
      CALL PYBOOK(IRE+50,'<m_W>(LUCLUS min dist2-true)',100,-10D0,10D0)
      CALL PYBOOK(IRE+60,'<m_W>(LUCLUS min dist3-true)',100,-10D0,10D0)
      CALL PYBOOK(IRE+70,'charged multiplicity',80,-1D0,159D0)
  110 CONTINUE

C-----------------------------------------------------------------

C...Second section: event loop.

C...Loop through the cases of interest. See manual for description.
      DO 300 IRE=1,NRE
      IF(IRE.EQ.1) MSTP(115)=0
      IF(IRE.EQ.2) MSTP(115)=1
      IF(IRE.EQ.3) MSTP(115)=2
      IF(IRE.EQ.4) MSTP(115)=3
      IF(IRE.EQ.5) MSTP(115)=5
      IF(IRE.EQ.6) MSTP(115)=11
      IF(IRE.EQ.7) MSTP(115)=12

C...Generate events for each case.
      DO 290 IEV=1,NEV
      CALL PYEVNT

C...List first event of each type.
      IF(IEV.EQ.1) CALL PYLIST(1)

C...Read out whether reconnection occured. W+- positions.
      IRR=MSTI(32)
      IW1=7
      IW2=8

C...Do cluster search. Only keep events with four clusters.
      IACC=0
      CALL PYCLUS(NJET)
      CALL PYFILL(IRE,DBLE(NJET),1D0)
      CALL PYFILL(IRE+10,DBLE(NJET),DBLE(IRR))
      IF(NJET.NE.4) GOTO 290
      NEVT(IRE)=NEVT(IRE)+1

C...Cuts so that all clusters are well separated and have good energy.
      DSPMIN=0.5D0
      EMIN=20D0
      ISEP=1
      DO 120 I1=N+1,N+3
      DO 120 I2=I1+1,N+4
      PA1=SQRT(P(I1,1)**2+P(I1,2)**2+P(I1,3)**2)      
      PA2=SQRT(P(I2,1)**2+P(I2,2)**2+P(I2,3)**2)      
      P12=P(I1,1)*P(I2,1)+P(I1,2)*P(I2,2)+P(I1,3)*P(I2,3)
      DSEP=ACOS(MAX(-1D0,MIN(1D0,P12/(PA1*PA2))))
      DISTSV(I1-N,I2-N)=DSEP
      DISTSV(I2-N,I1-N)=DSEP
  120 IF(DSEP.LT.DSPMIN) ISEP=0
      DO 130 I1=N+1,N+4
  130 IF(P(I1,4).LT.EMIN) ISEP=0
      IF(ISEP.EQ.0) GOTO 290
      NEVT(IRE+10)=NEVT(IRE+10)+1

C...Fill true average W mass.
      PMAVG=0.5D0*(P(IW1,5)+P(IW2,5))
      CALL PYFILL(IRE+20,PMAVG,1D0)

C...Relate clusters to partons.
      IQQ(1)=9
      IQQ(2)=10
      IQQ(3)=11
      IQQ(4)=12
      DO 150 I1=N+1,N+4
      DO 150 I2=1,4
      PMWRS=(P(I1,4)+P(IQQ(I2),4))**2-(P(I1,1)+P(IQQ(I2),1))**2-
     &(P(I1,2)+P(IQQ(I2),2))**2-(P(I1,3)+P(IQQ(I2),3))**2
  150 PMWR(I1-N,I2)=SQRT(MAX(0D0,PMWRS))
      PROMIN=1D10
      DO 160 IJ1=1,4
      DO 160 IJ2=1,4
      DO 160 IJ3=1,4
      DO 160 IJ4=1,4
      IF(IJ1.EQ.IJ2.OR.IJ1.EQ.IJ3.OR.IJ1.EQ.IJ4.OR.IJ2.EQ.IJ3.OR.
     &IJ2.EQ.IJ4.OR.IJ3.EQ.IJ4) GOTO 160
      PRONOW=PMWR(IJ1,1)*PMWR(IJ2,2)*PMWR(IJ3,3)*PMWR(IJ4,4)
      IF(PRONOW.LT.PROMIN) THEN
        PROMIN=PRONOW
        IJJ(1)=N+IJ1
        IJJ(2)=N+IJ2
        IJJ(3)=N+IJ3
        IJJ(4)=N+IJ4
      ENDIF
  160 CONTINUE

C...Fill reconstructed average W mass shifts; under idealized conditions.
      PMWRS=(P(IJJ(1),4)+P(IJJ(2),4))**2-(P(IJJ(1),1)+P(IJJ(2),1))**2-
     &(P(IJJ(1),2)+P(IJJ(2),2))**2-(P(IJJ(1),3)+P(IJJ(2),3))**2
      PMWW1=SQRT(MAX(0D0,PMWRS))
      PMWRS=(P(IJJ(3),4)+P(IJJ(4),4))**2-(P(IJJ(3),1)+P(IJJ(4),1))**2-
     &(P(IJJ(3),2)+P(IJJ(4),2))**2-(P(IJJ(3),3)+P(IJJ(4),3))**2
      PMWW2=SQRT(MAX(0D0,PMWRS))
      PMWWA=0.5D0*(PMWW1+PMWW2)
      CALL PYFILL(IRE+30,PMWWA-PMAVG,1D0)   

C...Now use three different semirealistic schemes to pair jets to W's,
C...designed to pick jet combination which gives masses "closest" to 
C...nominal ones: (1) average mass closest to 80 GeV; (2) minimal
C...deviation of W masses from 80 GeV; (3) jets most back-to-back. 
      PMBEST=0D0
      PMDEVI=80D0
      DMAXI=0D0
      DO 180 ICA=1,3
      IF(ICA.EQ.1) THEN
        I1=N+1
        I2=N+2
        I3=N+3
        I4=N+4
      ELSEIF(ICA.EQ.2) THEN
        I1=N+1
        I2=N+3
        I3=N+2
        I4=N+4
      ELSE
        I1=N+1
        I2=N+4
        I3=N+2
        I4=N+3
      ENDIF
      PMWRS1=(P(I1,4)+P(I2,4))**2-(P(I1,1)+P(I2,1))**2-
     &(P(I1,2)+P(I2,2))**2-(P(I1,3)+P(I2,3))**2
      PMWR1=SQRT(MAX(0D0,PMWRS1))
      PMWRS2=(P(I3,4)+P(I4,4))**2-(P(I3,1)+P(I4,1))**2-
     &(P(I3,2)+P(I4,2))**2-(P(I3,3)+P(I4,3))**2
      PMWR2=SQRT(MAX(0D0,PMWRS2))
      PMWRA=0.5D0*(PMWR1+PMWR2)
      IF(ABS(PMWRA-80D0).LT.ABS(PMBEST-80D0)) PMBEST=PMWRA
      PMDEWW=ABS(PMWR1-80D0)+ABS(PMWR2-80D0)
      IF(PMDEWW.LT.PMDEVI) THEN
        PMDEVI=PMDEWW
        PMBESA=PMWRA
      ENDIF
      DTHE=DISTSV(I1-N,I2-N)+DISTSV(I3-N,I4-N)
      IF(DTHE.GT.DMAXI) THEN
        DMAXI=DTHE
        PMBESB=PMWRA
      ENDIF
  180 CONTINUE

C...Fill average mass shifts for three different choices.
      CALL PYFILL(IRE+40,PMBEST-PMAVG,1D0)
      CALL PYFILL(IRE+50,PMBESA-PMAVG,1D0)
      CALL PYFILL(IRE+60,PMBESB-PMAVG,1D0)

C...Fill numerical statistics as alternative to histograms.
      PDIFF(1)=PMWWA-PMAVG
      PDIFF(2)=PMBEST-PMAVG
      PDIFF(3)=PMBESA-PMAVG
      PDIFF(4)=PMBESB-PMAVG
      DO 200 J=1,4
      IF(ABS(PDIFF(J)).LT.10D0) THEN
        NACC(IRE,J)=NACC(IRE,J)+1
        WACC(IRE,J)=WACC(IRE,J)+PDIFF(J)
      ENDIF
      IF(ABS(PDIFF(J)).LT.4D0) THEN
        NACC2(IRE,J)=NACC2(IRE,J)+1
        WACC2(IRE,J)=WACC2(IRE,J)+PDIFF(J)
      ENDIF
  200 CONTINUE     

C...Charged multiplicity.
      CALL PYEDIT(3)
      CALL PYFILL(IRE+70,DBLE(N),1D0)

C...End event and case loops.
  290 CONTINUE
  300 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Numerical statistics.
      DO 320 IRE=1,NRE
      DO 320 J=1,4
      WACC(IRE,J)=WACC(IRE,J)/NACC(IRE,J)
      WACC2(IRE,J)=WACC2(IRE,J)/NACC2(IRE,J)
  320 CONTINUE
      WRITE(6,'(A32,I7/5X,7I6)') '# events in total and after cuts:',
     &NEV,(NEVT(IRE+10),IRE=1,NRE)
      DO 330 J=1,4
      WRITE(6,'(I5,7I6,7F10.3)') J,(NACC(IRE,J),IRE=1,NRE),
     &(WACC(IRE,J),IRE=1,NRE)
      WRITE(6,'(57X,6F10.3)') (WACC(IRE,J)-WACC(1,J),IRE=2,NRE)
      WRITE(6,'(I5,7I6,7F10.3)') J,(NACC2(IRE,J),IRE=1,NRE),
     &(WACC2(IRE,J),IRE=1,NRE)
      WRITE(6,'(57X,6F10.3)') (WACC2(IRE,J)-WACC2(1,J),IRE=2,NRE)
  330 CONTINUE

C...Rescale and print histograms.
C...Note: in a realistic run, the histrograms would be saved on
C...a file, and shown with curves suitably superimposed.
      FAC=1D0/NEV
      DO 400 IRE=1,NRE      
      CALL PYOPER(IRE+10,'/',IRE,IRE+10,1D0,1D0)
      CALL PYFACT(IRE,FAC)
      CALL PYFACT(IRE+20,5D0*FAC)
      CALL PYFACT(IRE+30,5D0*FAC)
      CALL PYFACT(IRE+40,5D0*FAC)
      CALL PYFACT(IRE+50,5D0*FAC)
      CALL PYFACT(IRE+60,5D0*FAC)
      CALL PYFACT(IRE+70,FAC)
  400 CONTINUE
      CALL PYHIST

      END 

C...A simple skeleton program, illustrating a typical Pythia run:
C...Z0 production at LEP 1. 
C...Toy task: compare multiplicity distribution with matrix elements
C...and with parton showers (using same fragmentation parameters).

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C-----------------------------------------------------------------

C...First section: initialization.
 
C...Main parameters of run: c.m. energy and number of events.
      ECM=91.2D0
      NEV=1000

C...Select gamma*/Z0 production process.
      MSEL=0
      MSUB(1)=1

C...Only allow Z0 decay to quarks (i.e. no leptonic final states).
      DO 100 IDC=MDCY(23,2),MDCY(23,2)+MDCY(23,3)-1
        IF(IABS(KFDP(IDC,1)).GE.6) MDME(IDC,1)=MIN(0,MDME(IDC,1))
  100 CONTINUE

C...Initialize.
      CALL PYINIT('CMS','e+','e-',ECM)

C...Check that Z0 decay channels set correctly.
      CALL PYSTAT(2)

C...Book histograms.
      CALL PYBOOK(1,'charged multiplicity ME',100,-0.5D0,99.5D0)
      CALL PYBOOK(2,'charged multiplicity PS',100,-0.5D0,99.5D0)

C-----------------------------------------------------------------

C...Second section: event loop.

C...Outer loop over ME and PS options.
      DO 300 ICA=1,2
        IF(ICA.EQ.1) THEN
          MSTP(48)=1
          MSTJ(101)=2
        ELSE
          MSTP(48)=0
        ENDIF 
 
C...Begin event loop.
        DO 200 IEV=1,NEV
          CALL PYEVNT

C...List first few events.
          IF(IEV.LE.2) CALL PYLIST(1)

C...Extract and fill event properties.
          CALL PYEDIT(3)
          CALL PYFILL(ICA,DBLE(N),1D0)

C...End event loop.
  200   CONTINUE

C...End outer loop.
  300 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      CALL PYHIST

      END

C...Sample main program for leptoquark generation at HERA.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C...Local arrays.
      DIMENSION NCHN(12),QVEC(4)
      DATA NCHN/12*0/ 

C-----------------------------------------------------------------

C...First section: initialization.

C...Number of events, positron and proton energy.
      NEV=1000
      EPOSI=27.5D0
      EPROT=820D0

C...Process.
      MSEL=0
      MSUB(145)=1

C...Leptoquark mass and type: quark and lepton species.
      PMAS(39,1)=200D0
      KFDP(MDCY(39,2),1)=2
      KFDP(MDCY(39,2),2)=-11

C...Rescale leptoquark Yukawa coupling to suitable value.
      PARU(151)=0.01D0

C...Switch off unnecessary aspects: initial and  final state
C...showers, multiple interactions, hadronization.
C...(Optional for faster simulation of the parton-level 
C...processes only.)
C      MSTP(61)=0
C      MSTP(71)=0
C      MSTP(81)=0
C      MSTP(111)=0 

C...Switch off interference between initial and final partons.
C...(Not there because of long leptoquark lifetime.)
      MSTJ(50)=0
      MSTP(67)=0 

C...Initialize.
      P(1,1)=0D0
      P(1,2)=0D0
      P(1,3)=-EPOSI
      P(2,1)=0D0
      P(2,2)=0D0
      P(2,3)=EPROT
      CALL PYINIT('3mom','e+','p',0D0)

C...List table of resonance decay channels.
      CALL PYSTAT(2)
 
C...Book histograms.
      CALL PYBOOK(1,'Leptoquark mass',100,PMAS(39,1)-10D0,
     &PMAS(39,1)+10D0)
      CALL PYBOOK(2,'x spectrum',100,0D0,1D0) 
      CALL PYBOOK(3,'Q2 distribution',100,0D0,1D5) 

C-----------------------------------------------------------------

C...Second section: event loop.
 
C...Begin event loop.
        DO 200 IEV=1,NEV
          CALL PYEVNT

C...List first few events.
          IF(IEV.LE.5) CALL PYLIST(1)

C...Hard scattering mass from commonblock.
          CALL PYFILL(1,PARI(13),1D0) 

C...Reconstruct Q2 and Bjorken x.
          IIN=1
          IP=2
          IOUT=9
  110     IOUT=IOUT+1
          IF(K(IOUT,2).NE.KFDP(MDCY(39,2),2)) GOTO 110
          DO 120 J=1,4
            QVEC(J)=P(IIN,J)-P(IOUT,J)
  120     CONTINUE
          Q2=QVEC(1)**2+QVEC(2)**2+QVEC(3)**2-QVEC(4)**2
          PQ=P(IP,4)*QVEC(4)-P(IP,1)*QVEC(1)-P(IP,2)*QVEC(2)-
     &    P(IP,3)*QVEC(3)
          X=Q2/(2D0*PQ)
          CALL PYFILL(2,X,1D0)
          CALL PYFILL(3,Q2,1D0)

C...End event loop.
  200   CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      CALL PYHIST

      END

      PROGRAM MAIN77

C...Program to turn gluinos into gluino-hadrons, assuming
C...the gluino is the (pseudo)stable LSP. Also possibility 
C...to let this gluino-hadron decay later on. Can be used
C...e.g. in split SUSY scenarios, where the gluino-hadron
C...might decay inside the detector.
C...
C...Modified version, implementing the agreed R-hadron codes, e.g.
C...1000993 gluino g      (or gluinoball) 
C...1009213 gluino u dbar (or ~g rho+)
C...1092214 gluino u u d  (or ~g Delta+)
C...For simplicity all gluino-meson are assumed to have 
C...light-flavour spin 1, since those are the lightest and
C...favoured by spin-state counting. Further, all gluino-baryons
C...are bookkept as having light-flavour spin 3/2, and flavours 
C...are listed in descending order. This is more for convenience
C...of notation, however, since the normal baryon octet e.g.
C...has no uuu = "p++" state. When a diquark is extracted, 
C...a mixture of spin 0 and spin 1 is allowed. 
C...For your pick of naming conventions, see the PYRHAD routine.
C...
C...Note that the R-hadrons are given status codes 6 or 7 before
C...decay, 16 or 17 after. This is for ease to find them, and has
C...no special significance relative to the normal 1 and 11.

C******************************************************************

C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Process names.
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
C...Local arrays. R-hadron codes used for histogramming only
      DIMENSION EPQSUM(6)
      DIMENSION KFRH(20)
      DATA KFRH/1000993,1009213,1009313,1009323,1009113,1009223,
     &1009333,1091114,1092114,1092214,1092224,1093114,1093214,
     &1093224,1093314,1093324,1093334,3*0/
      CHARACTER*16 CHRHAD

C...Number of events, CM energy.
      NEV=1000
      ECM=14000D0

C...Pick gluino mass.
      KFGL=KSUSY1+21
      PMGL=200D0

C...Pick processes: gluino pair production.
      MSEL=0
      MSUB(243)=1
      MSUB(244)=1

C...Set necessary SUSY parameters (brute force).
      IMSS(1)=1
C...Gluino mass - of "constituent" mass kind.
      IMSS(3)=1
      RMSS(3)=PMGL
C...Pick other ino masses somewhat smaller.
      RMSS(1)=0.5D0*PMGL
      RMSS(2)=0.5D0*PMGL
      RMSS(4)=1D4
C...Stop_1 mass.
      IMSS(5)=1
      RMSS(12)=2D0*PMGL

C...Initialize R-hadron names, charges, etc.
      CALL PYRHAD

C...Initialize.
      CALL PYINIT('CMS','p','p',ECM)
  
C...Show particle data.
C      CALL PYSTAT(2)
C      CALL PYLIST(12)

C...Switch off hadronization in normal PYEVNT call.
      MSTP(111)=0 

C...Histograms.
      CALL PYBOOK(1,'E-P-Q conservation before R decays',100,0D0,0.01D0)
      CALL PYBOOK(2,'E-P-Q conservation after R decays',100,0D0,0.01D0)
      CALL PYBOOK(3,'charged hadron multiplicity (excl. R hadrons)',
     &100,-1D0,399D0)
      CALL PYBOOK(5,'extra multiplicity from gluino decays',
     &100,-0.5D0,99.5D0)
      CALL PYBOOK(11,'gluino-hadron species',39,-19.5D0,19.5D0)
      CALL PYBOOK(12,'gluino-hadron mass spectrum',100,PMGL,PMGL+2D0)
      CALL PYBOOK(21,'gluino-parton pT spectrum',100,0D0,500D0)
      CALL PYBOOK(22,'gluino-hadron pT spectrum',100,0D0,500D0)
 
C...Event generation loop.
      DO 200 IEV=1,NEV
      if(mod(iev,100).eq.0) write(*,*) 'begin event no', iev

C...Put gluino stable.
        MDCY(PYCOMP(KFGL),1)=0

C...Generate event, but without worrying about small string systems.
        MSTJ(14)=-1
        CALL PYEVNT
        MSTJ(14)=1
        DO 140 J=1,6
          EPQSUM(J)=PYP(0,J)
 140    CONTINUE

C...Now perform treatment of gluino hadronization.
        CALL PYGLFR

C...List first few events.
C        IF(IEV.LE.2) CALL PYLIST(2)

C...Statistics: generic.
        NMERR=0
        EPQ=ABS(PYP(0,4)-EPQSUM(4))+ABS(PYP(0,1)-EPQSUM(1))+
     &  ABS(PYP(0,2)-EPQSUM(2))+ABS(PYP(0,3)-EPQSUM(3))+
     &  ABS(PYP(0,6)-EPQSUM(6))
        CALL PYFILL(1,EPQ,1D0)
        IF(EPQ.GT.1D-2) NMERR=NMERR+1
        NCH=0
        DO 160 I=1,N
          DM2=P(I,4)**2-P(I,1)**2-P(I,2)**2-P(I,3)**2-P(I,5)**2
          IF(DM2.GT.1D-4) THEN
             WRITE(*,*) 'problem particle',I,K(I,2),DM2
            IF(DM2.GT.1D-2) NMERR=NMERR+1
          ENDIF
          IF(K(I,1).EQ.1.AND.PYCHGE(K(I,2)).NE.0) NCH=NCH+1
          PT=SQRT(P(I,1)**2+P(I,2)**2) 
 
C...Statistics: gluino.
          IF(K(I,1).EQ.12.AND.K(I,2).EQ.KFGL) THEN
            CALL PYFILL(21,PT,1D0)
          ENDIF
          IF(K(I,1).EQ.6.OR.K(I,1).EQ.7) THEN
C            CALL PYNAME(K(I,2),CHRHAD)
C            WRITE(*,*) ' R-hadron KF = ',K(I,2),' and name ',CHRHAD
            KFARH=IABS(K(I,2))
            IRHBIN=0
            DO 150 IBIN=1,17
              IF(KFARH.EQ.KFRH(IBIN)) IRHBIN=IBIN
  150       CONTINUE
            IF(K(I,2).LT.0) IRHBIN=-IRHBIN
            CALL PYFILL(11,DBLE(IRHBIN),1D0)
            CALL PYFILL(12,P(I,5),1D0)
            CALL PYFILL(22,PT,1D0)
          ENDIF
 160    CONTINUE
        CALL PYFILL(3,DBLE(NCH),1D0)
c        IF(NMERR.GT.0) CALL PYLIST(2)

C..Put gluino unstable.
        MDCY(PYCOMP(KFGL),1)=1

C...Now force gluinos to decay.
        NSAV=N
        CALL PYGLDC

C...Again check energy-momentum-charge conservation.
        NMERR=0
        EPQ=ABS(PYP(0,4)-EPQSUM(4))+ABS(PYP(0,1)-EPQSUM(1))+
     &  ABS(PYP(0,2)-EPQSUM(2))+ABS(PYP(0,3)-EPQSUM(3))+
     &  ABS(PYP(0,6)-EPQSUM(6))
        CALL PYFILL(2,EPQ,1D0)

C...Charged multiplicity in gluino decays.
        NCH=0
        DO 180 I=NSAV+1,N
          IF(K(I,1).EQ.1.AND.PYCHGE(K(I,2)).NE.0) NCH=NCH+1
 180    CONTINUE
        CALL PYFILL(5,DBLE(NCH),1D0)

C...List first few events.
        IF(IEV.LE.2) CALL PYLIST(2)

C...End of event generation loop.
 200  CONTINUE

C...Cross section - not relevant in this case. Histograms.
      CALL PYSTAT(1)      
      CALL PYHIST

      END
 
C*********************************************************************
 
C...PYRHAD
C...Initialize R-hadron data, like names (for event listing) and 
C...charges. So far nothing but the minimum required.
C...Feel free to choose between hadron-like names or 
C...flavour-content-based ones.

      SUBROUTINE PYRHAD
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
      SAVE /PYDAT2/,/PYDAT4/

C...Local R-hadron data arrays, to fill into the global ones.
      DIMENSION KFRH(20),KCHGRH(20),KANTRH(20)
      CHARACTER*16 CHRHA(20),CHRHB(20)
C...Codes.
      DATA KFRH/1000993,1009213,1009313,1009323,1009113,1009223,
     &1009333,1091114,1092114,1092214,1092224,1093114,1093214,
     &1093224,1093314,1093324,1093334,3*0/
C...Three times charge.
      DATA KCHGRH/0,3,0,3,0,0,0,-3,0,3,6,-3,0,3,-3,0,-3,3*0/
C...Existence of a distinct antiparticle.
      DATA KANTRH/0,3*1,3*0,10*1,3*0/
C...One possibility: hadron-like names.
      DATA CHRHA/'~g glueball','~g rho+','~g K*0','~g K*+',
     &'~g rho0','~g omega','~g phi','~g Delta-','~g Delta0',
     &'~g Delta+','~g Delta++','~g Sigma*-','~g Sigma*0',
     &'~g Sigma*+','~g Xi*-','~g Xi*0 ','~g Omega-',3*' '/
      DATA CHRHB/' ','~g rho-','~g K*bar0','~g K*-',3*' ',
     &'~g Deltabar+','~g Deltabar0','~g Deltabar-','~g Deltabar--',
     &'~g Sigma*bar+','~g Sigma*bar0','~g Sigma*bar-','~g Xi*bar+',
     &'~g Xi*bar0','~g Omegabar+',3*' '/
C...Another possibility: flavour-contents-based names.
c      DATA CHRHA/'~g g','~g u dbar','~g d sbar','~g u sbar',
c     &'~g d dbar','~g u ubar','~g s sbar','~g ddd','~g udd',
c     &'~g uud','~g uuu','~g sdd','~g sud','~g suu','~g ssd',
c     &'~g ssu','~g sss',3*' '/
c      DATA CHRHB/' ','~g d ubar','~g s dbar','~g s ubar',3*' ',
c     &'~g ddd bar','~g udd bar','~g uud bar','~g uuu bar',
c     &'~g sdd bar','~g sud bar','~g suu bar','~g ssd bar',
c     &'~g ssu bar','~g sss bar',3*' '/

C...Fill in data.
      DO 100 I=1,17
        KC=400+I
        KCHG(KC,1)=KCHGRH(I)
        KCHG(KC,2)=0
        KCHG(KC,3)=KANTRH(I)
        KCHG(KC,4)=KFRH(I)
        CHAF(KC,1)=CHRHA(I)
        CHAF(KC,2)=CHRHB(I)
  100 CONTINUE    
  
      RETURN
      END
 
C*********************************************************************
 
C...PYGLFR
C...Fragments the string near to a gluino, to form a gluino-hadron, 
C...either by producing a new g-g pair or two new q-qbar ones.
 
      SUBROUTINE PYGLFR
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/
C...Local array.
      DIMENSION PSUM(5),KFSAV(2),PMSAV(2),PSAV(2,5) 

C...Free parameter: relative probability for gluino-gluon-ball.
C...(But occasional low-mass string will never become it anyway.)
      PROBGG=0.1D0
 
C...Free parameter: gluon constituent mass.
      PMGLU=0.7D0
 
C...Free parameter: max kinetic energy in gluino-hadron.
      PMKIN=0.5D0

C...Switch off popcorn baryon production. (Not imperative, but more
C...failed events when popcorn is allowed.)
      MSTJ12=MSTJ(12)
      MSTJ(12)=1

C...Convenient shorthand.
      KFGL=KSUSY1+21

C...Loopback point for serious problems, with new try.
      LOOP=0
      CALL PYEDIT(21)
      CHGSAV=PYP(0,6)
   90 LOOP=LOOP+1
      IF(LOOP.GT.1) CALL PYEDIT(22)

C...Take copy of string system(s), leaving extra free slot after gluino.
C...(Eventually to be overwritten by one q and one qbar string break.)
      NOLD=N
      NGLUI=0
      DO 120 I=1,NOLD
        ICOPY=0
        IF(K(I,1).EQ.2) ICOPY=1
        IF(K(I,1).EQ.1.AND.I.GE.2) THEN
          IF(K(I-1,1).EQ.12) ICOPY=1
        ENDIF
        IF(ICOPY.EQ.1) THEN  
          N=N+1
          DO 100 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  100     CONTINUE
          K(I,1)=K(I,1)+10
          K(I,4)=N
          K(I,5)=N
          K(N,3)=I
          IF(K(I,2).EQ.KFGL) THEN
            NGLUI=NGLUI+1  
            N=N+1
            DO 110 J=1,5
              K(N,J)=K(N-1,J)
              P(N,J)=0D0
              V(N,J)=V(I,J)
  110       CONTINUE
            K(I,5)=N
            K(N,2)=21
          ENDIF
        ENDIF
  120 CONTINUE

C...Loop over (up to) two gluinos per event.
      DO 300 IGLUI=1,NGLUI

C...Identify position of gluino (randomize order of treatment).
        IGL=0
        NGL=0
        DO 130 I=1,N
          IF(K(I,1).EQ.2.AND.K(I,2).EQ.KFGL) THEN
            NGL=NGL+1
            IF(IGLUI.EQ.NGLUI) THEN
              IGL=I
            ELSEIF(NGL.EQ.1) THEN
              IF(PYR(0).LT.0.5D0) IGL=I
            ELSEIF(IGL.EQ.0) THEN
              IGL=I
            ENDIF
          ENDIF
  130   CONTINUE

C...Identify range of partons on string the gluino belongs to. 
        IMIN=IGL
  140   IMIN=IMIN-1
        IF(K(IMIN-1,1).EQ.2) GOTO 140
        IMAX=IGL
  150   IMAX=IMAX+1
        IF(K(IMAX,1).EQ.2) GOTO 150
 
C...Find mass of this gluino-string. 
        DO 170 J=1,5
          PSUM(J)=0D0
          DO 160 I=IMIN,IMAX
            PSUM(J)=PSUM(J)+P(I,J)
  160     CONTINUE
  170   CONTINUE
        PSUM(5)=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &  PSUM(3)**2))
 
C...If low-mass, then consider gluino-hadron already formed.
        IF(PSUM(5).LE.P(IGL,5)+P(IMIN,5)+P(IMAX,5)+PMKIN) THEN
          DO 180 I=IMIN,IMAX
            K(I,1)=15+IGLUI
  180     CONTINUE
          GOTO 300
        ENDIF    

C...Else break string by production of new gg or two new qqbar pairs.
C...(Also diquarks allowed, but not popcorn, and not two adjacent.)
        IF(PYR(0).LT.PROBGG) THEN
C...Let a gluon occupy two slots, to make administration work the same
C...way as for the qqbar case.
          KFSAV(1)=21
          KFSAV(2)=21
          PMSAV(1)=0.5D0*PMGLU  
          PMSAV(2)=0.5D0*PMGLU  
        ELSE
  185     CALL PYDCYK(K(IMIN,2),0,KFSAV(1),KFDUM)
          CALL PYDCYK(K(IMAX,2),0,KFSAV(2),KFDUM)
          IF(IABS(KFSAV(1)).GT.10.AND.IABS(KFSAV(2)).GT.10) GOTO 185
          IF(IABS(KFSAV(1)).GT.10.AND.IABS(K(IGL-1,2)).GT.10) GOTO 185
          IF(IABS(KFSAV(2)).GT.10.AND.IABS(K(IGL+2,2)).GT.10) GOTO 185
          KFSAV(1)=ISIGN(MOD(IABS(KFSAV(1)),10000),KFSAV(1))
          KFSAV(2)=ISIGN(MOD(IABS(KFSAV(2)),10000),KFSAV(2))
          MSTJ(93)=1 
          PMSAV(1)=PYMASS(KFSAV(1))         
          MSTJ(93)=1 
          PMSAV(2)=PYMASS(KFSAV(2))
        ENDIF         

C...Mass of gluino-hadron.
        PMGSAV=P(IGL,5)
        PMGB=P(IGL,5)+PMSAV(1)+PMSAV(2)

C...Pick at random order in which both sides of gluino string break.
        ISIDE=INT(1.5D0+PYR(0))
        DO 220 ISDE=1,2
          IF(ISDE.EQ.1) IS=ISIDE
          IF(ISDE.EQ.2) IS=3-ISIDE

C...Pick momentum sharing according to fragmentation function as if bottom.
          PMBSAV=PARF(105)
          PARF(105)=PMGSAV
          CALL PYZDIS(5,0,PMGB**2,ZGL)
          PARF(105)=PMBSAV 
          ZGL=MAX(0.9D0,MIN(0.9999D0,ZGL)) 
          DO 190 J=1,5
            PSAV(IS,J)=(1D0-ZGL)*P(IGL,J)
            P(IGL,J)=ZGL*P(IGL,J)
  190    CONTINUE

C...Target gluino-hadron mass for this stage of momentum reshuffling.
          PMOLD=P(IGL,5)
          IF(ISDE.EQ.1) PMNEW=PMGSAV+PMSAV(IS)
          IF(ISDE.EQ.2) PMNEW=PMGB 

C...Recoiling parton from which to shuffle momentum. System momentum.
          IF(IS.EQ.1) IREC=IGL-1
          IF(IS.EQ.2) IREC=IGL+2
  200     DO 210 J=1,4
            PSUM(J)=P(IGL,J)+P(IREC,J)
  210     CONTINUE           

C...Boost to rest frame of system, and align gluino along +z axis.
          CALL PYROBO(IGL,IGL,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          PHI=PYANGL(P(IGL,1),P(IGL,2))
          CALL PYROBO(IGL,IGL,0D0,-PHI,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,0D0,-PHI,0D0,0D0,0D0)
          THETA=PYANGL(P(IGL,3),P(IGL,1)) 
          CALL PYROBO(IGL,IGL,-THETA,0D0,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,-THETA,0D0,0D0,0D0,0D0)

C...Calculate new kinematics in this frame, for desired gluino mass.
          ETOT=P(IGL,4)+P(IREC,4)
          IF(ETOT.GT.PMNEW+P(IREC,5)) THEN
            IFAIL=0
            PZNEW=0.5D0*SQRT(MAX(0D0,(ETOT**2-PMNEW**2-P(IREC,5)**2)**2-
     &      4D0*PMNEW**2*P(IREC,5)**2))/ETOT
            P(IGL,3)=PZNEW
            P(IGL,4)=SQRT(PZNEW**2+PMNEW**2)
            P(IGL,5)=PMNEW
            P(IREC,3)=-PZNEW
            P(IREC,4)=SQRT(PZNEW**2+P(IREC,5)**2)

C...If not enough momentum, take what can be taken.
          ELSE
            IFAIL=1
            PMOLD=ETOT-P(IREC,5)
            P(IGL,3)=0D0
            P(IGL,4)=PMOLD
            P(IGL,5)=PMOLD
            P(IREC,3)=0D0
            P(IREC,4)=P(IREC,5)
          ENDIF

C...Bost back to lab frame.
          CALL PYROBO(IGL,IGL,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))

C...Loop back when not enough momentum could be shuffled.
C...(As long as there is something left on either side.)
          IF(IFAIL.EQ.1) THEN
  215       IF(IS.EQ.1.AND.IREC.GT.IMIN) THEN
              IREC=IREC-1
              GOTO 200
            ELSEIF(IS.EQ.2.AND.IREC.LT.IMAX) THEN
              IREC=IREC+1
              GOTO 200
            ELSEIF(ISDE.EQ.2.AND.IS.EQ.3-ISIDE) THEN
              IS=ISIDE
              IREC=IRECSV
              GOTO 215
            ENDIF
          ENDIF

C...End loop over fragmentation of two sides around gluino.
         IRECSV=IREC
  220   CONTINUE

C...New slot at end of record for gluino R-hadron.
        DO 230 J=1,5
          K(N+1,J)=0
          P(N+1,J)=P(IGL,J)
          V(N+1,J)=V(IGL,J)
  230   CONTINUE
 
C...Status and code of this slot.
        K(N+1,1)=15+IGLUI
        KFSVMX=MAX(IABS(KFSAV(1)),IABS(KFSAV(2)))
        KFSVMN=MIN(IABS(KFSAV(1)),IABS(KFSAV(2)))
C...Gluino-ball.
        IF(KFSVMX.EQ.21) THEN
          K(N+1,2)=KSUSY1+993
C...Gluino-meson.
        ELSEIF(KFSVMX.LT.10) THEN
          K(N+1,2)=KSUSY1+9000+100*KFSVMX+10*KFSVMN+3
          IF(KFSVMX.EQ.KFSVMN) THEN
          ELSEIF(MOD(KFSVMX,2).EQ.0) THEN
            IF(KFSVMX.EQ.KFSAV(1).OR.KFSVMX.EQ.KFSAV(2))
     &      K(N+1,2)=-K(N+1,2) 
          ELSE
            IF(KFSVMX.EQ.-KFSAV(1).OR.KFSVMX.EQ.-KFSAV(2))
     &      K(N+1,2)=-K(N+1,2) 
          ENDIF             
C...Gluino-baryon.
        ELSE
          KFSVX1=KFSVMX/1000
          KFSVX2=MOD(KFSVMX/100,10)
          KFA=MAX(KFSVX1,KFSVX2,KFSVMN)
          KFC=MIN(KFSVX1,KFSVX2,KFSVMN)
          KFB=KFSVX1+KFSVX2+KFSVMN-KFA-KFC
          K(N+1,2)=SIGN(KSUSY1+90000+1000*KFA+100*KFB+10*KFC+4,
     &    -KFSAV(1))
        ENDIF
        K(N+1,3)=K(IGL,3)
        N=N+1
        
C...Code and momentum of two new string endpoints.
        K(IGL,2)=KFSAV(1)
        K(IGL+1,2)=KFSAV(2)
        IF(KFSAV(1).NE.21) K(IGL,1)=1
        DO 240 J=1,5
          P(IGL,J)=PSAV(1,J)
          P(IGL+1,J)=PSAV(2,J)
  240   CONTINUE
 
C...End of loop over two gluinos.
  300 CONTINUE

C...Cleanup: remove zero-energy gluons.
      NNOW=N
      N=NOLD
      DO 330 I=NOLD+1,NNOW
        IF(K(I,2).EQ.21.AND.P(I,4).LT.1D-10) THEN
        ELSEIF(I.EQ.N+1) THEN
          N=N+1
        ELSE
          N=N+1
          DO 320 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  320     CONTINUE
        ENDIF
  330 CONTINUE

C...Finish off with standard hadronization.
C...Note that the R-hadrons are not affected here, since they
C...(deliberately erroneously) have been bookkept as decayed.
      CALL PYEXEC

C...Restore code of gluino-hadrons to non-fragmented numbers.
      N6=0
      N7=0
      DO 340 I=1,N
        IF(K(I,1).EQ.16.OR.K(I,1).EQ.17) K(I,1)=K(I,1)-10
        IF(K(I,1).EQ.6) N6=N6+1
        IF(K(I,1).EQ.7) N7=N7+1
  340 CONTINUE
      IF(N6.GT.1.OR.N7.GT.1) MSTU(24)=1

C...Extracheck charge.
      CHGNEW=PYP(0,6)
      IF(ABS(CHGNEW-CHGSAV).GT.0.1D0) MSTU(24)=1

C...In case of trouble, make up to five attempts.
      IF(MSTU(24).NE.0.AND.LOOP.LT.5) THEN
        WRITE(*,*) '     ...give it new try...'
        MSTU(23)=MSTU(23)-1
        GOTO 90
      ELSEIF(MSTU(24).NE.0) THEN
        WRITE(*,*) '     ...but still fail after repeated attempts!'
      ELSEIF(MSTU(24).EQ.0.AND.LOOP.GT.1) THEN
        WRITE(*,*) '     ...and now it worked!'
      ENDIF

C...Finished. Restore baryon production model.
      MSTJ(12)=MSTJ12
      
      RETURN
      END
 
C*********************************************************************
 
C...PYGLDC
C...Decays the gluino inside a gluino-hadron.
 
      SUBROUTINE PYGLDC
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/

C...Optional offset of constituent quark/diquark mass,
C...representing gluon cloud around gluino not part of the decay.
      PMOFF = 0.2D0

C...The probability that it has spin 1.
C...(Except for identical flavours, where spin 1 is only possibility.)
C...(Recall that all R-baryon codes were given as if spin 1, sloppily.)
      PROBS1=0.5D0

C...Loop through to find R-hadrons.
      DO 150 I=1,N
C...If only one of the R-hadrons should decay inside the detector, 
C...you could here pick at random whether to allow the one with 
C...K(I,1) = 6 or the one with =7. (Where the random choice of course
C...could depend on the position of an imagined displaced vertex.)
        IF(K(I,1).EQ.6.OR.K(I,1).EQ.7) THEN

C...Begin resolve R-hadron flavour content to q + qbar or q + qq.
          KFRH=(IABS(K(I,2))-KSUSY1)/10
C...Gluino - g : split g to u ubar or d dbar.
          IF(KFRH.LT.100) THEN
            KF1=1+INT(0.5D0+PYR(0))             
            KF2=-KF1
          ELSEIF(KFRH.LT.1000) THEN
C...Gluino-meson: split to q + qbar.
            KFRH=KFRH-900
            KF1=KFRH/10
            KF2=-MOD(KFRH,10)
            IF(MOD(KF1,2).EQ.1) THEN
              KF1=MOD(KFRH,10)
              KF2=-KFRH/10
            ENDIF
c...Gluino-baryon: split to q + qq (diquark). Pick diquark at random.
          ELSE 
            KFRH=KFRH-9000
            KFA=KFRH/100
            KFB=MOD(KFRH/10,10) 
            KFC=MOD(KFRH,10)
            RDIQ=3D0*PYR(0)
            IF(RDIQ.LT.1D0) THEN
              KF1=KFA
              KF2=1000*KFB+100*KFC+3
              IF(KFB.NE.KFC.AND.PROBS1.LT.PYR(0)) KF2=KF2-2
            ELSEIF(RDIQ.LT.2D0) THEN
              KF1=KFB
              KF2=1000*KFA+100*KFC+3
              IF(KFA.NE.KFC.AND.PROBS1.LT.PYR(0)) KF2=KF2-2
            ELSE
              KF1=KFC
              KF2=1000*KFA+100*KFB+3
              IF(KFA.NE.KFB.AND.PROBS1.LT.PYR(0)) KF2=KF2-2
            ENDIF
          ENDIF
C...Flip for anti-R-hadron. 
          IF(K(I,2).LT.0) THEN
            KFSV=KF1
            KF1=-KF2
            KF2=-KFSV
          ENDIF 

C...Subdivide R-hadron into gluino + 2 light (di)quarks in new slots. 
          DO 120 I1=N+1,N+3
            K(I1,1)=3
            K(I1,3)=I
            K(I1,4)=0
            K(I1,5)=0
            DO 110 J=1,5
              V(I1,J)=0D0
  110       CONTINUE
  120     CONTINUE 

C...Store new flavours.
          K(N+1,2)=KSUSY1+21
          K(N+2,2)=KF1
          K(N+3,2)=KF2

C...Set up colour flow.
          K(N+1,4)=MSTU(5)*(N+3) 
          K(N+1,5)=MSTU(5)*(N+2) 
          K(N+2,4)=MSTU(5)*(N+1) 
          K(N+3,5)=MSTU(5)*(N+1)

C...Define effective quark/diquark masses.
          MSTJ(93)=1 
          PM1=PYMASS(KF1)+PMOFF         
          MSTJ(93)=1 
          PM2=PYMASS(KF2)+PMOFF         
         
C...Share gluino"hadron" momentum with two light quarks.
          FAC1=PM1/P(I,5)
          FAC2=PM2/P(I,5)
          DO 130 J=1,5
            P(N+1,J)=(1D0-FAC1-FAC2)*P(I,J)
            P(N+2,J)=FAC1*P(I,J)
            P(N+3,J)=FAC2*P(I,J)
  130     CONTINUE

C...If you want a displaced vertex, you could also write that info
C...into the V array, but you have to calculate that vertex yourself.

C...Mark R-hadron decayed and update number counter.
          K(I,1)=K(I,1)+10
          K(I,4)=N+1
          K(I,5)=N+3
          N=N+3

C...Let gluino decay now.
          CALL PYRESD(N-2)

C...End of loop over two R-hadrons.
        ENDIF
 150  CONTINUE

C...And then the decay products can fragment, etc.
      CALL PYEXEC

    
      RETURN
      END       

C...Long example how to interface user-defined processes to PYTHIA
C...based on the Les Houches commonblock agreement. Generates events 
C...of several different kinds, to test the new code under varied 
C...conditions, but kinematics selection and cross sections are
C...completely unphysical.

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
 
C...Standard PYTHIA commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...Extra commonblock to transfer run info.
      COMMON/PRIV/MODE,NLIM  

C...Local arrays.
      DIMENSION IPRID(100)

C...Switch process mode; agrees with IDWTUP code (+-1,+-2,+-3,+-4).
      MODE=-2

C...Simulate limited suppy of events of Wbb kind.
      NLIM=10000

C...Maximum number of events to generate.
      NEV=10000

C...Set pi0 stable to trim event listings.
      MDCY(PYCOMP(111),1)=0

C...Expanded event listing (required for histogramming).
      MSTP(125)=2

C...Histograms.
      CALL PYBOOK(1,'charged multiplicity',100,-1D0,399D0)
      CALL PYBOOK(2,'starting virtualities, 2 -> 2',100,0D0,200D0)
      CALL PYBOOK(3,'starting virtualities, 2 -> 3',100,0D0,200D0)
      CALL PYBOOK(4,'starting virtualities, 2 -> 4',100,0D0,200D0)
      CALL PYBOOK(5,'starting virtualities, 2 -> 5',100,0D0,200D0)
      CALL PYBOOK(6,'starting virtualities, 2 -> 6',100,0D0,200D0)
      CALL PYBOOK(7,'starting virtualities, 2 -> 7',100,0D0,200D0)

C...Initialize with external process.
      CALL PYINIT('USER',' ',' ',0D0)
      NACC=0
      NPRID=0

C...Event loop; generate event; check it was obtained or quit.
      DO 130 IEV=1,NEV
        CALL PYEVNT
        IF(MSTI(51).EQ.1) GOTO 140  
        NACC=NACC+1

C...List one event of each new type.
        ISUB=MSTI(1)
        IAGR=0
        DO 100 I=1,NPRID
          IF(ISUB.EQ.IPRID(I)) IAGR=I
  100   CONTINUE
        IF(IAGR.EQ.0) THEN
          NPRID=NPRID+1
          IPRID(NPRID)=ISUB
          CALL PYLIST(7)
          CALL PYLIST(2)
        ENDIF
 
C...Analyze events. End of event loop.
        IF(IDPRUP.GE.212.AND.IDPRUP.LE.217) THEN
          NGLU=MOD(IDPRUP,10)
          ICM=0
          DO 110 I=1,N
            IF(K(I,2).EQ.94) ICM=I
  110     CONTINUE
          IF(ICM.NE.0) THEN
            DO 120 I=1,NGLU
              CALL PYFILL(NGLU,P(ICM+I,5),XWGTUP)
  120       CONTINUE
          ENDIF
        ENDIF  
        CALL PYEDIT(3)
        CALL PYFILL(1,DBLE(N),1D0)
  130 CONTINUE

C...Statistics and histograms.
  140 CALL PYSTAT(1)
      CALL PYHIST

      END
   
C*********************************************************************
 
C...UPINIT
C...Routine to be called by user to set up user-defined processes.
C...Code below only intended as example, without any claim of realism.
C...Especially it shows what info needs to be put in HEPRUP.
 
      SUBROUTINE UPINIT
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...Extra commonblock to transfer run info.
      COMMON/PRIV/MODE,NLIM   
      SAVE/PRIV/

C....Pythia commonblock - needed for setting PDF's; see below.
C      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C      SAVE /PYPARS/      

C...Set incoming beams: Tevatron Run II.
      IDBMUP(1)=2212
      IDBMUP(2)=-2212
      EBMUP(1)=1000D0
      EBMUP(2)=1000D0

C...Set PDF's of incoming beams: CTEQ 5L.
C...Note that Pythia will not look at PDFGUP and PDFSUP.  
      PDFGUP(1)=4
      PDFSUP(1)=46
      PDFGUP(2)=PDFGUP(1)
      PDFSUP(2)=PDFSUP(1)
      
C...If you want Pythia to use PDFLIB, you have to set it by hand.
C...(You also have to ensure that the dummy routines
C...PDFSET, STRUCTM and STRUCTP in Pythia are not linked.)      
C      MSTP(52)=2
C      MSTP(51)=1000*PDFGUP(1)+PDFSUP(1)

C...Decide on weighting strategy: unweighted on input.
      IDWTUP=MODE

C...Number of external processes. 
      NPRUP=9

C...Set up q qbar -> t tbar.
      XSECUP(1)=0.6D0
      XMAXUP(1)=0.8D0
      LPRUP(1)=661

C...Set up g g -> t tbar.
      XSECUP(2)=0.06D0
      XMAXUP(2)=0.15D0
      LPRUP(2)=662

C...Set up u dbar -> W+ b bbar.
      XSECUP(3)=0.5D0
      XMAXUP(3)=0.5D0
      LPRUP(3)=2455

C...Set up g g -> 2 to 7 gluons.
      DO 100 IPR=4,9
        XSECUP(IPR)=0.1D0
        XMAXUP(IPR)=1D0
        LPRUP(IPR)=208+IPR
  100 CONTINUE

C...Negative weights for some processes.
      MODEA=IABS(MODE)
      DO 110 I=1,9
        IF(MODE.LT.0.AND.MOD(I,2).EQ.0) THEN
          XSECUP(I)=-XSECUP(I)
          XMAXUP(I)=-XMAXUP(I)
        ENDIF

C...In some modes XSECUP or XMAXUP need not be given.
        IF(MODEA.EQ.1.OR.MODEA.EQ.4) XSECUP(I)=0D0
        IF(MODEA.EQ.3.OR.MODEA.EQ.4) XMAXUP(I)=0D0
  110 CONTINUE
        

      RETURN
      END
 
C*********************************************************************
 
C...UPEVNT
C...Sample routine to generate events of various kinds.
C...Not intended to be realistic, but rather to show in closed
C...and understandable form what such a routine might look like.
C...Especially it shows what info needs to be put in HEPEUP.
 
      SUBROUTINE UPEVNT
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)

C...Extra commonblock to transfer run info.
      COMMON/PRIV/MODE,NLIM   
      SAVE/PRIV/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C...If PYTHIA is supposed to select event type, do not modify this choice.
      IF(IABS(MODE).LE.2) THEN

C...Else free hands to mix; here evenly.
      ELSE  
        IPYR=1+MIN(8,INT(9D0*PYR(0)))
        IF(IPYR.LE.2) THEN
          IDPRUP=660+IPYR
        ELSEIF(IPYR.EQ.3) THEN
          IDPRUP=2455
        ELSE
          IDPRUP=208+IPYR
        ENDIF 
      ENDIF

C...Call the respective routine to generate event.
      IF(IDPRUP.EQ.661.OR.IDPRUP.EQ.662) THEN
        CALL MYTTB
      ELSEIF(IDPRUP.EQ.2455) THEN
        CALL MYWBB
      ELSEIF(IDPRUP.GE.212.AND.IDPRUP.LE.217) THEN
        CALL MYGLU
      ELSE
        WRITE(*,*) 'Fatal error! Unknown process',IDPRUP 
        STOP  
      ENDIF

C...Ensure proper normalization of weights for MODE=+-3
      IF(MODE.EQ.3) THEN
        XWGTUP=1D0
      ELSEIF(MODE.EQ.-3) THEN
        XWGTUP=SIGN(1D0,XWGTUP)
      ENDIF   

      RETURN
      END 
 
C*********************************************************************
 
C...MYTTB
C...Sample routine to generate q qbar or g + g -> t tbar events.
C...Not intended to be realistic
 
      SUBROUTINE MYTTB
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      PARAMETER (PI=3.141592653589793D0)

C...Extra commonblock to transfer run info.
      COMMON/PRIV/MODE,NLIM   
      SAVE/PRIV/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C...PYTHIA commonblock.  
      COMMON/PYINT1/MINT(400),VINT(400)

C...CM energy of system.
      ECM=VINT(1)

C...Input (to be provided from common block eventually).
C...Top mass and Breit-Wigner parameters.
      PMTOP=175D0
      PWTOP=1.5D0
      PMTOPL=150D0
      PMTOPU=200D0
C....W mass and Breit-Wigner parameters. 
      PMW=80.4D0
      PWW=2.1D0
      PMWL=60D0
      PMWU=100D0
C....b mass.
      PMB=4.5D0 

C...Zero some arrays in common blocks to simplify filling.
      NUP=12
      DO 100 I=1,NUP
        MOTHUP(1,I)=0
        MOTHUP(2,I)=0
        ICOLUP(1,I)=0
        ICOLUP(2,I)=0
        SPINUP(I)=9D0
        PUP(1,I)=0D0    
        PUP(2,I)=0D0    
        PUP(5,I)=0D0
        VTIMUP(I)=1D0
  100 CONTINUE

C...Generate top and antitop masses according to Breit-Wigners.
      ATL=ATAN((PMTOPL**2-PMTOP**2)/(PMTOP*PWTOP))
      ATU=ATAN((PMTOPU**2-PMTOP**2)/(PMTOP*PWTOP))
      PMBW=PMTOP**2+PMTOP*PWTOP*TAN(ATL+PYR(0)*(ATU-ATL))
      PMT1=MIN(PMTOPU,MAX(PMTOPL,SQRT(MAX(0D0,PMBW))))
      PMBW=PMTOP**2+PMTOP*PWTOP*TAN(ATL+PYR(0)*(ATU-ATL))
      PMT2=MIN(PMTOPU,MAX(PMTOPL,SQRT(MAX(0D0,PMBW))))
          
C...Generate flavour, tau and y of q qbar or g g  pair. 
  110 CONTINUE
      IFL=MAX(1,MIN(3,INT(1D0+2.2D0*PYR(0))))
      IF(PYR(0).LT.0.2D0) IFL=-IFL
      IF(IDPRUP.EQ.662) IFL=21 
      TAUMIN=(PMT1+PMT2)**2/ECM**2
      TAU=TAUMIN**PYR(0)  
      YMAX=-0.5D0*LOG(TAU)
      Y=YMAX*(2D0*PYR(0)-1D0)
      X1=SQRT(TAU)*EXP(Y)
      X2=SQRT(TAU)*EXP(-Y)
      
C...Generate scattering angles; translate to Mandelstam variables.
      COSTHE=2D0*PYR(0)-1D0
      SHAT=TAU*ECM**2
      BETA34=SQRT(MAX(0D0,(1D0-PMT1**2/SHAT-PMT2**2/SHAT)**2-
     &4D0*(PMT1**2/SHAT)*(PMT2**2/SHAT)))
      THAT=-0.5D0*(SHAT-PMT1**2-PMT2**2-SHAT*BETA34*COSTHE)
      UHAT=-0.5D0*(SHAT-PMT1**2-PMT2**2+SHAT*BETA34*COSTHE)
      PT2HAT=0.25D0*SHAT*BETA34**2*(1D0-COSTHE**2)

C...Here is excellent place to evaluate parton densities and
C...matrix elements. This is currently not done, except primitively.
C...If you want unweighted events, goto 100 in case of failure,
C...else carry along weight as part of event weight.
      IF(IFL.NE.21) THEN   
        WT=(1D0-X1)**3*(1D0-X2)**6
      ELSE
        WT=(1D0-X1)**4*(1D0-X2)**7
      ENDIF
      IF(WT.LT.PYR(0)) GOTO 110 

C...Set up flavour and history of q + qbar or g + g -> t + tbar. 
      IDUP(1)=IFL
      IDUP(2)=-IFL
      IF(IFL.EQ.21) IDUP(2)=IFL
      IDUP(3)=6
      IDUP(4)=-6 
      ISTUP(1)=-1
      ISTUP(2)=-1
      ISTUP(3)=2
      ISTUP(4)=2
      MOTHUP(1,3)=1
      MOTHUP(2,3)=2
      MOTHUP(1,4)=1
      MOTHUP(2,4)=2

C...Set up colour of g +g or q + qbar -> t + tbar. 
      IF(IFL.EQ.21) THEN
        ICOLUP(1,1)=101
        ICOLUP(2,2)=102
        ICOLUP(2,1)=109
        ICOLUP(1,2)=109
      ELSEIF(IFL.GT.0) THEN
        ICOLUP(1,1)=101
        ICOLUP(2,2)=102
      ELSE
        ICOLUP(2,1)=102
        ICOLUP(1,2)=101
      ENDIF         
      ICOLUP(1,3)=101
      ICOLUP(2,4)=102

C...Set up kinematics of q + qbar -> t + tbar. 
      PHI=2D0*PI*PYR(0)
      PUP(4,1)=0.5D0*X1*ECM
      PUP(3,1)=PUP(4,1)
      PUP(4,2)=0.5D0*X2*ECM
      PUP(3,2)=-PUP(4,2)
      PUP(1,3)=SQRT(PT2HAT)*COS(PHI)  
      PUP(2,3)=SQRT(PT2HAT)*SIN(PHI)  
      PUP(3,3)=0.5D0*SQRT(SHAT)*BETA34*COSTHE
      PUP(4,3)=0.5D0*(SHAT+PMT1**2-PMT2**2)/SQRT(SHAT)  
      PUP(5,3)=PMT1
      PUP(1,4)=-PUP(1,3)  
      PUP(2,4)=-PUP(2,3)  
      PUP(3,4)=-PUP(3,3)  
      PUP(4,4)=0.5D0*(SHAT+PMT2**2-PMT1**2)/SQRT(SHAT)  
      PUP(5,4)=PMT2
      CALL BSTUP(3,4,0D0,0D0,(X1-X2)/(X1+X2))

C...Generate W+- masses according to Breit-Wigners.
      AWL=ATAN((PMWL**2-PMW**2)/(PMW*PWW))
      AWU=ATAN((PMWU**2-PMW**2)/(PMW*PWW))
      PMBW=PMW**2+PMW*PWW*TAN(AWL+PYR(0)*(AWU-AWL))
      PMW1=MIN(PMWU,MAX(PMWL,SQRT(MAX(0D0,PMBW))))
      PMBW=PMW**2+PMW*PWW*TAN(AWL+PYR(0)*(AWU-AWL))
      PMW2=MIN(PMWU,MAX(PMWL,SQRT(MAX(0D0,PMBW))))

C...Set up flavour, history  and colour of two t -> b + W decays.  
      IDUP(5)=5
      IDUP(6)=24
      IDUP(7)=-5
      IDUP(8)=-24
      ISTUP(5)=1
      ISTUP(6)=2
      ISTUP(7)=1
      ISTUP(8)=2
      MOTHUP(1,5)=3
      MOTHUP(1,6)=3
      MOTHUP(1,7)=4
      MOTHUP(1,8)=4
      ICOLUP(1,5)=101
      ICOLUP(2,7)=102

C...Set up flavour, history  and colour of two W -> u dbar decays.
      IDUP(9)=2
      IDUP(10)=-1 
      IDUP(11)=-2
      IDUP(12)=1 
      ISTUP(9)=1
      ISTUP(10)=1
      ISTUP(11)=1
      ISTUP(12)=1
      MOTHUP(1,9)=6
      MOTHUP(1,10)=6
      MOTHUP(1,11)=8
      MOTHUP(1,12)=8
      ICOLUP(1,9)=103
      ICOLUP(2,10)=103
      ICOLUP(2,11)=104
      ICOLUP(1,12)=104

C...Construct top decay kinematics isotropically in angle and boost. 
  120 COSTHE=2D0*PYR(0)-1D0
      PHI=2D0*PI*PYR(0)
      PABS=0.5D0*SQRT((PMT1**2-PMW1**2-PMB**2)**2-4D0*PMW1**2*PMB**2)/
     &PMT1
      PUP(1,5)=PABS*SQRT(1D0-COSTHE**2)*COS(PHI)
      PUP(2,5)=PABS*SQRT(1D0-COSTHE**2)*SIN(PHI)
      PUP(3,5)=PABS*COSTHE
      PUP(4,5)=0.5D0*(PMT1**2+PMB**2-PMW1**2)/PMT1
      PUP(5,5)=PMB
      PUP(1,6)=-PUP(1,5)
      PUP(2,6)=-PUP(2,5)
      PUP(3,6)=-PUP(3,5)
      PUP(4,6)=0.5D0*(PMT1**2+PMW1**2-PMB**2)/PMT1
      PUP(5,6)=PMW1
      CALL BSTUP(5,6,PUP(1,3)/PUP(4,3),PUP(2,3)/PUP(4,3),
     &PUP(3,3)/PUP(4,3)) 
      COSTHE=2D0*PYR(0)-1D0
      PHI=2D0*PI*PYR(0)
      PABS=0.5D0*SQRT((PMT2**2-PMW2**2-PMB**2)**2-4D0*PMW2**2*PMB**2)/
     &PMT2
      PUP(1,7)=PABS*SQRT(1D0-COSTHE**2)*COS(PHI)
      PUP(2,7)=PABS*SQRT(1D0-COSTHE**2)*SIN(PHI)
      PUP(3,7)=PABS*COSTHE
      PUP(4,7)=0.5D0*(PMT2**2+PMB**2-PMW2**2)/PMT2
      PUP(5,7)=PMB
      PUP(1,8)=-PUP(1,7)
      PUP(2,8)=-PUP(2,7)
      PUP(3,8)=-PUP(3,7)
      PUP(4,8)=0.5D0*(PMT2**2+PMW2**2-PMB**2)/PMT2
      PUP(5,8)=PMW2
      CALL BSTUP(7,8,PUP(1,4)/PUP(4,4),PUP(2,4)/PUP(4,4),
     &PUP(3,4)/PUP(4,4)) 

C...Construct W decay kinematics isotropically in angle and boost. 
      COSTHE=2D0*PYR(0)-1D0
      PHI=2D0*PI*PYR(0)
      PUP(1,9)=0.5D0*PMW1*SQRT(1D0-COSTHE**2)*COS(PHI)
      PUP(2,9)=0.5D0*PMW1*SQRT(1D0-COSTHE**2)*SIN(PHI)
      PUP(3,9)=0.5D0*PMW1*COSTHE
      PUP(4,9)=0.5D0*PMW1
      PUP(1,10)=-PUP(1,9)
      PUP(2,10)=-PUP(2,9)
      PUP(3,10)=-PUP(3,9)
      PUP(4,10)=PUP(4,9)
      CALL BSTUP(9,10,PUP(1,6)/PUP(4,6),PUP(2,6)/PUP(4,6),
     &PUP(3,6)/PUP(4,6)) 
      COSTHE=2D0*PYR(0)-1D0
      PHI=2D0*PI*PYR(0)
      PUP(1,11)=0.5D0*PMW2*SQRT(1D0-COSTHE**2)*COS(PHI)
      PUP(2,11)=0.5D0*PMW2*SQRT(1D0-COSTHE**2)*SIN(PHI)
      PUP(3,11)=0.5D0*PMW2*COSTHE
      PUP(4,11)=0.5D0*PMW2
      PUP(1,12)=-PUP(1,11)
      PUP(2,12)=-PUP(2,11)
      PUP(3,12)=-PUP(3,11)
      PUP(4,12)=PUP(4,11)
      CALL BSTUP(11,12,PUP(1,8)/PUP(4,8),PUP(2,8)/PUP(4,8),
     &PUP(3,8)/PUP(4,8)) 

C...Now all decay kinematics is known. Here is excellent place to
C...insert weighting of the decay angle correlations.  
C...If you want unweighted events, goto 120 in case of failure.
      IF(IDPRUP.EQ.661) THEN
        XWGTUP=1D0
      ELSE
        XWGTUP=0.2D0   
        IF(MODE.LT.0) XWGTUP=-0.2D0
      ENDIF  

C...Some other compulsory quantities.
      SCALUP=PMTOP

      RETURN
      END
 
C*********************************************************************
 
C...MYWBB
C...Sample routine to generate u dbar -> W+ b bbar events.
C...Not intended to be realistic
 
      SUBROUTINE MYWBB
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      PARAMETER (PI=3.141592653589793D0)

C...Extra commonblock to transfer run info.
      COMMON/PRIV/MODE,NLIM   
      SAVE/PRIV/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/   

C...PYTHIA commonblock.  
      COMMON/PYINT1/MINT(400),VINT(400)

C...Event number counter.
      DATA ILIM/0/

C...CM energy of system.
      ECM=VINT(1)

C...Simulate limited supply of events.
      ILIM=ILIM+1
      IF(ILIM.GT.NLIM) THEN
        WRITE(*,*) 'No more Wbb events!'
        NUP=0  
        RETURN
      ENDIF

C...Input (to be provided from common block eventually).
C....W mass and Breit-Wigner parameters. 
      PMW=80.4D0
      PWW=2.1D0
      PMWL=60D0
      PMWU=100D0
C....b mass.
      PMB=4.5D0 
          
C...Zero some arrays in common blocks to simplify filling.
      NUP=5
      DO 100 I=1,NUP
        MOTHUP(1,I)=0
        MOTHUP(2,I)=0
        ICOLUP(1,I)=0
        ICOLUP(2,I)=0
        SPINUP(I)=9D0
        PUP(1,I)=0D0    
        PUP(2,I)=0D0    
        PUP(5,I)=0D0
        VTIMUP(I)=0D0
  100 CONTINUE

C...Set up flavour and history of u dbar -> W+ b bbar. 
      IDUP(1)=2
      IDUP(2)=-1
      IDUP(3)=24
      IDUP(4)=5 
      IDUP(5)=-5 
      ISTUP(1)=-1
      ISTUP(2)=-1
      ISTUP(3)=1
      ISTUP(4)=1
      ISTUP(5)=1
      MOTHUP(1,3)=1
      MOTHUP(2,3)=2
      MOTHUP(1,4)=1
      MOTHUP(2,4)=2
      MOTHUP(1,5)=1
      MOTHUP(2,5)=2

C...Set up colour of u dbar -> W+ b bbar.  
      ICOLUP(1,1)=101
      ICOLUP(1,4)=101
      ICOLUP(2,2)=102
      ICOLUP(2,5)=102

C...Set up kinematics of b and bbar.
      PTBMX=50D0
      DO 120 I=4,5
        PUP(5,I)=PMB
        RR=PYR(0)
        PTB=PMB*PTBMX*SQRT(RR/(PMB**2+(1D0-RR)*PTBMX**2))
        PHIB=2D0*PI*PYR(0)
        PUP(1,I)=PTB*COS(PHIB) 
        PUP(2,I)=PTB*SIN(PHIB) 
        PUP(3,I)=100D0*(2D0*PYR(0)-1D0)
        PUP(4,I)=SQRT(PUP(1,I)**2+PUP(2,I)**2+PUP(3,I)**2+PUP(5,I)**2)
  120 CONTINUE

C...Generate W+ mass according to Breit-Wigner.
      AWL=ATAN((PMWL**2-PMW**2)/(PMW*PWW))
      AWU=ATAN((PMWU**2-PMW**2)/(PMW*PWW))
      PMBW=PMW**2+PMW*PWW*TAN(AWL+PYR(0)*(AWU-AWL))
      PUP(5,3)=MIN(PMWU,MAX(PMWL,SQRT(MAX(0D0,PMBW))))

C...Set up kinematics of W+.
      PUP(1,3)=-PUP(1,4)-PUP(1,5)   
      PUP(2,3)=-PUP(2,4)-PUP(2,5)   
      PUP(3,3)=100D0*(2D0*PYR(0)-1D0)
      PUP(4,3)=SQRT(PUP(1,3)**2+PUP(2,3)**2+PUP(3,3)**2+PUP(5,3)**2)

C...Set up kinematics of incoming u dbar.
      ESUM=PUP(4,3)+PUP(4,4)+PUP(4,5)
      PZSUM=PUP(3,3)+PUP(3,4)+PUP(3,5)
      PUP(4,1)=0.5D0*(ESUM+PZSUM)
      PUP(4,2)=0.5D0*(ESUM-PZSUM)
      PUP(3,1)=PUP(4,1) 
      PUP(3,2)=-PUP(4,2) 

C...Now all decay kinematics is known. Fictitious weight.
      XWGTUP=PYR(0)

C...Some other compulsory quantities.
      SCALUP=PMW

      RETURN
      END
 
C*********************************************************************
 
C...MYGLU
C...Sample routine to generate g g -> 2 to 7 gluons.
C...Not intended to be realistic.
 
      SUBROUTINE MYGLU
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      PARAMETER (PI=3.141592653589793D0)

C...Extra commonblock to transfer run info.
      COMMON/PRIV/MODE,NLIM   
      SAVE/PRIV/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C...PYTHIA commonblock.  
      COMMON/PYINT1/MINT(400),VINT(400)

C...Local arrays.
      DIMENSION PSUM(4)

C...Number of gluons.
      NGLU=MOD(IDPRUP,10)

C...CM energy of system.
      ECM=VINT(1)
          
C...Zero some arrays in common blocks to simplify filling.
      NUP=NGLU+2
      DO 110 I=1,NUP          
        IDUP(I)=21
        MOTHUP(1,I)=0
        MOTHUP(2,I)=0
        ICOLUP(1,I)=0
        ICOLUP(2,I)=0
        SPINUP(I)=9D0
        PUP(1,I)=0D0    
        PUP(2,I)=0D0    
        PUP(5,I)=0D0
        VTIMUP(I)=0D0
  110 CONTINUE

C...Pick scattering subsystem energy. 
      EHAT=MAX(10D0,0.9D0*ECM*PYR(0)**2)

C...Set up mothers.
      ISTUP(1)=-1
      ISTUP(2)=-1
      PUP(4,1)=0.5D0*EHAT
      PUP(4,2)=0.5D0*EHAT
      PUP(3,1)=PUP(4,1)
      PUP(3,2)=-PUP(4,2)

C...Pick outgoing momenta for daughters, and set mother pointers.
      DO 120 J=1,4
        PSUM(J)=0D0
  120 CONTINUE  
      DO 140 I=3,NUP
        ISTUP(I)=1
        MOTHUP(1,I)=1
        MOTHUP(2,I)=2 
        PABS=-LOG(PYR(0)*PYR(1))
        CTHE=2D0*PYR(0)-1D0
        STHE=SQRT(MAX(0D0,1D0-CTHE**2))
        PHI=2D0*PI*PYR(0)
        PUP(1,I)=PABS*STHE*COS(PHI)
        PUP(2,I)=PABS*STHE*SIN(PHI)
        PUP(3,I)=PABS*CTHE
        PUP(4,I)=PABS
        DO 130 J=1,4
          PSUM(J)=PSUM(J)+PUP(J,I)
  130   CONTINUE  
  140 CONTINUE 

C...Boost to rest frame and rescale.
      CALL BSTUP(3,NUP,-PSUM(1)/PSUM(4),-PSUM(2)/PSUM(4),
     &-PSUM(3)/PSUM(4))
      ESUM=0D0
      DO 150 I=3,NUP
        ESUM=ESUM+PUP(4,I)
  150 CONTINUE
      FAC=EHAT/ESUM
      DO 170 I=3,NUP
        DO 160 J=1,4
          PUP(J,I)=FAC*PUP(J,I)
  160   CONTINUE  
  170 CONTINUE 
   
C...Pick rapidity and do boost.
      YMAX=LOG(ECM/EHAT)
  180 Y=(2D0*PYR(0)-1D0)*YMAX
      IF((1-ABS(Y)/YMAX)**2.LT.PYR(0)) GOTO 180
      BETAZ=(EXP(2D0*Y)-1D0)/(EXP(2D0*Y)+1D0) 
      CALL BSTUP(1,NUP,0D0,0D0,BETAZ)      

C...Now all decay kinematics is known. Here is excellent place to
C...insert weighting of the decay angle correlations.  
      XWGTUP=PYR(0)**NGLU

C...Simulate negative weights.
      IF(MODE.LT.0.AND.MOD(NGLU,2).EQ.0) XWGTUP=-XWGTUP 

C...Set colour flow.
      ICOLUP(2,1)=501
      ICOLUP(1,2)=501
      ICOLUP(1,1)=502
      ICOLUP(1,3)=502
      ICOLUP(2,2)=503
      ICOLUP(2,NUP)=503
      DO 190 I=3,NUP-1
        ICOLUP(2,I)=501+I
        ICOLUP(1,I+1)=501+I
  190 CONTINUE            

C...Some other compulsory quantities.
      SCALUP=EHAT/NGLU

      RETURN
      END
 
C*********************************************************************
 
C...BSTUP
C...Performs boosts on user-process entries.
 
      SUBROUTINE BSTUP(IMIN,IMAX,BETAX,BETAY,BETAZ)
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/   
 
C...Boost, typically from rest to momentum/energy=beta.
      GAMMA=1D0/SQRT(1D0-BETAX**2-BETAY**2-BETAZ**2)
      DO 100 I=IMIN,IMAX
        BETAP=BETAX*PUP(1,I)+BETAY*PUP(2,I)+BETAZ*PUP(3,I)
        GABEP=GAMMA*(GAMMA*BETAP/(1D0+GAMMA)+PUP(4,I))
        PUP(1,I)=PUP(1,I)+GABEP*BETAX
        PUP(2,I)=PUP(2,I)+GABEP*BETAY
        PUP(3,I)=PUP(3,I)+GABEP*BETAZ
        PUP(4,I)=GAMMA*(PUP(4,I)+BETAP)
  100 CONTINUE
 
      RETURN
      END

C...Supersymmetry at a hadron collider.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C-----------------------------------------------------------------

C...First section: initialization.

C...Select generic SUSY generation.
      MSEL=39

C...Set SUSY parameters in SUGRA scenario.
      IMSS(1)=2
      RMSS(1)=200D0
      RMSS(4)=1D0
      RMSS(5)=10D0
      RMSS(8)=800D0
      RMSS(16)=0D0

C...If interested only in cross sections and resonance decays: 
C...switch off initial and final state radiation, 
C...multiple interactions and hadronization.
C      MSTP(61)=0
C      MSTP(71)=0
      MSTP(81)=0
C      MSTP(111)=0 

C...Initialization for the Tevatron or LHC. 
C      CALL PYINIT('CMS','p','pbar',2000D0)
      CALL PYINIT('CMS','p','p',14000D0)

C...List resonance data: decay channels, widths etc.
      CALL PYSTAT(2)

C...Histograms for mass distributions.      
      CALL PYBOOK(1,'top mass',100,0D0,1000D0)
      CALL PYBOOK(2,'squark_L mass',100,0D0,1000D0)
      CALL PYBOOK(3,'squark_R mass',100,0D0,1000D0)
      CALL PYBOOK(4,'sbottom_1 mass',100,0D0,1000D0)
      CALL PYBOOK(5,'sbottom_2 mass',100,0D0,1000D0)
      CALL PYBOOK(6,'stop_1 mass',100,0D0,1000D0)
      CALL PYBOOK(7,'stop_2 mass',100,0D0,1000D0)
      CALL PYBOOK(8,'slepton mass',100,0D0,1000D0)
      CALL PYBOOK(9,'gluino mass',100,0D0,1000D0)
      CALL PYBOOK(10,'chi0_1 mass',100,0D0,1000D0)
      CALL PYBOOK(11,'chi0_2 mass',100,0D0,1000D0)
      CALL PYBOOK(12,'chi0_3 mass',100,0D0,1000D0)
      CALL PYBOOK(13,'chi0_4 mass',100,0D0,1000D0)
      CALL PYBOOK(14,'chi+_1 mass',100,0D0,1000D0)
      CALL PYBOOK(15,'chi+_2 mass',100,0D0,1000D0)

C-----------------------------------------------------------------

C...Second section: event loop.

C...Loop over the number of events.
      DO 200 IEV=1,10000
        IF(MOD(IEV,1000).EQ.0) WRITE(6,*) 
     &  'Now at event number',IEV

C...Event generation.
        CALL PYEVNT

C...List first few events.
          IF(IEV.LE.2) CALL PYLIST(1)

C...Loop though documentation section of event.
        DO 150 I=1,MSTP(126)
          IF(K(I,1).NE.21) GOTO 150 

C...Fill the masses of interesting (s)particles.
          KFA=IABS(K(I,2))
          IH=0
          IF(KFA.EQ.6) IH=1
          IF(KFA.GE.KSUSY1+1.AND.KFA.LE.KSUSY1+4) IH=2
          IF(KFA.GE.KSUSY2+1.AND.KFA.LE.KSUSY2+4) IH=3
          IF(KFA.EQ.KSUSY1+5) IH=4
          IF(KFA.EQ.KSUSY2+5) IH=5
          IF(KFA.EQ.KSUSY1+6) IH=6
          IF(KFA.EQ.KSUSY2+6) IH=7
          IF(KFA.GE.KSUSY1+11.AND.KFA.LE.KSUSY1+16) IH=8
          IF(KFA.GE.KSUSY2+11.AND.KFA.LE.KSUSY2+16) IH=8
          IF(KFA.EQ.KSUSY1+21) IH=9
          IF(KFA.EQ.KSUSY1+22) IH=10
          IF(KFA.EQ.KSUSY1+23) IH=11
          IF(KFA.EQ.KSUSY1+25) IH=12
          IF(KFA.EQ.KSUSY1+35) IH=13
          IF(KFA.EQ.KSUSY1+24) IH=14
          IF(KFA.EQ.KSUSY1+37) IH=15
          IF(IH.NE.0) CALL PYFILL(IH,P(I,5),1D0)

C...End of documentation and event loops.
  150   CONTINUE  
  200 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      CALL PYHIST

      END

      PROGRAM MAIN78

C...Program to produce long-lived ("stable") stop-hadrons 
C...at the Tevatron or LHC.
C...
C...Modified version, implementing the agreed R-hadron codes, e.g.
C...1000612 stop dbar     (stopmeson) 
C...1006211 gluino u d    (stopbaryon)
C...For your pick of naming conventions, see the PYRHAD routine.
C...
C...Note that the R-hadrons are given status codes 6 or 7. This is 
C...for ease to find them, and has no special significance relative 
C...to the normal 1.
C...Modified 2005-06-04 also to allow more massive stops. 
C...Modified 2008-03-12 bookkeeping when string collapses to one.

C******************************************************************

C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Width properties.
      COMMON/PYINT4/MWID(500),WIDS(500,5)
C...Process names.
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
C...Local arrays.
      DIMENSION EPQSUM(6)

C...Number of events, CM energy.
      NEV=1000

C..Initialize stop-R-hadron names, charges, etc.
      CALL PYRHAD

C...Pick stop and gluino masses.
      PMST=200D0
      PMGL=1000D0

C...Pick process.
      MSEL=0
      MSUB(261)=1
      MSUB(264)=1

C...Set necessary SUSY parameters (brute force).
      IMSS(1)=1
C...Gluino mass - of "constituent" mass kind.
      IMSS(3)=1
      RMSS(3)=PMGL
C...Force gluino mass = lightest neutralino (almost).
      RMSS(1)=PMGL
      RMSS(2)=PMGL
      RMSS(4)=5D3
C...Stop_1 and stop_2 masses (ensure m(stop_2) > m(stop_1)).
      IMSS(5)=1
      RMSS(12)=PMST
      RMSS(10)=1.5D0*PMST

C...Convenient shorthand.
      KFST=KSUSY1+6
      KCST=PYCOMP(KFST)

C...Put stop stable. 
      MDCY(KCST,1)=0
      MWID(KCST)=0

C...Initialize: the Tevatron or LHC.
c      ECM=1960D0
c      CALL PYINIT('CMS','p','pbar',ECM)
      ECM=14000D0
      CALL PYINIT('CMS','p','p',ECM)
  
C...Show particle data.
C      CALL PYSTAT(2)
C      CALL PYLIST(12)

C...Switch off hadronization in normal PYEVNT call.
      MSTP(111)=0 

C...Histograms.
      CALL PYBOOK(1,'E-P-Q conservation check',100,0D0,0.0001D0)
      CALL PYBOOK(3,'charged hadron multiplicity (excl. R hadrons)',
     &100,-1D0,399D0)
      CALL PYBOOK(11,'stop squark momentum spectrum',100,0D0,1000D0)
      CALL PYBOOK(12,'stop hadron momentum spectrum',100,0D0,1000D0)
      CALL PYBOOK(13,'stop hadron-squark mass diff',100,-0.5D0,2D0)
 
C...Event generation loop.
      DO 200 IEV=1,NEV
      if(mod(iev,100).eq.0) write(*,*) 'begin event no', iev

C...Generate event, but without without hadronization.
        MSTJ(14)=-1
        CALL PYEVNT
        MSTJ(14)=1
        DO 140 J=1,6
          EPQSUM(J)=PYP(0,J)
 140    CONTINUE

C...Now perform treatment of stop hadronization and the rest.
        CALL PYSTFR(IERR)

C...Skip faulty events.
        IF(IERR.NE.0) GOTO 200

C...List first few events.
        IF(IEV.LE.2) CALL PYLIST(2)

C...Statistics: generic.
        NMERR=0
        EPQ=ABS(PYP(0,4)-EPQSUM(4))+ABS(PYP(0,1)-EPQSUM(1))+
     &  ABS(PYP(0,2)-EPQSUM(2))+ABS(PYP(0,3)-EPQSUM(3))+
     &  ABS(PYP(0,6)-EPQSUM(6))
        IF(EPQ.GT.1D-4) CALL PYFILL(1,EPQ,1D0)
        IF(EPQ.GT.1D-4) NMERR=NMERR+1
        NCH=0
        NSTHAD=0
        DO 160 I=1,N
          DM2=1D0-(P(I,1)**2+P(I,2)**2+P(I,3)**2+P(I,5)**2)/P(I,4)**2
          IF(ABS(DM2).GT.1D-10) THEN
             WRITE(*,*) ' Particle kinematics problem',I,K(I,2),DM2,
     &       P(I,4)
            IF(DM2.GT.1D-4) NMERR=NMERR+1
          ENDIF
          IF(K(I,1).EQ.1.AND.PYCHGE(K(I,2)).NE.0) NCH=NCH+1    
          PABS=SQRT(P(I,1)**2+P(I,2)**2+P(I,3)**2)  

C...Statistics: stop.         
          IF((K(I,1).EQ.11.OR.K(I,1).EQ.12).AND.IABS(K(I,2)).EQ.KFST) 
     &    THEN
            CALL PYFILL(11,PABS,1D0)
          ENDIF
          IF(K(I,1).EQ.6.OR.K(I,1).EQ.7) THEN
            NSTHAD=NSTHAD+1
            CALL PYFILL(12,PABS,1D0)
            PMSTHD=P(I,5)
            IF(PMSTHD.LT.PMST-0.5D0.OR.PMSTHD.GT.PMST+2D0) THEN
              WRITE(*,*) ' Unexpected stop hadron mass = ',PMSTHD
            ELSE
              CALL PYFILL(13,PMSTHD-PMST,1D0)
            ENDIF
          ENDIF
 160    CONTINUE
        CALL PYFILL(3,DBLE(NCH),1D0)
        IF(NSTHAD.NE.2) THEN
          WRITE(*,*) ' Unexpected number of stop hadrons = ',NSTHAD           
          NMERR=1
        ENDIF
        IF(NMERR.GT.0) CALL PYLIST(2)

C...End of event generation loop.
 200  CONTINUE

C...Cross section - not relevant in this case. Histograms.
      CALL PYSTAT(1)      
      CALL PYHIST

      END
 
C*********************************************************************
 
C...PYRHAD
C...Initialize stop_1 R-hadron data, like names (for event listing) 
C...and charges. So far nothing but the minimum required.
C...Feel free to choose between hadron-like names or 
C...flavour-content-based ones.

      SUBROUTINE PYRHAD
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
      SAVE /PYDAT2/,/PYDAT4/

C...Local R-hadron data arrays, to fill into the global ones.
      DIMENSION KFRH(20),KCHGRH(20),KANTRH(20)
      CHARACTER*16 CHRHA(20),CHRHB(20)
C...Codes.
      DATA KFRH/1000612,1000622,1000632,1000642,1000652,1006113,
     &1006211,1006213,1006223,1006311,1006313,1006321,1006323,
     &1006333,6*0/
C...Three times charge.
      DATA KCHGRH/3,0,3,0,3,0,3,3,6,0,0,3,3,0,6*0/
C...Existence of a distinct antiparticle.
      DATA KANTRH/14*1,6*0/
C...One possibility: hadron-like names.
      DATA CHRHA/'~T+','~T0','~T_s+','~T_c0','~T_b+','~T_dd10',
     &'~T_ud0+','~T_ud1+','~T_uu1++','~T_sd00','~T_sd10',
     &'~T_su0+','~T_su1+','~T_ss10',6*' '/
      DATA CHRHB/'~Tbar-','~Tbar0','~Tbar_s-','~Tbar_c0','~Tbar_b-',
     &'~Tbar_dd10','~Tbar_ud0-','~Tbar_ud1-','~Tbar_uu1--',
     &'~Tbar_sd00','~Tbar_sd10','~Tbar_su0-','~Tbar_su1-',
     &'~Tbar_ss10',6*' '/
C...Another possibility: flavour-contents-based names.
C      DATA CHRHA/'~t dbar','~t ubar','~t sbar','~t cbar','~t bbar',
C     &'~t dd1','~t ud0','~t ud1','~t uu1','~t sd0','~t sd1','~t su0',
C     &'~t su1','~t ss1',6*' '/
C      DATA CHRHB/'~tbar d','~tbar u','~tbar s','~tbar c','~tbar b',
C     &'~tbar dd1bar','~tbar ud0bar','~tbar ud1bar','~tbar uu1bar',
C     &'~tbar sd0bar','~tbar sd1bar','~tbar su0bar','~tbar su1bar',
C     &'~tbar ss1bar',6*' '/

C...Fill in data.
      DO 100 I=1,14
        KC=400+I
        KCHG(KC,1)=KCHGRH(I)
        KCHG(KC,2)=0
        KCHG(KC,3)=KANTRH(I)
        KCHG(KC,4)=KFRH(I)
        CHAF(KC,1)=CHRHA(I)
        CHAF(KC,2)=CHRHB(I)
  100 CONTINUE    
  
      RETURN
      END
 
C*********************************************************************
 
C...PYSTFR
C...Fragments the string near to a stop, to form a stop-hadron, 
C...by producing a new q-qbar pair.
 
      SUBROUTINE PYSTFR(IERR)
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/
C...Local array.
      DIMENSION PSUM(5),PSAV(5),IJOIN(2),IPOSST(10) 

C...Default is no error.
      IERR=0
 
C...Free parameter: max kinetic energy in gluino-hadron.
      PMKIN=0.5D0
 
C...Free parameter: part of stop mass that does not participate
C...in weak decay.
      PMINAC=0.5D0

C...Switch off popcorn baryon production. (Not imperative, but more
C...failed events when popcorn is allowed.)
      MSTJ12=MSTJ(12)
      MSTJ(12)=1

C...Convenient shorthand.
      KFST=KSUSY1+6
      KCST=PYCOMP(KFST)
      KFGL=KSUSY1+21

C...Loopback point for serious problems, with new try.
      LOOP=0
      CALL PYEDIT(21)
      CHGSAV=PYP(0,6)
   90 LOOP=LOOP+1
      IF(LOOP.GT.1) CALL PYEDIT(22)

C...Give up when too much problems.
      IF(LOOP.GT.5) THEN
        WRITE(*,*) ' Problematical event skipped'
        IERR=1
        RETURN
      ENDIF

C...Take copy of string system(s).
      NOLD=N
      NSTOP=0
      DO 120 I=1,NOLD
        ICOPY=0
        IF(K(I,1).EQ.2) ICOPY=1
        IF(K(I,1).EQ.1.AND.I.GE.2) THEN
          IF(K(I-1,1).EQ.12) ICOPY=1
        ENDIF
        IF(ICOPY.EQ.1) THEN  
          N=N+1
          DO 100 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  100     CONTINUE
          K(I,1)=K(I,1)+10
          K(I,4)=N
          K(I,5)=N
          K(N,3)=I
          IF(IABS(K(I,2)).EQ.KFST) THEN
            NSTOP=NSTOP+1
            IPOSST(NSTOP)=N
          ENDIF   
        ENDIF
  120 CONTINUE
      NTMP=N

C...Loop over (up to) two stops per event.
C...Identify position of stop (randomize order of treatment).
      IRNST=INT(1.5D0+PYR(0))
      DO 300 ISTOP=1,NSTOP
        IST=IPOSST(1)
        IF(NSTOP.EQ.2.AND.ISTOP.NE.IRNST) IST=IPOSST(2)

C...Identify range of partons on string the stop belongs to. 
        IMIN=IST+1
  140   IMIN=IMIN-1
        IF(K(IMIN-1,1).EQ.2) GOTO 140
        IMAX=IST-1
  150   IMAX=IMAX+1
        IF(K(IMAX,1).EQ.2) GOTO 150
        IOTHER=IMAX
        IF(IST.EQ.IMAX) IOTHER=IMIN  
 
C...Find mass of this stop-string. 
        DO 170 J=1,5
          PSUM(J)=0D0
          DO 160 I=IMIN,IMAX
            PSUM(J)=PSUM(J)+P(I,J)
  160     CONTINUE
  170   CONTINUE
        PSUM(5)=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &  PSUM(3)**2))
 
C...If low-mass, then consider stop-hadron already formed.
        IF(PSUM(5).LE.P(IST,5)+P(IOTHER,5)+PMKIN) THEN

C...New slot at end of record for stop-hadron
          N=N+1
          DO 175 J=1,5
            K(N,J)=0
            P(N,J)=PSUM(J)
            V(N,J)=V(IST,J)
 175     CONTINUE
          K(N,1)=5+ISTOP
          K(N,3)=IST

C...Particle code for stop-hadron in low-mass system.
          KFSTHD=0 
          KFSAV=K(IOTHER,2)
          IF(K(IST,2).GT.0) THEN
            IF(KFSAV.LE.-1.AND.KFSAV.GE.-5) KFSTHD=KSUSY1+600-10*KFSAV+2
            IF(KFSAV.GE.1103.AND.KFSAV.LE.3303) KFSTHD=KSUSY1+6000+
     &      (KFSAV/10)+MOD(KFSAV,10)
          ELSE
            IF(KFSAV.GE.1.AND.KFSAV.LE.5) KFSTHD=KSUSY1+600+10*KFSAV+2
            IF(KFSAV.LE.-1103.AND.KFSAV.GE.-3303) KFSTHD=KSUSY1+6000+
     &      (IABS(KFSAV)/10)+MOD(IABS(KFSAV),10)
            KFSTHD=-KFSTHD
          ENDIF
          IF(KFSTHD.EQ.0) THEN
            WRITE(*,*) ' Failed to find R-hadron code from ',
     &      K(IST,2),KFSAV 
            IERR=1 
            RETURN
          ENDIF
          K(N,2)=KFSTHD

C...Mark original partons decayed. Done for low-mass system. 
          DO 180 I=IMIN,IMAX
            K(I,1)=K(I,1)+10
            K(I,4)=N
            K(I,5)=N
  180     CONTINUE
          GOTO 300
        ENDIF    

C...Else break string by production of new qqbar pair.
C...(Also diquarks allowed, but not popcorn.)
        INFLAV=ISIGN(4,K(IST,2))
        CALL PYDCYK(INFLAV,0,KFSAV,KFDUM)
        KFSAV=ISIGN(MOD(IABS(KFSAV),10000),KFSAV)
        MSTJ(93)=1 
        PMSAV=PYMASS(KFSAV)         

C...Mass of stop-hadron.
        PMSSAV=P(IST,5)
        PMSHAD=P(IST,5)+PMSAV

C...Pick momentum sharing according to fragmentation function as if bottom.
        PMBSAV=PARF(105)
        PARF(105)=PMSSAV
        CALL PYZDIS(5,0,PMSHAD**2,ZST)
        PARF(105)=PMBSAV 
        ZST=MAX(0.9D0,MIN(0.9999D0,ZST)) 
        DO 190 J=1,5
          PSAV(J)=(1D0-ZST)*P(IST,J)
          P(IST,J)=ZST*P(IST,J)
  190  CONTINUE

C...Recoiling parton from which to shuffle momentum. System momentum.
        IF(IST.EQ.IMIN) IREC=IST+1
        IF(IST.EQ.IMAX) IREC=IST-1
  200   DO 210 J=1,4
          PSUM(J)=P(IST,J)+P(IREC,J)
  210   CONTINUE           

C...Boost to rest frame of system, and align stop along +z axis.
        CALL PYROBO(IST,IST,0D0,0D0,-PSUM(1)/PSUM(4),
     &  -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
        CALL PYROBO(IREC,IREC,0D0,0D0,-PSUM(1)/PSUM(4),
     &  -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
        PHI=PYANGL(P(IST,1),P(IST,2))
        CALL PYROBO(IST,IST,0D0,-PHI,0D0,0D0,0D0)
        CALL PYROBO(IREC,IREC,0D0,-PHI,0D0,0D0,0D0)
        THETA=PYANGL(P(IST,3),P(IST,1)) 
        CALL PYROBO(IST,IST,-THETA,0D0,0D0,0D0,0D0)
        CALL PYROBO(IREC,IREC,-THETA,0D0,0D0,0D0,0D0)

C...Calculate new kinematics in this frame, for desired stop hadron mass.
        ETOT=P(IST,4)+P(IREC,4)
        PMREC=P(IREC,5)
        IF(K(IREC,2).NE.21.AND.IABS(K(IREC,2)).NE.KFST) THEN
          MSTJ(93)=1 
          PMREC=PYMASS(K(IREC,2))         
        ENDIF 
        IF(ETOT.GT.PMSHAD+PMREC) THEN
          IFAIL=0
          PZNEW=0.5D0*SQRT(MAX(0D0,(ETOT**2-PMSHAD**2-PMREC**2)**2-
     &    4D0*PMSHAD**2*PMREC**2))/ETOT
          P(IST,3)=PZNEW
          P(IST,4)=SQRT(PZNEW**2+PMSHAD**2)
          P(IST,5)=PMSHAD
          P(IREC,3)=-PZNEW
          P(IREC,4)=SQRT(PZNEW**2+PMREC**2)
          P(IREC,5)=PMREC

C...If not enough momentum, take what can be taken.
        ELSE
          IFAIL=1
          P(IST,3)=0D0
          P(IST,4)=ETOT-PMREC
          P(IST,5)=P(IST,4)
          P(IREC,3)=0D0
          P(IREC,4)=PMREC
          P(IREC,5)=PMREC
        ENDIF

C...Bost back to lab frame.
        CALL PYROBO(IST,IST,THETA,PHI,PSUM(1)/PSUM(4),
     &  PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))
        CALL PYROBO(IREC,IREC,THETA,PHI,PSUM(1)/PSUM(4),
     &  PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))

C...Loop back when not enough momentum could be shuffled.
C...(As long as there is something left.)
        IF(IFAIL.EQ.1) THEN
          IF(IST.EQ.IMIN.AND.IREC.LT.IMAX) THEN
            IREC=IREC+1
            GOTO 200
          ELSEIF(IST.EQ.IMAX.AND.IREC.GT.IMIN) THEN
            IREC=IREC-1
            GOTO 200
          ENDIF
        ENDIF

C...Particle code for stop-hadron.
        KFSTHD=0 
        IF(K(IST,2).GT.0) THEN
          IF(KFSAV.LE.-1.AND.KFSAV.GE.-5) KFSTHD=KSUSY1+600-10*KFSAV+2
          IF(KFSAV.GE.1103.AND.KFSAV.LE.3303) KFSTHD=KSUSY1+6000+
     &    (KFSAV/10)+MOD(KFSAV,10)
        ELSE
          IF(KFSAV.GE.1.AND.KFSAV.LE.5) KFSTHD=KSUSY1+600+10*KFSAV+2
          IF(KFSAV.LE.-1103.AND.KFSAV.GE.-3303) KFSTHD=KSUSY1+6000+
     &    (IABS(KFSAV)/10)+MOD(IABS(KFSAV),10)
          KFSTHD=-KFSTHD
        ENDIF
        IF(KFSTHD.EQ.0) THEN
          WRITE(*,*) ' Failed to find R-hadron code from ',
     &    K(IST,2),KFSAV 
          IERR=1 
          RETURN
        ENDIF

C...New slot at end of record for stop-hadron
        DO 230 J=1,5
          K(N+1,J)=0
          P(N+1,J)=P(IST,J)
          V(N+1,J)=V(IST,J)
  230   CONTINUE
        K(N+1,1)=5+ISTOP
        K(N+1,2)=KFSTHD
        K(N+1,3)=K(IST,3)
        N=N+1
        
C...Code and momentum of new string endpoint.
        K(IST,2)=-KFSAV
        DO 240 J=1,5
          P(IST,J)=PSAV(J)
  240   CONTINUE
 
C...End of loop over two stops.
  300 CONTINUE

C...Cleanup: remove zero-energy gluons.
      NNOW=N
      N=NOLD
      DO 330 I=NOLD+1,NNOW
        IF(K(I,2).EQ.21.AND.P(I,4).LT.1D-10) THEN
        ELSEIF(I.EQ.N+1) THEN
          N=N+1
        ELSE
          N=N+1
          DO 320 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  320     CONTINUE
        ENDIF
  330 CONTINUE
      NNOW=N

C...Check that no low-mass system of diquark-antidiquark kind,
C...or very low-mass of any kind.
      KFBEG=0
      DO 332 J=1,5
        PSUM(J)=0D0
  332 CONTINUE
      DO 338 I=NOLD+1,NNOW
        DO 334 J=1,4
          PSUM(J)=PSUM(J)+P(I,J)
  334   CONTINUE
        IF(KFBEG.EQ.0) THEN
          KFBEG=IABS(K(I,2))
          MSTJ(93)=1 
          PSUM(5)=PSUM(5)+PYMASS(K(I,2))         
        ELSEIF(K(I,1).EQ.1) THEN
          KFEND=IABS(K(I,2))
          MSTJ(93)=1 
          PSUM(5)=PSUM(5)+PYMASS(K(I,2))         
          DELTA=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &    PSUM(3)**2))-PSUM(5)
          IF(KFBEG.GT.10.AND.KFBEG.LT.10000.AND.KFEND.GT.10.AND.
     &    KFEND.LT.10000.AND.DELTA.LT.PARJ(32).AND.(KFBEG.NE.21
     &    .AND.KFEND.NE.21)) GOTO 90
          IF(DELTA.LT.0D0) GOTO 90
          KFBEG=0
          DO 336 J=1,5
            PSUM(J)=0D0
  336     CONTINUE
        ENDIF
  338 CONTINUE

C...Finished with stop hadronization. Restore baryon production model.
      MSTJ(12)=MSTJ12

C...Now hadronize everything else. Some cheating to allow sensible
C...momentum shuffling.
      MSTJ16=MSTJ(16)
      MSTJ(16)=0
      CALL PYEXEC
      MSTJ(16)=MSTJ16
      IF(MSTU(24).NE.0) THEN
        WRITE(*,*) ' Event to be skipped'
        IERR=1 
      ENDIF

      RETURN
      END

      PROGRAM MAIN76
C...Example program to generate stop1 pair production events at LHC, using a 
C...SuSy spectrum calculated by an external RGE code (in this case SoftSusy),
C...input via the SuSy Les Houches Accord, 
C...                                 see http://home.fnal.gov/~skands/slha.
C...DEFAULT INPUT:
C...Spectrum of couplings and masses for SPS1a from SoftSusy. You can of
C...course replace this by any other SLHA spectrum you want to use. Decays 
C...and cross sections are calculated by Pythia. If you wish to use input 
C...from an SLHA file with a decay list, the relevant line below is 
C...included but commented out. Simply uncomment it.
C...NOTE: in its default form, this program assumes the file 'softsusy.spc' 
C...to exist in the current directory (and contain an SLHA spectrum).

C--------------- PREAMBLE: COMMON BLOCK DECLARATIONS ETC -------------
C...All real arithmetic done in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...The PYTHIA event record:
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...PYTHIA MSSM and subprocess common blocks
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C-------------------------- PYTHIA SETUP -----------------------------
C - Number of events to generate.
      NEV=5000

C - Subprocesses: q qbar -> ~t_1 ~t_1bar and g g -> ~t_1 ~t_1bar.
      MSEL=0
      MSUB(261)=1
      MSUB(264)=1

C - CM energy
      ECM=14000D0

C - Set SuSy parameters, using SLHA input.
C...Switch on SUSY MSSM input from an SLHA file.
      IMSS(1)=11
C...Open the SLHA file and tell Pythia where (on which LUN) to find it:
      LUNSPC=22
      OPEN(LUNSPC,file='softsusy.spc',status='old')
      IMSS(21)=LUNSPC
C...If the file also contains an SLHA decay table that you want to use,
C...uncomment the next line: 
C      IMSS(22)=LUNSPC
      
C - Initialize PYTHIA
      CALL PYINIT('CMS','p','p',ECM)

C - Close the SLHA file (only used during initialization).
      CLOSE(LUNSPC)

C------------------------- GENERATE EVENTS ---------------------------
      DO 100 IEV=1,NEV
        CALL PYEVNT
C...Make a print of the event record for the first event.
        IF (IEV.EQ.1) THEN 
          CALL PYLIST(2)
        ENDIF

 100  CONTINUE

C----------------------------- FINALIZE ------------------------------
C - Print info on cross sections and errors/warnings
      CALL PYSTAT(1)

      END

      PROGRAM MAIN80
C...Example PYTHIA main program using new interface to FeynHiggs. 
C   (Requires PYTHIA version 6.321 or later)
C...Note: FeynHiggs *corrects* the Higgs sector with higher precision,
C         but needs to *start* from an already defined SUSY spectrum. Below
C         is shown how to do this either in the case of using an SLHA
C         spectrum, or by using the PYTHIA-ISAJET interface for RGE
C         running.

C...Example process: Higgs strahlung at ILC (500GeV).

C...To compile and link from a fresh PYTHIA 6.3 source, with the 
C   FeynHiggs routines in the library libFH.a: 
C   1) In the PYTHIA source, first remove the dummy routines: 
C       FHSETFLAGS
C       FHSETPARA
C       FHHIGGSCORR
C      (These are only included to make sure PYTHIA can still compile 
C       also when not linked to FeynHiggs)
C      Compile the modified source -> PYTHIA library.
C   2) Compile this example program, linking to the PYTHIA and 
C      FeynHiggs libraries
C...(To compile with an already existing PYTHIA library, step 1 is
C    normally not needed, since the dummy routines are normally not
C    included in the pre-compiled libraries. If, by mistake, the 
C    dummy routines are not removed, you will get an error message).

C...There are 2 ways of using the FeynHiggs Interface (IMODE below):
C IMODE = 1 : Use a SuSy Les Houches Accord input spectrum to start 
C             from (requires the file softsusy.spc)
C       = 2 : Use the PYSUGI ISASUSY interface to start from
C             (requires linking with ISAJET library as well)

C--------------- PREAMBLE: COMMON BLOCK DECLARATIONS ETC -------------
C...All real arithmetic done in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...The PYTHIA event record:
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Commonblocks.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...PYTHIA MSSM and subprocess common blocks
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C-------------------------- PYTHIA SETUP -----------------------------
C - Number of events to generate.
      NEV=1000

C - Subprocesses: e+e- -> h0 Z0
      MSEL=0
      MSUB(24)=1

C - CM energy
      ECM=500D0

      IMODE = 2

      IF (IMODE.EQ.1) THEN
C - Set SuSy parameters, using SLHA input.
C...Switch on SUSY MSSM input from an SLHA file.
        IMSS(1)=11
C...Open the SLHA file and tell Pythia where (on which LUN) to find it:
        LUNSPC=88
        OPEN(LUNSPC,file='softsusy.spc',status='old')
        IMSS(21)=LUNSPC
C...If the file also contains an SLHA decay table that you want to use,
C...uncomment the next line: 
C        IMSS(22)=LUNSPC

      ELSEIF (IMODE.EQ.2) THEN      
C...SUSY Model specifications. Interface ISASUSY.
        IMSS(1)=12
C...Set parameters for old interface (SPS1a)
        RMSS(1)=250D0
        RMSS(4)=1D0
        RMSS(5)=10D0
        RMSS(8)=100D0
        RMSS(16)=-100D0
      ELSE
        CALL PYERRM(9,'(Main:) IMODE not valid.')
      ENDIF

C***Tell PYTHIA to improve Higgs sector using FeynHiggs***
      IMSS(4)=3

C...Just a fast test: switch off hafdronization, ISR, and FSR
      MSTP(111)=0
      MSTP(61)=0
      MSTP(71)=0

C - Initialize PYTHIA
      CALL PYINIT('CMS','e+','e-',ECM)


C - Close the SLHA file (only used during initialization).
      IF (IMODE.EQ.1) THEN
        CLOSE(LUNSPC)
      ENDIF

C      CALL PYSTAT(2)

C------------------------- GENERATE EVENTS ---------------------------
      DO 100 IEV=1,NEV
        CALL PYEVNW
C...Make a print of the event record for the first event.
        IF (IEV.EQ.1) THEN 
          CALL PYLIST(2)
        ENDIF

 100  CONTINUE

C----------------------------- FINALIZE ------------------------------
C - Print info on cross sections and errors/warnings
      CALL PYSTAT(1)

      END

      PROGRAM MAIN81
C...Example program to illustrate how to read in LHEF files, e.g., from 
C...a matrix-element generator, into Pythia 6 for further processing 
C...(resonance decays, parton showering, underlying event, and hadronization)
C...     For LHEF, see: hep-ph/0609017
C...     For LHEF+SLHA/BSM, see also: arXiv:0712.3311

C--------------- PREAMBLE: COMMON BLOCK DECLARATIONS ETC -------------
C...All real arithmetic done in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...The PYTHIA event record:
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Pythia parameters
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...EXTERNAL statement links PYDATA on most machines.
      CHARACTER*3 chlun
      EXTERNAL PYDATA

C-------------------------- PYTHIA SETUP -----------------------------

C...1) Open LHEF file on unit LUN, and tell Pythia where to find it.
      LUN=88
      OPEN(LUN,FILE='ttbar.lhe')
      WRITE(CHLUN,'(I3)') LUN
      CALL PYGIVE('MSTP(161)='//CHLUN)
      CALL PYGIVE('MSTP(162)='//CHLUN)

C...2) Initialize Pythia for user process  
      CALL PYINIT('USER',' ',' ',0D0)
      
C------------------------- GENERATE EVENTS ---------------------------

C...Initial values for number of events and cumulative charged multiplicity
      IEV=0
      DNSUM=0D0
      DN2SUM=0D0

C...Get next event from file and process it
 100  CALL PYEVNT

C...If event generation failed, quit loop
      IF(MSTI(51).EQ.1) THEN
        GOTO 999
      ENDIF

C...Else count up number of generated events
      IEV=IEV+1

C...Print first few events, both LHEF input and Pythia output.
      IF(IEV.LE.3) THEN
        CALL PYLIST(7)
        CALL PYLIST(2)
      ENDIF

C.../PYJETS/ now contains a fully generated event.
C...Insert user analysis here (or save event to output) 
C...(example: count charged multiplicity)
      CALL PYEDIT(3)
      DNSUM=DNSUM+N
      DN2SUM=DN2SUM+N**2

C...Loop back to look for next event
      GOTO 100

C...Jump point when end-of-file reached (or other problem encountered)
C...Print final statistics.
 999  CALL PYSTAT(1)

      DNAVG=DNSUM/IEV
      DNRMS=SQRT(DN2SUM/IEV)
      SIGMA2=MAX(0D0,DNRMS**2-DNAVG**2)
      WRITE(*,'(1x,A,1x,F6.1,5x,A,1x,F6.1)') 
     &    'Average Charged Multiplicity was <Nch> =', 
     &    DNAVG, '+/-',SQRT(SIGMA2/IEV)
      PRINT*

      END

C...Run to check that all processes allowed work and to clock them.
C...PYTIME must be interfaced to local clock for this to work.
C...Replace suitably if you want CPU time rather than elapsed one.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Process names.
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C...Local arrays.
      DIMENSION INEP(10),INEE(20),INGAP(10),INGAGA(10),INGAST(10),
     &INEESS(10),INGSTP(10),MSTP14(20),ITIME(6),ITUSED(500),SIGTOT(500)
C...Processes needing other collider types than pp.
      DATA INEP/145,9*0/
      DATA INEE/70,103,146,153,158,343,344,345,346,347,348,9*0/
      DATA INGAP/33,34,35,36,54,80,84,107,2*0/
      DATA INGAGA/58,69,85,108,6*0/
      DATA INGAST/99,137,138,139,140,5*0/
      DATA INEESS/341,342,8*0/
      DATA INGSTP/131,132,133,134,135,136,4*0/
C...Processes needing MSTP(14)=0.
      DATA MSTP14/33,34,35,36,54,58,69,70,80,84,85,103,107,108,153,
     &158,4*0/

C...Default values time consumption.
      DATA ITUSED/500*-1/ 

C-----------------------------------------------------------------

C...First section: common parameters.

C...Number of events per case.
      NEV=100

C...Minimize printout.
      MSTP(122)=0

C...Do not crash if vanishing cross section.
      MSTP(127)=1

C...Set SUSY parameters in SUGRA scenario.
      IMSS(1)=2
      RMSS(1)=200D0
      RMSS(4)=1D0
      RMSS(5)=10D0
      RMSS(8)=800D0
      RMSS(16)=0D0

C-----------------------------------------------------------------

C...Second section: process and event loops.
      CALL PYLIST(0)
 
C...Loop over processes; check which to skip. 
      DO 300 ISUB=1,500
      IF(ISET(ISUB).LT.0.OR.ISET(ISUB).EQ.9) GOTO 300
      WRITE(6,*) 'Now begin process ',ISUB   

C...Switch on desired subprocess and off the rest.
      MSEL=0
      DO 110 J=1,500
 110  MSUB(J)=0
      MSUB(ISUB)=1    

C...Decide on collider type; default is pp.
      ITYPE=1
      DO 120 J=1,10
        IF(ISUB.EQ.INEP(J)) ITYPE=2
        IF(ISUB.EQ.INEE(J)) ITYPE=3
        IF(ISUB.EQ.INEE(J+10)) ITYPE=3
        IF(ISUB.EQ.INGAP(J)) ITYPE=4
        IF(ISUB.EQ.INGAGA(J)) ITYPE=5
        IF(ISUB.EQ.INGAST(J)) ITYPE=6
        IF(ISUB.EQ.INEESS(J)) ITYPE=7
        IF(ISUB.EQ.INGSTP(J)) ITYPE=8
  120 CONTINUE

C...Set MSTP(14)=0 rather than default for some processes..
      MSTP(14)=30
      DO 130 J=1,20
        IF(ISUB.EQ.MSTP14(J)) MSTP(14)=0
  130 CONTINUE
      IF(ISUB.EQ.99) MSTP(14)=26

C...Reset CKIN(3).
      CKIN(3)=0D0

C...Starting time.
      CALL PYTIME(ITIME)
      TOLD=3600D0*ITIME(4)+60D0*ITIME(5)+ITIME(6)
 
C...Initialize for collider type.
C...(These are just convenient choices; could be changed.)
      IF(ITYPE.EQ.1) THEN
        CALL PYINIT('CMS','p','p',14000D0)
      ELSEIF(ITYPE.EQ.2) THEN
        CALL PYINIT('CMS','e+','p',2000D0)
      ELSEIF(ITYPE.EQ.3) THEN
        CALL PYINIT('CMS','e+','e-',2000D0)
      ELSEIF(ITYPE.EQ.4) THEN
        CALL PYINIT('CMS','gamma','p',2000D0)
      ELSEIF(ITYPE.EQ.5) THEN
        CALL PYINIT('CMS','gamma','gamma',2000D0)
      ELSEIF(ITYPE.EQ.6) THEN
        CALL PYINIT('CMS','gamma/e+','gamma/e-',2000D0)
      ELSEIF(ITYPE.EQ.7) THEN
        CALL PYINIT('CMS','e-','e-',200D0)
      ELSEIF(ITYPE.EQ.8) THEN
        CALL PYINIT('CMS','gamma/e-','p',2000D0)
      ENDIF  
 
C...Generate events, unless no cross section found...
      IF(MSTI(53).NE.1) THEN      
        DO 200 IEV=1,NEV
          CALL PYEVNT
  200   CONTINUE
      ELSE
        PARI(1)=-1D0
      ENDIF

C...Finishing time.
      CALL PYTIME(ITIME)
      TNEW=3600D0*ITIME(4)+60D0*ITIME(5)+ITIME(6)

C...Save time and cross sections.
      ITUSED(ISUB)=TNEW-TOLD
      SIGTOT(ISUB)=PARI(1)
      WRITE(6,*) 'Time and cross section: ',ITUSED(ISUB),PARI(1)   

C...End loop over processes.
 300  CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Loop over processes; write time and cross section.
      DO 400 ISUB=1,500
        IF(ITUSED(ISUB).NE.-1)  WRITE(6,'(2X,I4,3X,A28,I8,1P,E12.4)')
     &  ISUB,PROC(ISUB),ITUSED(ISUB),SIGTOT(ISUB)
  400 CONTINUE   

      END

C...This file contains an almost complete listing of all PYTHIA 
C...commonblocks, and additionally some recommended other 
C...declarations. You may copy this to the top of your
C...mina program and then eliminate unnecessary parts.

C-----------------------------------------------------------------
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Particle names
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
C...Random number generator information.
      COMMON/PYDATR/MRPY(6),RRPY(100)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Internal variables.
      COMMON/PYINT1/MINT(400),VINT(400)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Parton distributions and cross sections.
      COMMON/PYINT3/XSFX(2,-40:40),ISIG(1000,3),SIGH(1000)
C...Resonance width and secondary decay treatment.
      COMMON/PYINT4/MWID(500),WIDS(500,5)
C...Generation and cross section statistics.
      COMMON/PYINT5/NGENPD,NGEN(0:500,3),XSEC(0:500,3)
C...Process names.
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
C...Total cross sections.
      COMMON/PYINT7/SIGT(0:6,0:6,0:5)
C...Photon parton distributions: total and valence only.
      COMMON/PYINT8/XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6), 
     &XPDIR(-6:6) 
      COMMON/PYINT9/VXPVMD(-6:6),VXPANL(-6:6),VXPANH(-6:6),VXPDGM(-6:6) 
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
C...Supersymmetry mixing matrices.
      COMMON/PYSSMT/ZMIX(4,4),UMIX(2,2),VMIX(2,2),SMZ(4),SMW(2),
     &SFMIX(16,4),ZMIXI(4,4),UMIXI(2,2),VMIXI(2,2)
C...R-parity-violating couplings in supersymmetry.
      COMMON/PYMSRV/RVLAM(3,3,3), RVLAMP(3,3,3), RVLAMB(3,3,3)
C...Internal parameters for R-parity-violating processes.
      COMMON/PYRVNV/AB(2,16,2),RMS(0:3),RES(6,5),IDR,IDR2,DCMASS,KFR(3)
      COMMON/PYRVPM/RM(0:3),A(2),B(2),RESM(2),RESW(2),MFLAG
      LOGICAL MFLAG
C...Parameters for Gauss integration of supersymmetric widths.
      COMMON/PYINTS/XXM(20)
      COMMON/PYG2DX/X1
C...Histogram information.
      COMMON/PYBINS/IHIST(4),INDX(1000),BIN(20000)
C...HEPEVT commonblock.
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),
     &PUP(5,MAXNUP),VTIMUP(MAXNUP),SPINUP(MAXNUP)

C...Sample main program and subroutines illustrating how to set up
C...an external process in Pythia, including cross section calculation.
C...Example: q + g -> q + gamma at the Tevatron. This process 
C...already exists in standard Pythia, som comparisons are possible
C...between the two implementations.
C...Reminder: since dummy copies of the UPINIT and UPEVNT routines 
C...are included in the Pythia standard distribution (to avoid 
C...problems with unresolved external references) it is necessary 
C...to remove (the linking of) this dummy to avoid clashes with the 
C...routines below.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...The user's own transfer of information.
      COMMON/MYCOMM/ECM,PTMIN,INIT
      SAVE/MYCOMM/

C...Counter for number of generated events of each type.
      DIMENSION NCOUNT(2)
      DATA NCOUNT/2*0/

C-----------------------------------------------------------------

C...First section: initialization.
 
C...Number of events and cm energy. 
      NEV=1000
      ECM=2000D0

C...Define a pTmin cutoff for the process.
      PTMIN=10D0

C...Switch off unnecessary aspects: initial and  final state
C...showers, multiple interactions, hadronization.
C...(Optional for faster simulation of the parton-level 
C...processes only.)
C      MSTP(61)=0
C      MSTP(71)=0
C      MSTP(81)=0
C      MSTP(111)=0 

C...Initialize.
      CALL PYINIT('USER',' ',' ',0D0)
 
C...Book histograms.
      CALL PYBOOK(1,'pT spectrum internal',100,0D0,100D0)
      CALL PYBOOK(2,'pT spectrum external',100,0D0,100D0)
      CALL PYBOOK(3,'n_ch distribution internal',100,-1D0,199D0)
      CALL PYBOOK(4,'n_ch distribution external',100,-1D0,199D0)

C-----------------------------------------------------------------

C...Second section: event loop.

C...Generate events and look at first few.
      DO 200 IEV=1,NEV
        CALL PYEVNT
        ISUB=MSTI(1)
        ICASE=1
        IF(ISUB.NE.29) ICASE=2
        NCOUNT(ICASE)=NCOUNT(ICASE)+1
        IF(NCOUNT(ICASE).LE.1) THEN
          WRITE(6,*) ' Following event is subprocess',ISUB 
          IF(ICASE.EQ.2) CALL PYLIST(7)
          CALL PYLIST(1)
        ENDIF

C...Read out generated pT distribution and charged multiplicity.
        PTGEN=PARI(17)
        CALL PYFILL(ICASE,PTGEN,1D0)
        CALL PYEDIT(3)
        CALL PYFILL(ICASE+2,DBLE(N),1D0)

C...End of loop over events.
  200 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Histograms.
      CALL PYHIST

      END
 
C*********************************************************************

      SUBROUTINE UPINIT
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)

C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
 
C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/
 
C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/

C...The user's own transfer of information.
      COMMON/MYCOMM/ECM,PTMIN,INIT
      SAVE/MYCOMM/

C...Set up incoming beams.
      IDBMUP(1)= 2212
      IDBMUP(2)= -2212
      EBMUP(1) = 0.5D0*ECM 
      EBMUP(2) = 0.5D0*ECM

C...Set up the external process.
      IDWTUP   = 1
      NPRUP    = 1
      LPRUP(1) = 1001     

C...Find some reasonable maximum for external process.
C...(This is done by a cheating call to UPEVNT with special switch.)
      INIT=1
      CALL UPEVNT
      INIT=0
      XMAXUP(1) = XWGTUP  

C...Also switch on same internal process, for comparison.
      MSUB(29)=1
      CKIN(3)=PTMIN
 
      RETURN
      END
 
C*********************************************************************

C...This routine samples the phase space, evaluates the process cross 
C...and sets the colour topology and parton shower scales. 
 
      SUBROUTINE UPEVNT
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
 
C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/

C...The user's own transfer of information.
      COMMON/MYCOMM/ECM,PTMIN,INIT
      SAVE/MYCOMM/

C...Local arrays and parameters.
      DIMENSION XPP(-25:25),XPPBAR(-25:25),TERM(20)
      DATA PI/3.141592653589793D0/
      DATA CONV/0.3894D9/

C-----------------------------------------------------------------

C...Default return value.
      XWGTUP=0D0

C...Default flag for event rejection.
      IREJ=0

C-----------------------------------------------------------------

C...The first step is to decide how the phase space should be sampled.
C...The total cross section for a 2 -> 2 process can be written
C...   sigma = Integral d(x_1) Integral d(x_2) Integral d(t-hat) 
C...           f_1(x_1,Q^2) f_2(x_2,Q^2) d(sigma-hat)/d(t-hat)
C...(see manual section 7.2), so a simple recipe would be to pick
C...x_1, x_2 and t_hat uniformly. However, the matrix element and 
C...parton distributions are peaked, so this would be inefficient.
C...In particlar, the matrix element is proportional to 1/u-hat,
C...so note that d(t-hat)= d(u-hat), and therefore rewrite as
C...   sigma = Integral d(x_1)/x_1 Integral d(x_2)/x_2 
C...           Integral d(u-hat)/u-hat  x_1 f_1(x_1,Q^2) 
C...           x_2 f_2(x_2,Q^2) u-hat d(sigma-hat)/d(t-hat).
C...(More fancy methods are used in Pythia to improve efficiency,
C...but here the principles are more important.)

C...The pTmin cut translates into cuts on x_1, x_2 and u-hat.
      X1MIN=4D0*PTMIN**2/ECM**2  
      X2MIN=X1MIN
      UHTMIN=PTMIN**2 
      UHTMAX=ECM**2      

      IF(INIT.EQ.0) THEN
C...Normally select a phase space point at random from 
C...d(x_1)/x_1 d(x_2)/x_2 d(u-hat)/u-hat.
        X1=X1MIN**PYR(0)
        X2=X2MIN**PYR(0)
        UHAT=-UHTMIN*(UHTMAX/UHTMIN)**PYR(0)

      ELSE
C...For special initialization call pick lowest point as 
C...likely to represent maximum cross section.
        X1=2D0*PTMIN/ECM
        X2=X1
        UHAT=-2D0*PTMIN**2
      ENDIF

C...Derive other kinematical quantities.
      SHAT=X1*X2*ECM**2
      THAT=-SHAT-UHAT
      PT2=THAT*UHAT/SHAT

C...By decoupling the x_1, x_2 and u-hat variables we overestimate
C...the phase space region. We therefore have to reject events 
C...outside allowed phase space by putting the cross section = 0.
C...However, to keep bookkeeping correct, one still needs to set
C...variables as if there is an event, e.g. picking the same
C...point as for the initialization call.
      IF(INIT.EQ.0.AND.PT2.LT.PTMIN**2) THEN
        IREJ=1
        X1=2D0*PTMIN/ECM
        X2=X1
        UHAT=-2D0*PTMIN**2
        SHAT=X1*X2*ECM**2
        THAT=-SHAT-UHAT
        PT2=THAT*UHAT/SHAT
      ENDIF    

C...The selection strategy for the phase space point relies on
C...a phase space volume V inside which points are sampled. The
C...expression sigma = Integral dV d(sigma)/dV =
C...                 = < d(sigma)/dV > * Integral dV
C...(with < ... > denoting (Monte Carlo sampled) mean value over V)
C...implies we need Integral dV = 
C...Integral d(x_1)/x_1 Integral d(x_2)/x_2 Integral d(u-hat)/u-hat.
      PHSPV=(-LOG(X1MIN))*(-LOG(X2MIN))*LOG(UHTMAX/UHTMIN)

C-----------------------------------------------------------------

C...The second step is to evaluate the cross section in the 
C...phase space point selected above.

C...Pick Q2 scale (which involves some arbitrariness) 
C...and evaluate alpha_em and alpha_s.
      Q2=PT2
      AEM=PYALEM(Q2)
      ALPS=PYALPS(Q2) 

C...Evaluate matrix element d(sigma-hat)/d(t-hat), except for
C...a factor e_q^2 that varies over the quark flavours.
      DSIGDT=(PI*AEM*ALPS/3D0)*(SHAT**2+UHAT**2)/(-SHAT**3*UHAT)

C...Correction factor u-hat from our choice of phase space sampling.
      DSIGDT=(-UHAT)*DSIGDT

C...Now need sum of charge-square-weighted quark*gluon distributions.
C...The relative size of these terms is also needed for the 
C...Monte Carlo selection of one specific flavour in initial state,
C...and therefore the terms are stored in an array.

C...Parton distributions (multiplied by x) of p and pbar.
      CALL PYPDFU(2212,X1,Q2,XPP)
      CALL PYPDFU(-2212,X2,Q2,XPPBAR)

C...Loop over quark flavours (up to b).
      SUM=0D0
      DO 100 IQ=1,5
C...Squared quark charge.
        EQ2=1D0/9D0
        IF(IQ.EQ.2.OR.IQ.EQ.4) EQ2=4D0/9D0
C...q from p, g from pbar.
        TERM(4*IQ-3)=EQ2*XPP(IQ)*XPPBAR(21)
C...qbar from p, g from pbar.
        TERM(4*IQ-2)=EQ2*XPP(-IQ)*XPPBAR(21)
C...g from p, q from pbar.
        TERM(4*IQ-1)=EQ2*XPP(21)*XPPBAR(IQ)
C...g from p, qbar from pbar.
        TERM(4*IQ)=EQ2*XPP(21)*XPPBAR(-IQ)
        SUM=SUM+TERM(4*IQ-3)+TERM(4*IQ-2)+TERM(4*IQ-1)+TERM(4*IQ)
  100 CONTINUE  

C...Now possible to define the SIGEV return value.
C...The CONV factor converts from GeV**(-2) to pb.
      IF(IREJ.EQ.0) XWGTUP=CONV*PHSPV*DSIGDT*SUM

C...Done when initializing for maximum cross section.
      IF(INIT.EQ.1) RETURN

C...Store scale choice etc.
      SCALUP=SQRT(Q2)
      AQEDUP=AEM
      AQCDUP=ALPS

C-----------------------------------------------------------------

C...The third step is to set up the partonic process that is selected.

C...Define number of partons - two incoming and two outgoing.
      NUP=4

C...Select one of the possible flavour terms at random.
      RANSUM=PYR(0)*SUM
      ISEL=0
  110 ISEL=ISEL+1
      RANSUM=RANSUM-TERM(ISEL)
      IF(ISEL.LT.20.AND.RANSUM.GT.0D0) GOTO 110

C...Read off quark flavour and quark side from selection.
      KFLQ=(ISEL+3)/4
      IF(ISEL-4*KFLQ.EQ.-2.OR.ISEL-4*KFLQ.EQ.0) KFLQ=-KFLQ
      ISIDE=1
      IF(ISEL-4*KFLQ.GE.-1) ISIDE=2

C...Flavour codes for entries. Note that definition of t-hat
C...means quark either is 1 and 3 or 2 and 4.
      IDUP(ISIDE)=KFLQ
      IDUP(3-ISIDE)=21
      IDUP(ISIDE+2)=KFLQ
      IDUP(5-ISIDE)=22

C...Status codes.
      ISTUP(1)=-1
      ISTUP(2)=-1
      ISTUP(3)=1
      ISTUP(4)=1

C...Mother codes.
      MOTHUP(1,1)=0
      MOTHUP(2,1)=0
      MOTHUP(1,2)=0
      MOTHUP(2,2)=0
      MOTHUP(1,3)=1
      MOTHUP(2,3)=2
      MOTHUP(1,4)=1
      MOTHUP(2,4)=2

C...Colour flow.
      IF(KFLQ.GT.0) THEN
C...Colour stretched from initial quark to gluon to final quark.
        ICOLUP(1,ISIDE)  =501
        ICOLUP(2,3-ISIDE)=501
        ICOLUP(1,3-ISIDE)=502
        ICOLUP(1,ISIDE+2)=502
        ICOLUP(2,ISIDE)  =0
        ICOLUP(2,ISIDE+2)=0
        ICOLUP(1,5-ISIDE)=0
        ICOLUP(2,5-ISIDE)=0
      ELSE
C...Ditto but with colour <--> anticolour.
        ICOLUP(2,ISIDE)  =501
        ICOLUP(1,3-ISIDE)=501
        ICOLUP(2,3-ISIDE)=502
        ICOLUP(2,ISIDE+2)=502
        ICOLUP(1,ISIDE)  =0
        ICOLUP(1,ISIDE+2)=0
        ICOLUP(1,5-ISIDE)=0
        ICOLUP(2,5-ISIDE)=0
      ENDIF  

C...Reset momenta to zero.
      DO 130 I=1,4
        DO 120 J=1,5
          PUP(J,I)=0D0
  120   CONTINUE
  130 CONTINUE

C...Masses of final state entries; initial assumed massless.
      PUP(5,3)=PYMASS(IDUP(3))
      PUP(5,4)=PYMASS(IDUP(4))

C...Four-momenta of the incoming partons simple.
      PUP(4,1)=0.5D0*X1*ECM
      PUP(3,1)=PUP(4,1)
      PUP(4,2)=0.5D0*X2*ECM
      PUP(3,2)=-PUP(4,2)

C...Energies and absolute momentum of the outgoing partons in 
C...the subsystem frame.
      RTSHAT=SQRT(X1*X2)*ECM
      PABS=0.5D0*SQRT(MAX(0D0,(RTSHAT**2-PUP(5,3)**2-
     &PUP(5,4)**2)**2-4D0*PUP(5,3)**2*PUP(5,4)**2))/RTSHAT
      PE3=0.5D0*(RTSHAT**2+PUP(5,3)**2-PUP(5,4)**2)/RTSHAT
      PE4=RTSHAT-PE3

C...Subsystem scattering angle defined neglecting quark mass.
      COSTHE=(THAT-UHAT)/SHAT
      SINTHE=SQRT(MAX(0D0,1D0-COSTHE**2))

C...Azimuthal angle at random.
      PHI=2D0*PI*PYR(0)

C...Momenta of outgoing partons in the subsystem frame.
      PUP(1,3)=PABS*SINTHE*COS(PHI)
      PUP(2,3)=PABS*SINTHE*SIN(PHI)
      PZ3=PABS*COSTHE
      PUP(1,4)=-PUP(1,3)
      PUP(2,4)=-PUP(2,3)
      PZ4=-PZ3

C...Longitudinal boost of outgoing partons to cm frame.
      BETA=(X1-X2)/(X1+X2)
      GAMMA=0.5D0*(X1+X2)/SQRT(X1*X2)
      PUP(3,3)=GAMMA*(PZ3+BETA*PE3)
      PUP(4,3)=GAMMA*(PE3+BETA*PZ3)
      PUP(3,4)=GAMMA*(PZ4+BETA*PE4)
      PUP(4,4)=GAMMA*(PE4+BETA*PZ4)

C...Done.
      RETURN
      END

C...Sample main program for technicolour production at the Tevatron.

C-----------------------------------------------------------------

C...Preamble: declarations.
 
C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C...Local arrays.
      DIMENSION NCHN(12)
      DATA NCHN/12*0/ 

C-----------------------------------------------------------------

C...First section: initialization.
 
C...Number of events and cm energy. 
      NEV=1000
      ECM=2000D0

C...Possibility to set masses freely:
C...pi_tech0
      PMAS(PYCOMP(KTECHN+111),1)=100D0
C...pi_tech+-.
      PMAS(PYCOMP(KTECHN+211),1)=100D0
C...rho_tech0
      PMAS(PYCOMP(KTECHN+113),1)=200D0
C...rho_tech+-
      PMAS(PYCOMP(KTECHN+213),1)=200D0
C...omega_tech0
      PMAS(PYCOMP(KTECHN+223),1)=200D0

C...Parameters of technicolour scenario.
C...sin(chi).
c      PARP(141)=1D0/3D0
C...F_T.
c      PARP(142)=82D0
C...Q_U (Q_D = Q_U - 1 always implied). 
c      PARP(143)=1.0D0
C...N_TC.
c      PARP(144)=4D0 
C...M_T.
c      PARP(145)=200D0   

C...Technicolour processes.
      MSEL=0
C...rho_tech0.
      MSUB(191)=1
C...rho_tech+-. 
      MSUB(192)=1
C...omega_tech.
      MSUB(193)=1
C...rho_tech/omega_tech with full interference for one flavour.
C...Supersedes processes 191 and 193 for fermion pair production;
C...to include both at the same time would be doublecounting.
c      MSUB(194)=1
C...Pick flavour of above process.
c      KFPR(194,1)=13 

C...Kinematical cuts in mass - absolutely necessary for process
C...194; optional for the others.
      CKIN(1)=150D0
c      CKIN(2)=210D0

C...Force decay to muon pair only of rho_T and omega_T.
C...(Of interest when comparing with process 194).
c      KCRHOT=PYCOMP(KTECHN+113)
c      DO 100 IDC=MDCY(KCRHOT,2),MDCY(KCRHOT,2)+MDCY(KCRHOT,3)-1
c      IF(IABS(KFDP(IDC,1)).NE.13) MDME(IDC,1)=MIN(0,MDME(IDC,1))
c 100  CONTINUE
c      KCOMET=PYCOMP(KTECHN+223)
c      DO 110 IDC=MDCY(KCOMET,2),MDCY(KCOMET,2)+MDCY(KCOMET,3)-1
c      IF(IABS(KFDP(IDC,1)).NE.13) MDME(IDC,1)=MIN(0,MDME(IDC,1))
c 110  CONTINUE

C...Switch off unnecessary aspects: initial and  final state
C...showers, multiple interactions, hadronization.
C...(Optional for faster simulation of the parton-level 
C...processes only.)
c      MSTP(61)=0
c      MSTP(71)=0
c      MSTP(81)=0
c      MSTP(111)=0 

C...Initialize.
      CALL PYINIT('CMS','p','pbar',ECM)

C...List table of resonance decay channels.
      CALL PYSTAT(2)
 
C...Book histograms.
      CALL PYBOOK(1,'mass distribution rho_tech0',100,0D0,250D0)
      CALL PYBOOK(2,'mass distribution rho_tech+-',100,0D0,250D0)
      CALL PYBOOK(3,'mass distribution omega_tech0',100,0D0,250D0)
      CALL PYBOOK(4,'mass distribution pi_tech0',100,0D0,150D0)
      CALL PYBOOK(5,'mass distribution pi_tech+-',100,0D0,150D0)
      CALL PYBOOK(6,'mass distribution Z0',100,0D0,150D0)
      CALL PYBOOK(7,'mass distribution W+-',100,0D0,150D0)
      CALL PYBOOK(8,'mass distribution (rho+omega)_tech0',
     &100,0D0,250D0)
      CALL PYBOOK(11,'cos(theta*) proc 191',50,-1D0,1D0) 
      CALL PYBOOK(12,'cos(theta*) proc 192',50,-1D0,1D0) 
      CALL PYBOOK(13,'cos(theta*) proc 193',50,-1D0,1D0) 
      CALL PYBOOK(14,'cos(theta*) proc 194',50,-1D0,1D0) 

C-----------------------------------------------------------------

C...Second section: event loop.

C...Generate events and look at first few.
      DO 200 IEV=1,NEV
        CALL PYEVNT
        IF(IEV.LE.2) CALL PYLIST(1) 
        ISUB=MSTI(1)

C...Fill masses of resonances.
        DO 120 I=7,9
          KFA=IABS(K(I,2))
          IKF=0
          IF(KFA.EQ.KTECHN+113) IKF=1
          IF(KFA.EQ.KTECHN+213) IKF=2
          IF(KFA.EQ.KTECHN+223) IKF=3
          IF(KFA.EQ.KTECHN+111) IKF=4
          IF(KFA.EQ.KTECHN+211) IKF=5
          IF(KFA.EQ.23) IKF=6
          IF(KFA.EQ.24) IKF=7
          IF(IKF.NE.0) CALL PYFILL(IKF,P(I,5),1D0)
  120   CONTINUE
        IF(ISUB.EQ.194) CALL PYFILL(8,PARI(13),1D0)

C...Fill decay angle of primary resonances in rest frame.
        CTHE=PARI(41)
        CALL PYFILL(ISUB-180,CTHE,1D0)

C...Fill relative probability of decay channels.
        KDA1=MIN(IABS(K(8,2)),IABS(K(9,2)))
        KDA2=MAX(IABS(K(8,2)),IABS(K(9,2)))
        IF(ISUB.EQ.191) THEN
          IF(KDA2.EQ.24) THEN
            NCHN(1)=NCHN(1)+1
          ELSEIF(KDA1.EQ.24) THEN
            NCHN(2)=NCHN(2)+1
          ELSEIF(KDA1.EQ.KTECHN+211) THEN
            NCHN(3)=NCHN(3)+1
          ELSE
            NCHN(4)=NCHN(4)+1
          ENDIF
        ELSEIF(ISUB.EQ.192) THEN
          IF(KDA2.EQ.24) THEN 
            NCHN(5)=NCHN(5)+1
          ELSEIF(KDA1.EQ.24) THEN
            NCHN(6)=NCHN(6)+1
          ELSEIF(KDA1.EQ.23) THEN
            NCHN(7)=NCHN(7)+1
          ELSEIF(KDA1.EQ.KTECHN+111) THEN     
            NCHN(8)=NCHN(8)+1
          ELSE
            NCHN(9)=NCHN(9)+1
          ENDIF
        ELSEIF(ISUB.EQ.193) THEN
          IF(KDA1.EQ.22) THEN
            NCHN(10)=NCHN(10)+1
          ELSE
            NCHN(11)=NCHN(11)+1
          ENDIF
        ELSE
          NCHN(12)=NCHN(12)+1 
        ENDIF         

C...End of loop over events.
  200 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table.
      CALL PYSTAT(1)

C...Print cross sections by resonance decay channel. 
      FAC=PARI(2)*1D9
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T0   -> W+ W-        =',
     &NCHN(1),' =',FAC*NCHN(1),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T0   -> W+- pi_T-+   =', 
     &NCHN(2),' =',FAC*NCHN(2),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T0   -> pi-T+ pi_T-  =',
     &NCHN(3),' =',FAC*NCHN(3),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T0   -> f fbar       =',
     &NCHN(4),' =',FAC*NCHN(4),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T+-  -> W+- Z0       =', 
     &NCHN(5),' =',FAC*NCHN(5),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T+-  -> W+- pi_T0    =', 
     &NCHN(6),' =',FAC*NCHN(6),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T+-  -> pi_T+- Z0    =',
     &NCHN(7),' =',FAC*NCHN(7),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T+-  -> pi_T+- pi_T0 =', 
     &NCHN(8),' =',FAC*NCHN(8),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # rho_T+-  -> f fbar''      =', 
     &NCHN(9),' =',FAC*NCHN(9),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # omega_T0 -> gamma pi_T0  =', 
     &NCHN(10),' =',FAC*NCHN(10),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' # omega_T0 -> f fbar       =', 
     &NCHN(11),' =',FAC*NCHN(11),' pb'
      WRITE(6,'(A,I8,A,F10.3,A)') ' anything else              =', 
     &NCHN(12),' =',FAC*NCHN(12),' pb'

C...Histograms.
      CALL PYHIST

      END

      PROGRAM MAIN75
C...P. Skands, May 2006.
C...Test program to generate ttbar events at Tevatron using PYTHIA
C...internal ttbar production subprocesses, with varoius options for
C...underlying-event framework and parton showers. 
C...VERSION COMPATIBILITY:
C...  ALL TUNES WORK WITH PYTHIA v.6402 OR LATER
C...DISCLAIMER:
C...* With the exception of Tune A, these tunes are rough first tunes,
C...  and so should not be taken too seriously. They reproduce eg  
C...  the charged multiplicity distribution in min-bias collisions at 
C...  the Tevatron, but many other distributions have not been checked.
C...* Since these rough tunes were produced comparing to Tevatron 
C...  distributions only, the energy rescaling parameter, PARP(90), is
C...  not determined. HOWEVER, note that variations in this parameter 
C...  can lead to large differences at LHC (and also at RHIC). Therefore, 
C...  each tune comes in 3 variants, with different energy scaling 
C...  behaviour. Tunes 0-7 use the slowest energy rescaling, leading 
C...  to comparatively more underlying activity at the LHC, tunes 10-17 
C...  give somewhat less underlying activity at the LHC, and tunes 20-27
C...  give the least underlying activity at the LHC. The opposite is 
C...  true for energies below the Tevatron, such as RHIC. See auxiliary 
C...  routine PYTUNE (included below) for details on the tunes.

C--------------- PREAMBLE: COMMON BLOCK DECLARATIONS ETC -------------
C...All real arithmetic done in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...The PYTHIA event record:
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Internal common block needed below to get number of multiple inter-
C...actions for histogramming. For information EXTRACTION only. No 
C...variables in these blocks should be changed by user.
      COMMON/PYINT1/MINT(400),VINT(400)
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C-------------------------- PYTHIA SETUP -----------------------------
C...See SUBROUTINE PYTUNE below for descriptions of the models.
C...Choose tune (valid tunes: 0-7, 10-17, 20-27).
      ITUNE=0
      CALL PYTUNE(ITUNE)

C - Number of events to generate.
      NEV=5000

C - Other parameters
C...* Type of events to be generated: ttbar (using PYGIVE)
C...* Specify mtop
C...* CM Energy for Tevatron Run II.
      CALL PYGIVE('MSEL=6')
      CALL PYGIVE('PMAS(6,1)=174.0')
      ECM=1960D0

C - Initialize PYTHIA.
      CALL PYINIT('CMS','p','pbar',ECM)

C - Book histograms (just for fun)
      CALL PYBOOK(1,'Number of interactions',50,-0.5D0,49.5D0)
      CALL PYBOOK(2,'Charged multiplicity',100,-1D0,399D0)

C------------------------- GENERATE EVENTS ---------------------------
      DO 1000 IEV=1,NEV
        CALL PYEVNT
C...  Make a print of the event record for the first event
        IF (IEV.EQ.1) THEN 
          CALL PYLIST(2)
        ENDIF

C...Fill histograms (just for fun)
C...Extract and fill number of scatterings (/event)
        NINT=MINT(31)
        CALL PYFILL(1,DBLE(NINT),1D0/NEV)        
C...Extract and fill total charged multiplicity (/event/allowed value)
        CALL PYEDIT(3)
        CALL PYFILL(2,DBLE(N),0.5D0/NEV)
        
 1000 CONTINUE

C----------------------------- FINALIZE ------------------------------
C - Print some info on cross sections and errors/warnings
      CALL PYSTAT(1)

C...Histograms.
      CALL PYHIST

      END



C=====================================================================
C-------------------- AUXILIARY ROUTINE PYTUNE -----------------------
C              Sets parameters for a few standard scenarios.
      SUBROUTINE PYTUNE(ITUNE) 
C Quick Dictionary:
C      BR : Beam Remnants
C      CR : Colour Reconnections
C      ISR/FSR: Initial-State Radiation / Final-State Radiation
C      MB : Minimum-bias
C      MI : Multiple Interactions
C      UE : Underlying Event
C
C Energy Scaling: all tunes have Tevatron as reference scale.
C   ITUNE = 0-9  : slow scaling -> large UE at LHC / small at RHIC.
C         = 10-19: same tunes, with medium-paced energy scaling
C         = 20-29: fast scaling -> small UE at LHC / large at RHIC.
C       
C...ITUNE = 0,10,20 : Tune S0. New UE model, pT-ordered showers. 
C...Key feature: large amount of multiple interactions
C...* Small amount of radiation.
C...* Large amount of low-pT MI
C...* Low degree of proton lumpiness (broad matter dist.)
C...* CR Type S (driven by free triplets), of medium strength.
C...* See: Pythia6402 update notes or later.
C
C...ITUNE = 1,11,21 : Tune S1. New UE model, pT-ordered showers.
C...Key feature: large amount of radiation.
C...* Large amount of low-pT perturbative ISR
C...* Large amount of FSR off ISR partons
C...* Small amount of low-pT multiple interactions
C...* Moderate degree of proton lumpiness
C...* Least aggressive CR type (S+S Type I), but with large strength
C...* See: Sandhoff & Skands: FERMILAB-CONF-05-518-T, in hep-ph/0604120.
C
C...ITUNE = 2,12,22 : Tune S2. New UE model, pT-ordered showers. 
C...Key feature: very lumpy proton + gg string cluster formation allowed
C...* Small amount of radiation
C...* Moderate amount of low-pT MI
C...* High degree of proton lumpiness (more spiky matter distribution)
C...* Most aggressive CR type (S+S Type II), but with small strength
C...* See: Sandhoff & Skands: FERMILAB-CONF-05-518-T, in hep-ph/0604120.
C 
C...ITUNE = 3,13,23 : Old CR ("Lo FSR" (re)Tune). New UE, pT-ordered showers.
C...Key feature: primitive colour reconnections.
C...* NB: <pT>(Nch) problematic in this tune.
C...* Small amount of radiation
C...* Large amount of low-pT MI
C...* Very low degree of proton lumpiness.
C...* Old primitive CR model. 
C...* See: Sjostrand & Skands, Eur.Phys.J.C39(2205)129, hep-ph/0408302.
C...
C...ITUNE = 4,14,24 : No CR Tune. New UE model, pT-ordered showers.
C...Key feature: no colour reconnections (NB: "Best fit" only).
C...* NB: <pT>(Nch) problematic in this tune.
C...* Small amount of radiation
C...* Small amount of low-pT MI
C...* Low degree of proton lumpiness
C...* Large BR composite x enhancement factor
C...* Most clever colour flow without CR ("Lambda ordering")
C
C...ITUNE = 5,15,25 : Tune A. Old UE model, Q2-ordered showers.
C...Key feature: extensively compared to CDF data (R.D. Field).
C...NB: Can also be run with Pythia 6.2 or 6.312+
C...* Large starting scale for ISR (PARP(67)=4)
C...* See: http://www.phys.ufl.edu/~rfield/cdf/
C
C...ITUNE = 6,16,26 : Tune BW. Old UE model, Q2-ordered showers.
C...Key feature: extensively compared to CDF data (R.D. Field).
C...NB: Can also be run with Pythia 6.2 or 6.312+
C...* Large value of alpha_s.
C...* See: http://www.phys.ufl.edu/~rfield/cdf/
C
C...ITUNE = 7,17,27 : Rap Tune. Intermediate model, Q2-ordered showers.
C...Key feature: new UE model with Q2-ordered showers and no interleaving.
C...* NB: <pT>(Nch) problematic in this tune.
C...* Old (primitive) CR.
C...* See: Sjostrand & Skands: JHEP 03(2004)053, hep-ph/0402078.

      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
 
C...Commonblocks.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      SAVE /PYDAT1/,/PYPARS/

      IF (MOD(ITUNE,10).EQ.0) THEN 
C...New model, smooth ISR, low FSR
        CALL PYGIVE('MSTP(81)=21')
        CALL PYGIVE('MSTP(70)=2')
        CALL PYGIVE('MSTP(72)=0')
C...pT0
        CALL PYGIVE('PARP(82)=2.1D0')     
C...Transverse density profile.
        CALL PYGIVE('MSTP(82)=5')
        CALL PYGIVE('PARP(83)=1.6D0')
C...Colour Reconnections
        CALL PYGIVE('MSTP(95)=6')
        CALL PYGIVE('PARP(78)=0.2D0')
C...Reference energy for pT0 and energy scaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        IF (ITUNE/10.EQ.0) THEN 
          CALL PYGIVE('PARP(90)=0.16D0')
        ELSEIF (ITUNE/10.EQ.1) THEN 
          CALL PYGIVE('PARP(90)=0.205D0')
        ELSE
          CALL PYGIVE('PARP(90)=0.25D0')
        ENDIF
C...Lambda_FSR scale.
        CALL PYGIVE('PARJ(81)=0.14D0')
C...FSR activity.
        CALL PYGIVE('PARP(71)=4D0') 
C...Rap order, Valence qq, qq x enhc, BR-g-BR supp
        CALL PYGIVE('MSTP(89)=1')
        CALL PYGIVE('MSTP(88)=0')
        CALL PYGIVE('PARP(79)=2D0')          
        CALL PYGIVE('PARP(80)=0.01D0')
C...Switch off trial joinings
        MSTP(96)=0

      ELSEIF(MOD(ITUNE,10).EQ.1) THEN  
C...New model: sharp ISR, high FSR
        CALL PYGIVE('MSTP(81)=21')
        CALL PYGIVE('MSTP(70)=0') 
        CALL PYGIVE('MSTP(72)=1') 
C...pT0 
        CALL PYGIVE('PARP(82)=2.5D0')
C...Colour Reconnections
        CALL PYGIVE('MSTP(95)=2')
        CALL PYGIVE('PARP(78)=0.35D0')
C...Transverse density profile.
        CALL PYGIVE('MSTP(82)=5')
        CALL PYGIVE('PARP(83)=1.4D0')
C...Reference energy for pT0 and energy rescaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        IF (ITUNE/10.EQ.0) THEN 
          CALL PYGIVE('PARP(90)=0.16D0')
        ELSEIF (ITUNE/10.EQ.1) THEN 
          CALL PYGIVE('PARP(90)=0.205D0')
        ELSE
          CALL PYGIVE('PARP(90)=0.25D0')
        ENDIF
C...Lambda_FSR scale.
        CALL PYGIVE('PARJ(81)=0.14D0')
C...FSR activity.
        CALL PYGIVE('PARP(71)=4D0') 
C...Rap order, Valence qq, qq x enhc, BR-g-BR supp
        CALL PYGIVE('MSTP(89)=1')
        CALL PYGIVE('MSTP(88)=0')
        CALL PYGIVE('PARP(79)=2D0')           
        CALL PYGIVE('PARP(80)=0.01D0')
C...Switch off trial joinings
        MSTP(96)=0

      ELSEIF(MOD(ITUNE,10).EQ.2) THEN  
C...New model, smooth ISR, low FSR
        CALL PYGIVE('MSTP(81)=21')
        CALL PYGIVE('MSTP(70)=2')
        CALL PYGIVE('MSTP(72)=0')
C...pT0
        CALL PYGIVE('PARP(82)=2.25D0') 
C...Transverse density profile.
        CALL PYGIVE('MSTP(82)=5')
        CALL PYGIVE('PARP(83)=1.25D0')
C...Colour Reconnections
        CALL PYGIVE('MSTP(95)=4')
        CALL PYGIVE('PARP(78)=0.15D0')
C...Reference energy for pT0 and energy scaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        IF (ITUNE/10.EQ.0) THEN 
          CALL PYGIVE('PARP(90)=0.16D0')
        ELSEIF (ITUNE/10.EQ.1) THEN 
          CALL PYGIVE('PARP(90)=0.205D0')
        ELSE
          CALL PYGIVE('PARP(90)=0.25D0')
        ENDIF
C...Lambda_FSR scale.
        CALL PYGIVE('PARJ(81)=0.14D0')
C...FSR activity.
        CALL PYGIVE('PARP(71)=4D0') 
C...Rap order, Valence qq, qq x enhc, BR-g-BR supp
        CALL PYGIVE('MSTP(89)=1')
        CALL PYGIVE('MSTP(88)=0')
        CALL PYGIVE('PARP(79)=2D0')          
        CALL PYGIVE('PARP(80)=0.01D0')
C...Switch off trial joinings
        MSTP(96)=0

      ELSEIF(MOD(ITUNE,10).EQ.3) THEN  
C...New model, smooth ISR, low FSR
        CALL PYGIVE('MSTP(81)=21')
        CALL PYGIVE('MSTP(70)=2')
        CALL PYGIVE('MSTP(72)=0')
C...pT0
        CALL PYGIVE('PARP(82)=2.1D0')         
C...Transverse density profile.
        CALL PYGIVE('MSTP(82)=5')
        CALL PYGIVE('PARP(83)=2.0D0')
C...Colour Reconnections
        CALL PYGIVE('MSTP(95)=1')
        CALL PYGIVE('PARP(78)=1.0D0')
C...Reference energy for pT0 and energy scaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        IF (ITUNE/10.EQ.0) THEN 
          CALL PYGIVE('PARP(90)=0.16D0')
        ELSEIF (ITUNE/10.EQ.1) THEN 
          CALL PYGIVE('PARP(90)=0.205D0')
        ELSE
          CALL PYGIVE('PARP(90)=0.25D0')
        ENDIF
C...Lambda_FSR scale.
        CALL PYGIVE('PARJ(81)=0.14D0')
C...FSR activity.
        CALL PYGIVE('PARP(71)=4D0') 
C...Rap order, Valence qq, qq x enhc, BR-g-BR supp
        CALL PYGIVE('MSTP(89)=1')
        CALL PYGIVE('MSTP(88)=0')
        CALL PYGIVE('PARP(79)=2D0')          
        CALL PYGIVE('PARP(80)=0.01D0')
C...Switch off trial joinings
        MSTP(96)=0

      ELSEIF(MOD(ITUNE,10).EQ.4) THEN  
C...New model, smooth ISR, low FSR
        CALL PYGIVE('MSTP(81)=21')
        CALL PYGIVE('MSTP(70)=2')
        CALL PYGIVE('MSTP(72)=0')
C...pT0
        CALL PYGIVE('PARP(82)=2.3D0') 
C...Transverse density profile.
        CALL PYGIVE('MSTP(82)=5')
        CALL PYGIVE('PARP(83)=1.55D0')
C...Colour Reconnections
        CALL PYGIVE('MSTP(95)=0')       
C...Reference energy for pT0 and energy scaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        IF (ITUNE/10.EQ.0) THEN 
          CALL PYGIVE('PARP(90)=0.16D0')
        ELSEIF (ITUNE/10.EQ.1) THEN 
          CALL PYGIVE('PARP(90)=0.205D0')
        ELSE
          CALL PYGIVE('PARP(90)=0.25D0')
        ENDIF
C...Lambda_FSR scale.
        CALL PYGIVE('PARJ(81)=0.14D0')
C...FSR activity.
        CALL PYGIVE('PARP(71)=4D0') 
C...Lambda order, Valence qq, large qq x enhc, BR-g-BR supp
        CALL PYGIVE('MSTP(89)=2')
        CALL PYGIVE('MSTP(88)=0')
        CALL PYGIVE('PARP(79)=3D0')
        CALL PYGIVE('PARP(80)=0.01D0')
C...Switch off trial joinings
        MSTP(96)=0

C...Tunes A and BW. (by R.D. Field, CDF)
      ELSEIF(MOD(ITUNE,10).EQ.5.OR.MOD(ITUNE,10).EQ.6) THEN
C...Multiple interactions on.
        CALL PYGIVE('MSTP(81)=1')
C...Double Gaussian matter distribution. 
        CALL PYGIVE('MSTP(82)=4')
        CALL PYGIVE('PARP(83)=0.5D0')
        CALL PYGIVE('PARP(84)=0.4D0')
C...Reference energy for pT0 and energy rescaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        IF (ITUNE/10.EQ.0) THEN 
          CALL PYGIVE('PARP(90)=0.16D0')
        ELSEIF (ITUNE/10.EQ.1) THEN 
          CALL PYGIVE('PARP(90)=0.205D0')
        ELSE
          CALL PYGIVE('PARP(90)=0.25D0')
        ENDIF
C...FSR activity. 
        CALL PYGIVE('PARP(71)=4D0')
C...Lambda_FSR scale. 
        CALL PYGIVE('PARJ(81)=0.29D0')
     
        IF(MOD(ITUNE,10).EQ.5) THEN
C...Tune A. 
C...pT0.
          CALL PYGIVE('PARP(82)=2.0D0')
c...String drawing almost completely minimizes string length.
          CALL PYGIVE('PARP(85)=0.9D0')
          CALL PYGIVE('PARP(86)=0.95D0')
C...ISR cutoff, muR scale factor, and phase space size
          CALL PYGIVE('PARP(62)=1D0')
          CALL PYGIVE('PARP(64)=1D0')
          CALL PYGIVE('PARP(67)=4D0')
C...Intrinsic kT, size, and max
          CALL PYGIVE('MSTP(91)=1')
          CALL PYGIVE('PARP(91)=1D0')
          CALL PYGIVE('PARP(93)=5D0')
        ELSE
C...Tune BW (larger alpha_s, more intrinsic kT. Smaller ISR phase space.)
C...pT0.
          CALL PYGIVE('PARP(82)=1.9D0')
c...String drawing completely minimizes string length.
          CALL PYGIVE('PARP(85)=1.0D0')
          CALL PYGIVE('PARP(86)=1.0D0')
C...ISR cutoff, muR scale factor, and phase space size
          CALL PYGIVE('PARP(62)=1.25D0')
          CALL PYGIVE('PARP(64)=0.2D0')
          CALL PYGIVE('PARP(67)=1D0')
C...Intrinsic kT, size, and max
          CALL PYGIVE('MSTP(91)=1')
          CALL PYGIVE('PARP(91)=2.1D0')
          CALL PYGIVE('PARP(93)=15D0')
        ENDIF
     

      ELSEIF(MOD(ITUNE,10).EQ.7) THEN
C...  Intermediate model. Rap tune.
        CALL PYGIVE('MSTP(81)=11')
C...  Valence qq, BR-g-BR supp
        CALL PYGIVE('MSTP(88)=0')
        CALL PYGIVE('PARP(80)=0.01D0')
C...  Default diquark
        CALL PYGIVE('PARP(79)=2D0')           
C...  Final state reconnect.
        CALL PYGIVE('MSTP(95)=1')
        CALL PYGIVE('PARP(78)=0.55D0') 
C...  Maximum Q2 scale for ISR and FSR in relation to hard Q2.
        CALL PYGIVE('PARP(67)=4.0D0')
        CALL PYGIVE('PARP(71)=4.0D0')
C...  Reference energy for pT0 and energy rescaling pace.
        CALL PYGIVE('PARP(89)=1800D0')
        CALL PYGIVE('PARP(90)=0.25D0')
C...  Lambda_FSR scale.
        CALL PYGIVE('PARJ(81)=0.29D0')
C...  Rap Tune
        CALL PYGIVE('MSTP(89)=1')
C...  ExpOfPow(1.8) overlap profile
        CALL PYGIVE('MSTP(82)=5')
        CALL PYGIVE(' PARP(83)=1.8D0')
C...pT0 
        CALL PYGIVE('PARP(82)=2.40D0')

      ELSE
        CALL PYERRM(29,'(PYTUNE:) Desired Pythia tune not recognized') 

      ENDIF   
 
      RETURN 
      END 

      PROGRAM MAIN79

C...Test program for new gcc4 compiler.
C...Top pair events are generated at the LHC, 14 TeV.
C...Final charged multiplicity is histogrammed.
C...The final total cross section should be 4.9E-07 mb,
C...the average multiplicity 243, and the rms 70.2, 
C...all within statistical fluctuations. 

C******************************************************************

C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)

C...Number of events.
      NEV=10000

C...Processes qqbar, gg -> ttbar.
      MSEL=6

C...Initialize for the LHC.
      CALL PYINIT('CMS','p','p',14000D0)

C...Histogram.
      CALL PYBOOK(1,'Final charged multiplicity',100,-1D0,599D0)
 
C...Event generation loop.
      DO 200 IEV=1,NEV
        CALL PYEVNT

C...Remove all but charged particles and histogram multiplicity.
        CALL PYEDIT(3)
        CALL PYFILL(1,DBLE(N),1D0)

C...End of event generation loop.
 200  CONTINUE

C...Cross section. Histogram.
      CALL PYSTAT(1)      
      CALL PYHIST

      END

C...Production of a single top by s-channel W exchange.
C...The process is e.g. u dbar -> W+ -> t bbar, with t -> b W+.
C...The problem here is that two W's appear in the process,
C...one as the mother of the t and the other as decay product.
C...Therefore the normal forcing of the W decay does not work;
C...it leads to an infinite recursion W -> t -> W -> t -> ....
C...The way out is to use the W', which has default couplings
C...just like the normal W, just a different mass, which then
C...can be changed to agree. The W' is forced to decay to t bbar,
C...while the W can decay freely (or also be forced, if desired).
C...Additionally, it is important to raise CKIN(1), so that the 
C...program does not get stuck in a region of phase space where
C...the cross section vanishes.  

C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)

C-----------------------------------------------------------------

C...First section: initialization.

C...Main parameters of run: c.m. energy and number of events.
      ECM=2000D0
      NEV=1000

C...Select W' production.
      MSEL=0
      MSUB(142)=1

C...Set W' mass identical to W (widths already are!).
      PMAS(34,1)=PMAS(24,1)

C...Set W'+ decay only to bbar t.
      DO 100 IDC=MDCY(34,2),MDCY(34,2)+MDCY(34,3)-1
        MDME(IDC,1)=MIN(0,MDME(IDC,1))
        IF(KFDP(IDC,1).EQ.-5.AND.KFDP(IDC,2).EQ.6) MDME(IDC,1)=1
  100 CONTINUE

C...Minimum mass cut.
      CKIN(1)=170D0

C...Initialize.
      CALL PYINIT('CMS','p','pbar',ECM)

C...List resonance initialization parameters.
      CALL PYSTAT(2)

C...Histograms.
      CALL PYBOOK(1,'W* mass distribution',100,0D0,1000D0)

C-----------------------------------------------------------------

C...Second section: event loop.
 
C...Begin event loop.
      DO 200 IEV=1,NEV
        CALL PYEVNT

C...List first few events.
        IF(IEV.LE.2) CALL PYLIST(1)

C...Fill mass.
        CALL PYFILL(1,P(7,5),1D0)

C...End event loop.
  200 CONTINUE

C-----------------------------------------------------------------

C...Third section: produce output and end.

C...Cross section table and histograms.
      CALL PYSTAT(1)
      CALL PYHIST

      END

C...Program to turn gluinos into gluino-hadrons, assuming
C...the gluino is the (pseudo)stable LSP. Also possibility 
C...to let this gluino-hadron decay later on. Can be used
C...e.g. in split SUSY scenarios, where the gluino-hadron
C...might decay inside the detector.

C******************************************************************

C...All real arithmetic in double precision.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, technicolor, excited fermions,
C...extra dimensions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KTECHN=3000000,
     &KEXCIT=4000000,KDIMEN=5000000)

C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Commonblocks.
C...The event record.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
C...Parameters.
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
C...Particle properties + some flavour parameters.
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Decay information.
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
C...Selection of hard scattering subprocesses.
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
C...Parameters. 
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
C...Process information.
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
C...Process names.
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
C...Supersymmetry parameters.
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
C...Local arrays.
      DIMENSION EPQSUM(6)

C...Number of events, CM energy.
      NEV=10000
      ECM=14000D0

C...Pick gluino mass.
      KFGL=KSUSY1+21
      PMGL=200D0

C...Pick processes: here gluino pair production.
      MSEL=0
      MSUB(243)=1
      MSUB(244)=1

C...Set necessary SUSY parameters (brute force).
      IMSS(1)=1
C...Gluino mass - of "constituent" mass kind.
      IMSS(3)=1
      RMSS(3)=PMGL
C...Pick other ino masses somewhat smaller.
      RMSS(1)=0.5D0*PMGL
      RMSS(2)=0.5D0*PMGL
      RMSS(4)=1D4
C...Stop_1 mass.
      IMSS(5)=1
      RMSS(12)=2D0*PMGL

C...Initialize.
      CALL PYINIT('CMS','p','p',ECM)
  
C...Show particle data.
C      CALL PYSTAT(2)
C      CALL PYLIST(12)

C...Switch off hadronization in normal PYEVNT call. Do not change!
      MSTP(111)=0 

C...Put gluino stable. Do not change!
      MDCY(PYCOMP(KFGL),1)=0

C...Histograms.
      CALL PYBOOK(1,'E-P-Q conservation check',100,0D0,0.01D0)
      CALL PYBOOK(3,'charged hadron multiplicity (excl. R hadrons)',
     &100,-1D0,399D0)
      CALL PYBOOK(5,'extra multiplicity from gluino decays',
     &100,-0.5D0,99.5D0)
      CALL PYBOOK(21,'gluino parton pT spectrum',100,0D0,500D0)
      CALL PYBOOK(22,'gluino hadron pT spectrum',100,0D0,500D0)
      CALL PYBOOK(23,'Gluino-hadron mass spectrum',100,PMGL,PMGL+2D0)
 
C...Event generation loop.
      DO 200 IEV=1,NEV
        if(mod(iev,100).eq.0) write(*,*) 'begin event no', iev

C...Generate event, but without worrying about small string systems.
        MSTJ(14)=-1
        CALL PYEVNT
        MSTJ(14)=1
        DO 140 J=1,6
          EPQSUM(J)=PYP(0,J)
 140    CONTINUE

C...Now perform treatment of gluino hadronization.
        CALL PYGLFR

C...If treatment failed, skip this event.
        IF(MSTU(24).NE.0) GOTO 200

C...List first few events.
c        IF(IEV.LE.2) CALL PYLIST(2)

C...Statistics: generic.
        NMERR=0
        EPQ=ABS(PYP(0,4)-EPQSUM(4))+ABS(PYP(0,1)-EPQSUM(1))+
     &  ABS(PYP(0,2)-EPQSUM(2))+ABS(PYP(0,3)-EPQSUM(3))+
     &  ABS(PYP(0,6)-EPQSUM(6))
        CALL PYFILL(1,EPQ,1D0)
        IF(EPQ.GT.1D-2) NMERR=NMERR+1
        NCH=0
        DO 160 I=1,N
          DM2=P(I,4)**2-P(I,1)**2-P(I,2)**2-P(I,3)**2-P(I,5)**2
          IF(DM2.GT.1D-4) THEN
             WRITE(*,*) 'problem particle',I,K(I,2),DM2
            IF(DM2.GT.1D-2) NMERR=NMERR+1
          ENDIF
          IF(K(I,1).EQ.1.AND.PYCHGE(K(I,2)).NE.0) NCH=NCH+1
          PT=SQRT(P(I,1)**2+P(I,2)**2) 
 
C...Statistics: gluino.
          IF(K(I,1).EQ.12.AND.K(I,2).EQ.KFGL) THEN
            CALL PYFILL(21,PT,1D0)
          ENDIF
          IF((K(I,1).EQ.6.OR.K(I,1).EQ.7).AND.K(I,2).EQ.KFGL) THEN
            CALL PYFILL(22,PT,1D0)
            CALL PYFILL(23,P(I,5),1D0)
          ENDIF
 160    CONTINUE
        CALL PYFILL(3,DBLE(NCH),1D0)
        IF(NMERR.GT.0) CALL PYLIST(2)

C...Now force gluinos to decay. Look in PYGLDC for options to make 
C...only one of them decay inside the detector.
        NSAV=N
        CALL PYGLDC

C...Charged multiplicity in gluino decays.
        NCH=0
        DO 180 I=NSAV+1,N
          IF(K(I,1).EQ.1.AND.PYCHGE(K(I,2)).NE.0) NCH=NCH+1
 180    CONTINUE
        CALL PYFILL(5,DBLE(NCH),1D0)

C...List first few events.
        IF(IEV.LE.2) CALL PYLIST(2)

C...End of event generation loop.
 200  CONTINUE

C...Cross section - not relevant in this case. Histograms.
      CALL PYSTAT(1)      
      CALL PYHIST

      END
 
C*********************************************************************
 
C...PYGLFR
C...Fragments the string near to a gluino, to form a gluino-hadron, 
C...either by producing a new g-g pair or two new q-qbar ones.
 
      SUBROUTINE PYGLFR
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/
C...Local array.
      DIMENSION PSUM(5),KFSAV(2),PMSAV(2),PSAV(2,5) 

C...Free parameter: relative probability for gluino-gluon-ball.
C...(But occasional low-mass string will never become it anyway.)
      PROBGG=0.1D0
 
C...Free parameter: gluon constituent mass.
      PMGLU=0.7D0
 
C...Free parameter: max kinetic energy in gluino-hadron.
      PMKIN=0.5D0

C...Switch off popcorn baryon production. (Not imperative, but more
C...failed events when popcorn is allowed.)
      MSTJ12=MSTJ(12)
      MSTJ(12)=1

C...Convenient shorthand.
      KFGL=KSUSY1+21

C...Loopback point for serious problems, with new try.
      LOOP=0
      CALL PYEDIT(21)
      CHGSAV=PYP(0,6)
   90 LOOP=LOOP+1
      IF(LOOP.GT.1) CALL PYEDIT(22)

C...Take copy of string system(s), leaving extra free slot after gluino.
C...(Eventually to be overwritten by one q and one qbar string break.)
      NOLD=N
      NGLUI=0
      DO 120 I=1,NOLD
        ICOPY=0
        IF(K(I,1).EQ.2) ICOPY=1
        IF(K(I,1).EQ.1.AND.I.GE.2) THEN
          IF(K(I-1,1).EQ.12) ICOPY=1
        ENDIF
        IF(ICOPY.EQ.1) THEN  
          N=N+1
          DO 100 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  100     CONTINUE
          K(I,1)=K(I,1)+10
          K(I,4)=N
          K(I,5)=N
          K(N,3)=I
          IF(K(I,2).EQ.KFGL) THEN
            NGLUI=NGLUI+1  
            N=N+1
            DO 110 J=1,5
              K(N,J)=K(N-1,J)
              P(N,J)=0D0
              V(N,J)=V(I,J)
  110       CONTINUE
            K(I,5)=N
            K(N,2)=21
          ENDIF
        ENDIF
  120 CONTINUE

C...Loop over (up to) two gluinos per event.
      DO 300 IGLUI=1,NGLUI

C...Identify position of gluino (randomize order of treatment).
        IGL=0
        NGL=0
        DO 130 I=1,N
          IF(K(I,1).EQ.2.AND.K(I,2).EQ.KFGL) THEN
            NGL=NGL+1
            IF(IGLUI.EQ.NGLUI) THEN
              IGL=I
            ELSEIF(NGL.EQ.1) THEN
              IF(PYR(0).LT.0.5D0) IGL=I
            ELSEIF(IGL.EQ.0) THEN
              IGL=I
            ENDIF
          ENDIF
  130   CONTINUE

C...Identify range of partons on string the gluino belongs to. 
        IMIN=IGL
  140   IMIN=IMIN-1
        IF(K(IMIN-1,1).EQ.2) GOTO 140
        IMAX=IGL
  150   IMAX=IMAX+1
        IF(K(IMAX,1).EQ.2) GOTO 150
 
C...Find mass of this gluino-string. 
        DO 170 J=1,5
          PSUM(J)=0D0
          DO 160 I=IMIN,IMAX
            PSUM(J)=PSUM(J)+P(I,J)
  160     CONTINUE
  170   CONTINUE
        PSUM(5)=SQRT(MAX(0D0,PSUM(4)**2-PSUM(1)**2-PSUM(2)**2-
     &  PSUM(3)**2))
 
C...If low-mass, then consider gluino-hadron already formed.
        IF(PSUM(5).LE.P(IGL,5)+P(IMIN,5)+P(IMAX,5)+PMKIN) THEN
          DO 180 I=IMIN,IMAX
            K(I,1)=15+IGLUI
  180     CONTINUE
          GOTO 300
        ENDIF    

C...Else break string by production of new gg or two new qqbar pairs.
C...(Also diquarks allowed, but not popcorn, and not two adjacent.)
        IF(PYR(0).LT.PROBGG) THEN
C...Let a gluon occupy two slots, to make administration work the same
C...way as for the qqbar case.
          KFSAV(1)=21
          KFSAV(2)=21
          PMSAV(1)=0.5D0*PMGLU  
          PMSAV(2)=0.5D0*PMGLU  
        ELSE
  185     CALL PYDCYK(K(IMIN,2),0,KFSAV(1),KFDUM)
          CALL PYDCYK(K(IMAX,2),0,KFSAV(2),KFDUM)
          IF(IABS(KFSAV(1)).GT.10.AND.IABS(KFSAV(2)).GT.10) GOTO 185
          IF(IABS(KFSAV(1)).GT.10.AND.IABS(K(IGL-1,2)).GT.10) GOTO 185
          IF(IABS(KFSAV(2)).GT.10.AND.IABS(K(IGL+2,2)).GT.10) GOTO 185
          KFSAV(1)=ISIGN(MOD(IABS(KFSAV(1)),10000),KFSAV(1))
          KFSAV(2)=ISIGN(MOD(IABS(KFSAV(2)),10000),KFSAV(2))
          MSTJ(93)=1 
          PMSAV(1)=PYMASS(KFSAV(1))         
          MSTJ(93)=1 
          PMSAV(2)=PYMASS(KFSAV(2))
        ENDIF         

C...Mass of gluino-hadron.
        PMGSAV=P(IGL,5)
        PMGB=P(IGL,5)+PMSAV(1)+PMSAV(2)

C...Pick at random order in which both sides of gluino string break.
        ISIDE=INT(1.5D0+PYR(0))
        DO 220 ISDE=1,2
          IF(ISDE.EQ.1) IS=ISIDE
          IF(ISDE.EQ.2) IS=3-ISIDE

C...Pick momentum sharing according to fragmentation function as if bottom.
          PMBSAV=PARF(105)
          PARF(105)=PMGSAV
          CALL PYZDIS(5,0,PMGB**2,ZGL)
          PARF(105)=PMBSAV 
          ZGL=MAX(0.9D0,MIN(0.9999D0,ZGL)) 
          DO 190 J=1,5
            PSAV(IS,J)=(1D0-ZGL)*P(IGL,J)
            P(IGL,J)=ZGL*P(IGL,J)
  190    CONTINUE

C...Target gluino-hadron mass for this stage of momentum reshuffling.
          PMOLD=P(IGL,5)
          IF(ISDE.EQ.1) PMNEW=PMGSAV+PMSAV(IS)
          IF(ISDE.EQ.2) PMNEW=PMGB 

C...Recoiling parton from which to shuffle momentum. System momentum.
          IF(IS.EQ.1) IREC=IGL-1
          IF(IS.EQ.2) IREC=IGL+2
  200     DO 210 J=1,4
            PSUM(J)=P(IGL,J)+P(IREC,J)
  210     CONTINUE           

C...Boost to rest frame of system, and align gluino along +z axis.
          CALL PYROBO(IGL,IGL,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,0D0,0D0,-PSUM(1)/PSUM(4),
     &    -PSUM(2)/PSUM(4),-PSUM(3)/PSUM(4))
          PHI=PYANGL(P(IGL,1),P(IGL,2))
          CALL PYROBO(IGL,IGL,0D0,-PHI,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,0D0,-PHI,0D0,0D0,0D0)
          THETA=PYANGL(P(IGL,3),P(IGL,1)) 
          CALL PYROBO(IGL,IGL,-THETA,0D0,0D0,0D0,0D0)
          CALL PYROBO(IREC,IREC,-THETA,0D0,0D0,0D0,0D0)

C...Calculate new kinematics in this frame, for desired gluino mass.
          ETOT=P(IGL,4)+P(IREC,4)
          IF(ETOT.GT.PMNEW+P(IREC,5)) THEN
            IFAIL=0
            PZNEW=0.5D0*SQRT(MAX(0D0,(ETOT**2-PMNEW**2-P(IREC,5)**2)**2-
     &      4D0*PMNEW**2*P(IREC,5)**2))/ETOT
            P(IGL,3)=PZNEW
            P(IGL,4)=SQRT(PZNEW**2+PMNEW**2)
            P(IGL,5)=PMNEW
            P(IREC,3)=-PZNEW
            P(IREC,4)=SQRT(PZNEW**2+P(IREC,5)**2)

C...If not enough momentum, take what can be taken.
          ELSE
            IFAIL=1
            PMOLD=ETOT-P(IREC,5)
            P(IGL,3)=0D0
            P(IGL,4)=PMOLD
            P(IGL,5)=PMOLD
            P(IREC,3)=0D0
            P(IREC,4)=P(IREC,5)
          ENDIF

C...Bost back to lab frame.
          CALL PYROBO(IGL,IGL,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))
          CALL PYROBO(IREC,IREC,THETA,PHI,PSUM(1)/PSUM(4),
     &    PSUM(2)/PSUM(4),PSUM(3)/PSUM(4))

C...Loop back when not enough momentum could be shuffled.
C...(As long as there is something left on either side.)
          IF(IFAIL.EQ.1) THEN
  215       IF(IS.EQ.1.AND.IREC.GT.IMIN) THEN
              IREC=IREC-1
              GOTO 200
            ELSEIF(IS.EQ.2.AND.IREC.LT.IMAX) THEN
              IREC=IREC+1
              GOTO 200
            ELSEIF(ISDE.EQ.2.AND.IS.EQ.3-ISIDE) THEN
              IS=ISIDE
              IREC=IRECSV
              GOTO 215
            ENDIF
          ENDIF

C...End loop over fragmentation of two sides around gluino.
         IRECSV=IREC
  220   CONTINUE

C...New slots at end of record for gluino + new quarks/gluons.
        DO 230 J=1,5
          K(N+1,J)=0
          P(N+1,J)=P(IGL,J)
          V(N+1,J)=V(IGL,J)
          K(N+2,J)=0
          P(N+2,J)=0D0
          V(N+2,J)=V(IGL,J)
          K(N+3,J)=0
          P(N+3,J)=0D0
          V(N+3,J)=V(IGL,J)
  230   CONTINUE
 
C...Status and code of these slots.
        K(N+1,1)=15+IGLUI
        K(N+2,1)=15+IGLUI
        K(N+3,1)=15+IGLUI
        K(N+1,2)=K(IGL,2)
        IF(KFSAV(1).EQ.21) THEN
          K(N+2,2)=KFSAV(1)
          K(N+3,2)=KFSAV(2)
        ELSE
          K(N+2,2)=-KFSAV(1)
          K(N+3,2)=-KFSAV(2)
        ENDIF
        K(N+1,3)=K(IGL,3)
        K(N+2,3)=K(IGL,3)
        K(N+3,3)=K(IGL,3)
        N=N+3
        
C...Code and momentum of two new string endpoints.
        K(IGL,2)=KFSAV(1)
        K(IGL+1,2)=KFSAV(2)
        IF(KFSAV(1).NE.21) K(IGL,1)=1
        DO 240 J=1,5
          P(IGL,J)=PSAV(1,J)
          P(IGL+1,J)=PSAV(2,J)
  240   CONTINUE
 
C...End of loop over two gluinos.
  300 CONTINUE

C...Cleanup: remove zero-energy gluons.
      NNOW=N
      N=NOLD
      DO 330 I=NOLD+1,NNOW
        IF(K(I,2).EQ.21.AND.P(I,4).LT.1D-10) THEN
        ELSEIF(I.EQ.N+1) THEN
          N=N+1
        ELSE
          N=N+1
          DO 320 J=1,5
            K(N,J)=K(I,J)
            P(N,J)=P(I,J)
            V(N,J)=V(I,J)
  320     CONTINUE
        ENDIF
  330 CONTINUE

C...Finish off with standard hadronization.
      CALL PYEXEC

C...Restore code of gluino-hadrons to non-fragmented numbers.
C...(Status code K(I,1) = 6 and 7 can now be used to identify 
C...constituents of the two gluino-hadrons.)
C...Check that exactly two extrapartons accompanying each gluino.
      N6=0
      N7=0
      DO 340 I=1,N
        IF(K(I,1).EQ.16.OR.K(I,1).EQ.17) K(I,1)=K(I,1)-10
        IF(K(I,1).EQ.6) N6=N6+1
        IF(K(I,1).EQ.7) N7=N7+1
  340 CONTINUE
      IF(N6.NE.3.OR.N7.NE.3) MSTU(24)=1

C...Extracheck charge.
      CHGNEW=PYP(0,6)
      IF(ABS(CHGNEW-CHGSAV).GT.0.1D0) MSTU(24)=1

C...In case of trouble, make up to five attempts.
      IF(MSTU(24).NE.0.AND.LOOP.LT.5) THEN
        MSTU(23)=MSTU(23)-1
        GOTO 90
      ELSEIF(MSTU(24).NE.0) THEN
        WRITE(*,*) 'Failed after repeated attempts!'
      ELSEIF(MSTU(24).EQ.0.AND.LOOP.GT.1) THEN
      ENDIF

C...Finished. Restore baryon production model.
      MSTJ(12)=MSTJ12
      
      RETURN
      END
 
C*********************************************************************
 
C...PYGLDC
C...Decays the gluino inside a gluino-hadron.
C...Optionally you may pick to let only one or none decay, see below.
 
      SUBROUTINE PYGLDC

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...Parameter statement to help give large particle numbers
C...(left- and righthanded SUSY, excited fermions).
      PARAMETER (KSUSY1=1000000,KSUSY2=2000000,KEXCIT=4000000)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
C...Note that dimensions below grew from 4000 to 8000 in Pythia 6.2!
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,/PYINT1/,
     &/PYINT2/

C...Set light quark mass, which defines kinematics.
      PMLQ = 0.5D0

C...Loop through to find gluinos in systems (at most two).
      KFGL=KSUSY1+21
      IGL1=0
      IGL2=0
      DO 100 I=1,N
        IF(K(I,1).EQ.6.AND.K(I,2).EQ.KFGL) IGL1=I
        IF(K(I,1).EQ.7.AND.K(I,2).EQ.KFGL) IGL2=I
 100  CONTINUE  

C...The two gluino(-hadrons) are now stored in lines IGL1 AND IGL2
C...(with either zero if only one exists). You may here use the
C...momentum information to decide whether either or both should
C...decay inside the detector, and set that information.
C...Default behaviour is that both decay, =1, if not set =0.
C...This would also be an excellent place if you want to store
C...information on a displaced event vertex in the V array.
      MGL1DC=1
      MGL2DC=1

C...Loop over the two gluino-hadrons. Skip for intended stable.
      DO 150 IGL=1,2
        IF(IGL.EQ.1.AND.MGL1DC.LE.0) GOTO 150
        IF(IGL.EQ.2.AND.MGL2DC.LE.0) GOTO 150
        I=IGL1
        IF(IGL.EQ.2) I=IGL2

C...Check that system is of expected kind, else warn.
        IF(K(I+1,1).NE.K(I,1).OR.K(I+2,1).NE.K(I,1)) THEN
          WRITE(*,*) 'PROBLEM WITH GLUINO IN LINE =',I
          CALL PYLIST(1)
        ENDIF

C...Share gluino"hadron" momentum with two light quarks.
        FAC=PMLQ/P(I,5)
        DO 120 J=1,5
          P(I+1,J)=FAC*P(I,J)
          P(I+2,J)=FAC*P(I,J)
          P(I,J)=(1D0-2D0*FAC)*P(I,J)
 120    CONTINUE

C...Set up colour flow.
        K(I,1)=3
        K(I+1,1)=3
        K(I+2,1)=3
        IF((K(I+1,2).GE.1.AND.K(I+1,2).LT.10).OR.K(I+1,2).LT.-10) THEN
          K(I,4)=MSTU(5)*(I+2)
          K(I,5)=MSTU(5)*(I+1)
          K(I+1,4)=MSTU(5)*I
          K(I+2,5)=MSTU(5)*I
        ELSE
          K(I,5)=MSTU(5)*(I+2)
          K(I,4)=MSTU(5)*(I+1)
          K(I+1,5)=MSTU(5)*I
          K(I+2,4)=MSTU(5)*I
        ENDIF

C..Put gluino unstable.
        MDCY(PYCOMP(KFGL),1)=1

C...Let gluino decay now.
        CALL PYRESD(I)

C...Put gluino stable.
        MDCY(PYCOMP(KFGL),1)=0

 150  CONTINUE

C...Temporarily put undecayed gluinos as decayed, 
C...to avoid PYEXEC from trying (and failing) to decay them.
      IF(MGL1DC.LE.0) THEN 
        K(IGL1,1)=K(IGL1,1)+10
        K(IGL1+1,1)=K(IGL1+1,1)+10
        K(IGL1+2,1)=K(IGL1+2,1)+10
      ENDIF
      IF(MGL2DC.LE.0) THEN 
        K(IGL2,1)=K(IGL2,1)+10
        K(IGL2+1,1)=K(IGL2+1,1)+10
        K(IGL2+2,1)=K(IGL2+2,1)+10
      ENDIF

C...Let the gluino decay products fragment, etc.
      CALL PYEXEC

C...Undo temporary change of status code above.
      IF(MGL1DC.LE.0) THEN 
        K(IGL1,1)=K(IGL1,1)-10
        K(IGL1+1,1)=K(IGL1+1,1)-10
        K(IGL1+2,1)=K(IGL1+2,1)-10
      ENDIF
      IF(MGL2DC.LE.0) THEN 
        K(IGL2,1)=K(IGL2,1)-10
        K(IGL2+1,1)=K(IGL2+1,1)-10
        K(IGL2+2,1)=K(IGL2+2,1)-10
      ENDIF

      RETURN
      END
